2013-10-12  Anders Carlsson  <andersca@apple.com>

        Change callOnMainThread to take an std::function
        https://bugs.webkit.org/show_bug.cgi?id=122698

        Reviewed by Darin Adler.

        This will let us pass anything that can be converted to an std::function (including lambdas and
        WTF::Function objects) to callOnMainThread.

        * wtf/MainThread.cpp:
        (WTF::callOnMainThread):
        * wtf/MainThread.h:

2013-09-06  Jessica Pease  <jessica_n_pease@apple.com>

        Replace bounds checking ASSERTs with ASSERT_WITH_SECURITY_IMPLICATION
        https://bugs.webkit.org/show_bug.cgi?id=120893

        Reviewed by Darin Adler.

        * wtf/BumpPointerAllocator.h:
        (WTF::BumpPointerPool::ensureCapacity):
        (WTF::BumpPointerPool::alloc):
        (WTF::BumpPointerPool::ensureCapacityCrossPool):
        * wtf/FastMalloc.cpp:
        (WTF::TCMalloc_ThreadCache::CreateCacheIfNecessary):
        * wtf/StringPrintStream.cpp:
        (WTF::StringPrintStream::increaseSize):
        * wtf/dtoa/utils.h:
        (WTF::double_conversion::BufferReference::SubBufferReference):
        * wtf/text/WTFString.cpp:
        (WTF::String::fromUTF8):

2013-10-11  Darin Adler  <darin@apple.com>

        Change most call sites to call ICU directly instead of through WTF::Unicode
        https://bugs.webkit.org/show_bug.cgi?id=122635

        Reviewed by Alexey Proskuryakov.

        * wtf/text/StringHash.h:
        (WTF::CaseFoldingHash::foldCase): Use u_foldCase instead of WTF::Unicode::foldCase.
        (WTF::CaseFoldingHash::hash): Added an overload for a StringImpl& because why not.

        * wtf/text/StringImpl.cpp:
        (WTF::StringImpl::lower): Use u_tolower rather than WTF::Unicode::toLower. Also added
        an assertion to check that the lowercase version is also part of Latin-1. If this
        is not guaranteed it would be good to know in a debug build at least. Use u_strToLower
        rather than WTF::Unicode::toLower. Also removed #if USE(ICU_UNICODE) around the
        locale-specific version.
        (WTF::StringImpl::upper): Use u_toupper and u_strToUpper, as above.
        (WTF::StringImpl::foldCase): Use u_tolower and u_strFoldCase, as above.
        (WTF::equalIgnoringCase): Use u_foldCase instead of WTF::Unicode::foldCase.
        (WTF::StringImpl::defaultWritingDirection): Use u_charDirection and UCharDirection
        instead of WTF::Unicode::direction and WTF::Unicode::Direction.

        * wtf/text/StringImpl.h:
        (WTF::equalIgnoringCase): Use u_memcasecmp instead of WTF::Unicode::umemcasecmp.
        (WTF::isSpaceOrNewline): Use u_charDirection instead of WTF::Unicode::direction.

        * wtf/text/WTFString.h:
        (WTF::String::defaultWritingDirection): Use UCharDirection instead of WTF::Unicode::Direction.

        * wtf/unicode/icu/UnicodeIcu.h: Removed almost everything.

        * wtf/unicode/wchar/UnicodeWchar.cpp: Tried to do the right thing in this file, but
        I did not actually compile it. Also, the implementations here aren't really sufficient
        to make WebKit work broadly. There are many things that just aren't working with this
        implementation, such as parsing that uses u_charType to figure out which characters are valid.
        (unorm_normalize): Added.
        (u_charDirection): Added.
        (u_charMirror): Added.
        (u_charType): Added.
        (u_getCombiningClass): Added.
        (u_getIntPropertyValue): Added.
        (u_memcasecmp): Added.
        (convertWithFunction): Changed to work with ICU-style status code instead of error bool.
        (u_strFoldCase): Added.
        (u_strToLower): Added.
        (u_strToUpper): Added.
        * wtf/unicode/wchar/UnicodeWchar.h: Ditto. Later this file should just be named like the
        real ICU headers so the code can include it the same way it would ICU. But that will be
        in a future patch.

2013-10-11  Anders Carlsson  <andersca@apple.com>

        Remove gesture event support from WebCore
        https://bugs.webkit.org/show_bug.cgi?id=122650

        Reviewed by Ryosuke Niwa.

        * wtf/FeatureDefines.h:
        * wtf/nix/FeatureDefinesNix.h:

2013-10-09  Filip Pizlo  <fpizlo@apple.com>

        FTL: Soft-link LLVM as a workaround for LLVM's static initializers and exit-time destructors
        https://bugs.webkit.org/show_bug.cgi?id=122566

        Reviewed by Mark Rowe.
        
        Remove all LLVM stuff from WTF since to get LLVM you need to soft-link and it's
        entirely the responsibility of JSC to do that.
        
        Also fixed an export goof that I found after fixing the weak thingy script in JSC.

        * WTF.xcodeproj/project.pbxproj:
        * wtf/LLVMHeaders.h: Removed.
        * wtf/text/CString.h:
        (WTF::CStringHash::hash):

2013-10-10  Mark Rowe  <mrowe@apple.com>

        <rdar://problem/13341666> WebKit should always build against an SDK.

        Have all projects default to building against the OS X Internal SDK for the Production
        configuration. For the Debug and Release configurations, look for UseInternalSDK.xcconfig
        to determine whether the OS X Internal SDK should be used. If not, use the normal OS X SDK.

        Reviewed by Dan Bernstein.

        * Configurations/Base.xcconfig:
        * Configurations/DebugRelease.xcconfig:

2013-10-10  Hans Muller  <hmuller@adobe.com>

        [CSS Shapes] clampToUnsigned() should return unsigned, not int
        https://bugs.webkit.org/show_bug.cgi?id=122601

        Corrected the return type for clampToUnsigned() in MathExtras.h. It's now unsigned.

        Reviewed by Andreas Kling.

        * wtf/MathExtras.h:
        (clampToUnsigned):

2013-10-08  Filip Pizlo  <fpizlo@apple.com>

        FTL should be able to do simple OSR exits using llvm.webkit.stackmap
        https://bugs.webkit.org/show_bug.cgi?id=122538

        Reviewed by Oliver Hunt.

        * wtf/PrintStream.cpp:
        (WTF::printInternal):
        * wtf/PrintStream.h:
        * wtf/RefCountedArray.h:
        (WTF::RefCountedArray::byteSize):

2013-10-09  Michael Saboff  <msaboff@apple.com>

        Change to std::unique_ptr breaks wtf/DataLog.cpp when DATA_LOG_TO_FILE set to 1
        https://bugs.webkit.org/show_bug.cgi?id=122557

        Reviewed by Filip Pizlo.

        Changed the leakPtr() to release().

        * wtf/DataLog.cpp:
        (WTF::initializeLogFileOnce):

2013-10-08  Tim Horton  <timothy_horton@apple.com>

        Turn threaded scrolling on for all Mac ports.
        Rubber-stamped by Simon Fraser and Sam Weinig.

        * wtf/FeatureDefines.h:

2013-10-06  Darin Adler  <darin@apple.com>

        Improve HashMap::add comment and other similar comments
        https://bugs.webkit.org/show_bug.cgi?id=122432

        Reviewed by Andreas Kling.

        * wtf/HashCountedSet.h:
        * wtf/HashMap.h:
        * wtf/HashSet.h:
        Updated comment wording. They were a bit old and out of date.
        They also featured the word "interator".

2013-10-07  Darin Adler  <darin@apple.com>

        Make Vector::insert work for move-only types
        https://bugs.webkit.org/show_bug.cgi?id=122429

        Reviewed by Anders Carlsson.

        * wtf/Vector.h:
        (WTF::Vector::insert): Take an rvalue reference instead of a const reference.
        (WTF::Vector::insertVector): Renamed to avoid overloading troubles, analogous
        to what we did for appendVector.

2013-10-07  Anders Carlsson  <andersca@apple.com>

        Fix Windows build.

        * wtf/StdLibExtras.h:
        (std::make_unique):

2013-10-07  Roger Fong  <roger_fong@apple.com>

        Modify WTF makefile for x64 build.
        https://bugs.webkit.org/show_bug.cgi?id=122467.
        <rdar://problem/15169174>.

        Reviewed by Brent Fulgham.

        * WTF.vcxproj/WTF.make:

2013-10-07  Anders Carlsson  <andersca@apple.com>

        Remove passIn and passOut from HashTraits
        https://bugs.webkit.org/show_bug.cgi?id=122452

        Reviewed by Sam Weinig.

        Change RefPtrHashMap to not use passOut (just like the regular HashMap) and get rid of the
        passIn and passOut functions and related typedefs.

        * wtf/HashTraits.h:
        * wtf/RefPtrHashMap.h:

2013-10-06  Anders Carlsson  <andersca@apple.com>

        Add OVERRIDE and virtual where appropriate
        https://bugs.webkit.org/show_bug.cgi?id=122439

        Reviewed by Antti Koivisto.

        * wtf/Compiler.h:
        * wtf/FilePrintStream.h:
        * wtf/StringPrintStream.h:

2013-10-06  Andreas Kling  <akling@apple.com>

        Range constructors should take a Document&.
        <https://webkit.org/b/122435>

        Reviewed by Sam Weinig.

        Give Ref an assignment operator.

2013-10-05  Anders Carlsson  <andersca@apple.com>

        Clean up MessageQueue.h
        https://bugs.webkit.org/show_bug.cgi?id=122392

        Reviewed by Andreas Kling.

        Make MessageQueue use std::unique_ptr and change findIf and removeIf to take const references.

        * wtf/Deque.h:
        Change findIf to take an rvalue reference.

        * wtf/MessageQueue.h:
        (WTF::::append):
        (WTF::::appendAndKill):
        (WTF::::appendAndCheckEmpty):
        (WTF::::prepend):
        (WTF::::removeIf):

2013-10-05  Anders Carlsson  <andersca@apple.com>

        Try to #define final to sealed when building with MSVC
        https://bugs.webkit.org/show_bug.cgi?id=122386

        Reviewed by Darin Adler.

        * wtf/Compiler.h:

2013-10-05  Anders Carlsson  <andersca@apple.com>

        Remove createOwned
        https://bugs.webkit.org/show_bug.cgi?id=122388

        Reviewed by Darin Adler.

        Since we're going with std::unique_ptr instead of OwnPtr, there's no need for makeOwned to exist.
        Get rid of it and replace it with calls to std::make_unique.

        * wtf/FilePrintStream.cpp:
        (WTF::FilePrintStream::open):
        * wtf/FilePrintStream.h:
        * wtf/HashTable.h:
        (WTF::::HashTable):
        * wtf/ListHashSet.h:
        (WTF::::ListHashSet):
        * wtf/OwnPtr.h:
        * wtf/Threading.cpp:
        (WTF::compatEntryPoint):
        (WTF::createThread):
        * wtf/ThreadingPthreads.cpp:
        (WTF::wtfThreadEntryPoint):
        (WTF::createThreadInternal):
        * wtf/unicode/Collator.h:
        * wtf/unicode/CollatorDefault.cpp:
        (WTF::Collator::userDefault):
        * wtf/unicode/icu/CollatorICU.cpp:
        (WTF::Collator::userDefault):

2013-10-05  Darin Adler  <darin@apple.com>

        Remove COMPILER_SUPPORTS(CXX_RVALUE_REFERENCES) since it's required now
        https://bugs.webkit.org/show_bug.cgi?id=122387

        Reviewed by Anders Carlsson.

        * wtf/RefPtr.h:
        * wtf/RetainPtr.h:
        * wtf/Vector.h:
        * wtf/text/AtomicString.h:
        * wtf/text/WTFString.h:
        Take out conditionals.

2013-10-05  Darin Adler  <darin@apple.com>

        Add AtomicString::number and use it
        https://bugs.webkit.org/show_bug.cgi?id=122384

        Reviewed by Anders Carlsson.

        * wtf/text/AtomicString.cpp:
        (WTF::AtomicString::number): Added.
        * wtf/text/AtomicString.h: Ditto.

        * wtf/text/IntegerToStringConversion.h: Simplify includes, renamed ConversionTrait to
        IntegerToStringConversionTrait. Changed String version to use String since we no longer
        need to use PassRefPtr to efficiently handle return values. Replaced UnsignedIntegerTrait
        with std::make_unsigned. Added AtomicString support. Use nullptr instead of 0.

2013-10-05  Darin Adler  <darin@apple.com>

        Cut down on use of String::number
        https://bugs.webkit.org/show_bug.cgi?id=122382

        Reviewed by Anders Carlsson.

        * wtf/DateMath.cpp:
        (WTF::appendTwoDigitNumber): Added. Replaces twoDigitStringFromNumber, which returned a
        String and also allocated a temporary string for any number 10 or higher.
        (WTF::makeRFC2822DateString): Updated to use the new function.

2013-10-05  Anders Carlsson  <andersca@apple.com>

        Test the waters and begin using lambdas
        https://bugs.webkit.org/show_bug.cgi?id=121809

        Reviewed by Andreas Kling.

        * wtf/ListDump.h:
        (WTF::sortedListDump):
        Use std::less instead of a custom lessThan function.

2013-10-04  Darin Adler  <darin@apple.com>

        text-transform: lowercase is not lang-dependent (Turkish languages : tr,az)
        https://bugs.webkit.org/show_bug.cgi?id=21312

        Reviewed by Ryosuke Niwa.

        * wtf/text/StringImpl.cpp:
        (WTF::StringImpl::upper): Removed an extra call that would unnecessarily reallocate
        a StringImpl in the general non-ASCII case. Added an overload that takes a locale identifier.
        (WTF::StringImpl::lower): Ditto.
        * wtf/text/StringImpl.h: Ditto.
        * wtf/text/WTFString.cpp:
        (WTF::String::lower): Ditto.
        (WTF::String::upper): Ditto.
        * wtf/text/WTFString.h: Ditto. Also deleted the makeLower and makeUpper functions since they
        offer no advantages over the lower and upper functions. Also added a constructor that takes
        a RefPtr<StringImpl> with move construction to help.

2013-10-04  Brent Fulgham  <bfulgham@apple.com>

        Remove Qt definitions from Platform.h
        https://bugs.webkit.org/show_bug.cgi?id=122349

        Reviewed by Anders Carlsson.

        * wtf/Platform.h: Remove unused PLATFORM(QT) stanzas from file.

2013-10-04  Brent Fulgham  <bfulgham@apple.com>

        [Win] Turn off FastMalloc on Windows
        https://bugs.webkit.org/show_bug.cgi?id=122352

        Reviewed by Darin Adler.

        * wtf/Platform.h: Enable USE_SYSTEM_MALLOC when building on
        Windows to stick to the MSVCRT allocator/deallocator.

2013-10-04  Mikhail Pozdnyakov  <mikhail.pozdnyakov@intel.com>

        Remove WTF smart pointers 'const_pointer_cast'
        https://bugs.webkit.org/show_bug.cgi?id=122325

        Reviewed by Darin Adler.

        Removed WTF smart pointers 'const_pointer_cast' functions as:
        - they were not used
        - their implementation was wrong as they tried to cast to a different pointer type

        * wtf/PassOwnPtr.h:
        * wtf/PassRefPtr.h:
        * wtf/RefPtr.h:

2013-10-04  Oliver Hunt  <oliver@apple.com>

        Support for-of syntax
        https://bugs.webkit.org/show_bug.cgi?id=122339

        Reviewed by Geoffrey Garen.

        Update assertions and add a helper function to StringImpl
        to save repeated unique or identifier calls.

        * wtf/text/StringImpl.h:
        (WTF::StringImpl::isIdentifierOrUnique):
        (WTF::StringImpl::setIsIdentifier):
        (WTF::StringImpl::setIsAtomic):

2013-10-02  Brent Fulgham  <bfulgham@apple.com>

        [Win] Update solutions and projects to support 64-bit build.
        https://bugs.webkit.org/show_bug.cgi?id=122225

        Reviewed by Anders Carlsson.

        * WTF.vcxproj/WTF.submit.sln: Add x64 architecture targets.
        * WTF.vcxproj/WTF.vcxproj: Correct path to config.h file.
        * WTF.vcxproj/WTF.vcxproj.filters: Correct path to config.h file.


2013-10-02  Nadav Rotem  <nrotem@apple.com>

        Eliminate a branch in FastBitVector setAndCheck, make it vectorizable.
        https://bugs.webkit.org/show_bug.cgi?id=122229

        Reviewed by Geoffrey Garen.

        The CPU is unlikely to predict the branch in setAndCheck. I changed the code to use conditional instructions.

        * wtf/FastBitVector.h:
        (WTF::FastBitVector::setAndCheck):

2013-10-02  Anders Carlsson  <andersca@apple.com>

        Remove Qt code from WTF
        https://bugs.webkit.org/show_bug.cgi?id=122221

        Reviewed by Antti Koivisto.

        I'm keeping the PLATFORM(QT) defines in Platform.h for now so we can assess if there are any
        Qt only features that we can remove later.

        * WTF.pri: Removed.
        * WTF.pro: Removed.
        * wtf/Assertions.cpp:
        * wtf/CurrentTime.cpp:
        * wtf/DisallowCType.h:
        * wtf/FastMalloc.cpp:
        * wtf/FeatureDefines.h:
        * wtf/qt/MainThreadQt.cpp: Removed.
        * wtf/qt/StringQt.cpp: Removed.
        * wtf/text/AtomicString.h:
        * wtf/text/StringImpl.cpp:
        (WTF::StringImpl::~StringImpl):
        * wtf/text/StringImpl.h:
        * wtf/text/WTFString.cpp:
        (WTF::String::format):
        * wtf/text/WTFString.h:

2013-09-30  Sam Weinig  <sam@webkit.org>

        Remove support for DOMFileSystem
        https://bugs.webkit.org/show_bug.cgi?id=122137

        Reviewed by Anders Carlsson.

        * wtf/FeatureDefines.h:

2013-09-30  Benjamin Poulain  <benjamin@webkit.org>

        Remove the code guarded by STYLE_SCOPED
        https://bugs.webkit.org/show_bug.cgi?id=122123

        Reviewed by Anders Carlsson.

        * wtf/FeatureDefines.h:

2013-09-28  Mark Rowe  <mrowe@apple.com>

        Take Xcode's advice and enable some extra warnings.

        Reviewed by Sam Weinig.

        * Configurations/Base.xcconfig:
        * WTF.xcodeproj/project.pbxproj:

2013-09-28  Mark Rowe  <mrowe@apple.com>

        <rdar://problem/15079224> WTF fails to build with newer versions of clang.

        Reviewed by Sam Weinig.

        * wtf/DateMath.cpp: Remove some unused constants.
        * wtf/FastMalloc.cpp: #if some constants and functions that are unused in some configurations.
        Remove a function that's unused on all platforms.
        * wtf/TCSystemAlloc.cpp: Remove some unused constants.
        (TCMalloc_SystemRelease): Remove an if whose body is never executed.
        * wtf/dtoa.cpp: #if things such that storeInc is only defined when USE_LONG_LONG is undefined.
        Remove an unused constant.

2013-09-27  Thiago de Barros Lacerda  <thiago.lacerda@openbossa.org>

        [Nix] Updating Nix trunk files
        https://bugs.webkit.org/show_bug.cgi?id=121752

        Reviewed by Benjamin Poulain.

        * wtf/nix/FeatureDefinesNix.h:

2013-09-06  Jer Noble  <jer.noble@apple.com>

        [Mac] Implement the media controls in JavaScript.
        https://bugs.webkit.org/show_bug.cgi?id=120895

        Reviewed by Dean Jackson.

        Define and turn on ENABLE_MEDIA_CONTROLS_SCRIPT.

        * wtf/FeatureDefines.h:

2013-09-27  Gustavo Noronha Silva  <gns@gnome.org>

        [GCC] Fix build with gcc < 4.8.1, which does not have is_trivially_destructible
        https://bugs.webkit.org/show_bug.cgi?id=121999

        Reviewed by Benjamin Poulain.

        * wtf/StdLibExtras.h:

2013-09-26  Anders Carlsson  <andersca@apple.com>

        "Build fix".

        We can't use std::move. Explicitly destroy the old value and then construct the new in place.

        * wtf/HashTable.h:

2013-09-26  Anders Carlsson  <andersca@apple.com>

        Use the move assignment operator when reinserting values in the hash map
        https://bugs.webkit.org/show_bug.cgi?id=122003

        Reviewed by Alexey Proskuryakov.

        Using the move assignment operator ensures that the existing values will be destroyed correctly.

        * wtf/HashTable.h:

2013-09-26  Brent Fulgham  <bfulgham@apple.com>

        [Windows] Work around missing C++11 features of MSVC by providing an implementation for
        std::is_trivially_destructible based on the existing std::has_trivial_destructor.

        Rubber-stamped by Anders Carlsson.

        * wtf/StdLibExtras.h: Add implementation for is_trivially_destructable for MSVC 2010 and prior.

2013-09-26  Anders Carlsson  <andersca@apple.com>

        Remove needsDestruction from vector and hash traits
        https://bugs.webkit.org/show_bug.cgi?id=121983

        Reviewed by Sam Weinig.

        For Vector, use std::is_trivially_destructible to determine whether to call the destructor.
        For HashTable, always call the destructor; if it is trivial then no code will be generated for it and the loops will be folded away. 

        Removing this does break the ability to store objects with non-trivial destructors in vectors and hash maps
        and have their destructors not be called when removed, but we've never used this feature in WebKit so the extra
        code complexity is not worth it.

        * wtf/HashTable.h:
        (WTF::::deallocateTable):
        * wtf/HashTraits.h:
        * wtf/Vector.h:
        (WTF::VectorTypeOperations::destruct):
        * wtf/VectorTraits.h:

2013-09-26  Anders Carlsson  <andersca@apple.com>

        Build fixes.

        Fix a paste-o.

        * wtf/StdLibExtras.h:
        (std::make_unique):

2013-09-26  Anders Carlsson  <andersca@apple.com>

        Remove the hash table mover
        https://bugs.webkit.org/show_bug.cgi?id=121980

        Reviewed by Andreas Kling.

        Use std::move instead.

        * wtf/HashTable.h:

2013-09-26  Anders Carlsson  <andersca@apple.com>

        Change a couple of HashMap value types from OwnPtr to std::unique_ptr
        https://bugs.webkit.org/show_bug.cgi?id=121973

        Reviewed by Andreas Kling.

        * wtf/RefPtrHashMap.h:
        Add a missing std::forward.

        * wtf/StdLibExtras.h:
        (std::make_unique):
        Add more overloads.

2013-09-26  Julien Brianceau  <jbriance@cisco.com>

        [Qt] Remove PassTraits.h from WTF.pro.
        https://bugs.webkit.org/show_bug.cgi?id=121946

        Reviewed by Andreas Kling.

        * WTF.pro: Remove PassTraits.h as this file disappeared in r156298.

2013-09-25  Patrick Gansterer  <paroga@webkit.org>

        Fix compilation with new MSVC compiler for Windows CE
        https://bugs.webkit.org/show_bug.cgi?id=121914

        Reviewed by Darin Adler.

        Remove code to support older Windows CE versions, since those old
        versions do not support C+11, which is required in the meantime.

        * wtf/Atomics.h:
        * wtf/Platform.h:

2013-09-25  Anders Carlsson  <andersca@apple.com>

        Move KeyValuePairTraits inside HashMap
        https://bugs.webkit.org/show_bug.cgi?id=121931

        Reviewed by Sam Weinig.

        Also rename the ValueType typedef to KeyValuePairType since it's always a key value pair.

        * wtf/HashMap.h:
        (WTF::HashMap::KeyValuePairTraits::isEmptyValue):
        (WTF::HashMap::find):
        (WTF::HashMap::contains):

2013-09-25  Anders Carlsson  <andersca@apple.com>

        Un-indent HashMap.h.

        Rubber-stamped by Andreas Kling.

        * wtf/HashMap.h:

2013-09-25  Anders Carlsson  <andersca@apple.com>

        Un-indent HashTraits.h.

        Rubber-stamped by Andreas Kling.

        * wtf/HashTraits.h:

2013-09-25  Patrick Gansterer  <paroga@webkit.org>

        Fix template deduction for CollatorDefault

        * wtf/unicode/CollatorDefault.cpp:
        (WTF::Collator::userDefault): Use nullptr instead of 0.

2013-09-24  Anders Carlsson  <andersca@apple.com>

        Remove encoder create functions
        https://bugs.webkit.org/show_bug.cgi?id=121853

        Reviewed by Sam Weinig.

        Add a variadic version of createOwned.

        * wtf/OwnPtr.h:
        (WTF::createOwned):

2013-09-24  Mark Rowe  <mrowe@apple.com>

        <rdar://problem/14971518> WebKit should build against the Xcode default toolchain when targeting OS X 10.8

        Reviewed by Dan Bernstein.

        * Configurations/Base.xcconfig:

2013-09-23  Anders Carlsson  <andersca@apple.com>

        Remove WTF_USE_SCROLLBAR_PAINTER #define
        https://bugs.webkit.org/show_bug.cgi?id=121819

        Reviewed by Sam Weinig.

        All our supported systems use the scrollbar painter now, so get rid of the #ifdef.

        * wtf/Platform.h:

2013-09-23  Commit Queue  <commit-queue@webkit.org>

        Unreviewed, rolling out r156307.
        http://trac.webkit.org/changeset/156307
        https://bugs.webkit.org/show_bug.cgi?id=121817

        Broke the build, and crashes the compiler (Requested by ap on
        #webkit).

        * wtf/ListDump.h:
        (WTF::lessThan):
        (WTF::sortedListDump):

2013-09-23  Anders Carlsson  <andersca@apple.com>

        Test the waters and begin using lambdas
        https://bugs.webkit.org/show_bug.cgi?id=121809

        Reviewed by Andreas Kling.

        * wtf/ListDump.h:
        (WTF::sortedListDump):
        Use std::less instead of a custom lessThan function.

2013-09-23  Anders Carlsson  <andersca@apple.com>

        ListHashSet::removeLast should only remove one element.
        
        * wtf/ListHashSet.h:
        (WTF::ListHashSet::removeLast):

2013-09-23  Anders Carlsson  <andersca@apple.com>

        Add hash traits for std::unique_ptr
        https://bugs.webkit.org/show_bug.cgi?id=121807

        Reviewed by Antti Koivisto.

        Also, convert the thread map over to using std::unique_ptr instead of OwnPtr.

        * wtf/HashMap.h:
        Remove unnecessary typedefs and add missing calls to std::forward.

        * wtf/HashTraits.h:
        Add hash trait for std::unique_ptr.
        
        * wtf/RefPtrHashMap.h:
        Use std::add_lvalue_reference.

        * wtf/ThreadingPthreads.cpp:
        (WTF::establishIdentifierForPthreadHandle):
        Change ThreadMap to be a hash map from ThreadIdentifier to std::unique_ptr<PthreadState>.

2013-09-23  Patrick Gansterer  <paroga@webkit.org>

        use NOMINMAX instead of #define min min
        https://bugs.webkit.org/show_bug.cgi?id=73563

        Reviewed by Brent Fulgham.

        Use NOMINMAX instead of #define min/max as a cleaner
        way of ensuring that Windows system header files don't
        define min/max as macro in the first place.

        * config.h:

2013-09-23  Anders Carlsson  <andersca@apple.com>

        Remove PassTraits.h
        https://bugs.webkit.org/show_bug.cgi?id=121805

        Reviewed by Andreas Kling.

        We no longer need PassTraits.h, get rid of it.

        * GNUmakefile.list.am:
        * WTF.vcxproj/WTF.vcxproj:
        * WTF.vcxproj/WTF.vcxproj.filters:
        * WTF.xcodeproj/project.pbxproj:
        * wtf/CMakeLists.txt:
        * wtf/PassTraits.h: Removed.

2013-09-23  Anders Carlsson  <andersca@apple.com>

        ListHashSet should work with move-only types
        https://bugs.webkit.org/show_bug.cgi?id=121802

        Reviewed by Andreas Kling.

        Add rvalue reference overloads and calls to std::forward and std::move where appropriate.

        * wtf/ListHashSet.h:
        (WTF::::removeFirst):
        Implement this in terms of takeFirst.

        (WTF::::takeFirst):
        Look up the iterator before we move out the value so we won't break the hash invariant.
        
        (WTF::::removeLast):
        Implement this in terms of takeLast.

        (WTF::::takeLast):
        Look up the iterator before we move out the value so we won't break the hash invariant.

2013-09-23  Anders Carlsson  <andersca@apple.com>

        Clean up ListHashSet
        https://bugs.webkit.org/show_bug.cgi?id=121797

        Reviewed by Antti Koivisto.

        * wtf/ListHashSet.h:

2013-09-23  Anders Carlsson  <andersca@apple.com>

        ListHashSet should use std::reverse_iterator for reverse iterators
        https://bugs.webkit.org/show_bug.cgi?id=121795

        Reviewed by Antti Koivisto.

        Get rid of the custom reverse iterators and just use std::reverse_iterator instead.

        * wtf/ListHashSet.h:

2013-09-23  Anders Carlsson  <andersca@apple.com>

        De-indent ListHashSet in preparation of more changes.

        Rubber-stamped by Sam Weinig.

        * wtf/ListHashSet.h:

2013-09-23  Patrick Gansterer  <paroga@webkit.org>

        Cleanup CMake files in WTF
        https://bugs.webkit.org/show_bug.cgi?id=121761

        Reviewed by Gyuyoung Kim.

        Sort files and unify the style.

        * wtf/CMakeLists.txt:
        * wtf/PlatformEfl.cmake:
        * wtf/PlatformGTK.cmake:

2013-09-22  Andreas Kling  <akling@apple.com>

        Give purity hints to compiler to avoid penalizing repeated calls to some functions.
        <https://webkit.org/b/121744>

        Reviewed by Darin Adler.

        Added a PURE_FUNCTION macro. This is supported on GCC and Clang for now.
        Marking a function pure means that the compiler's CSE pass is free to coalesce
        multiple calls to this function because it has no globally observable side
        effects beyond the first call.

2013-09-20  Anders Carlsson  <andersca@apple.com>

        Add an implementation of std::index_sequence from C++14
        https://bugs.webkit.org/show_bug.cgi?id=121718

        Reviewed by Ryosuke Niwa.

        This will make it easier to do things like pack expansion of tuple elements.

        * wtf/StdLibExtras.h:

2013-09-20  Allan Sandfeld Jensen  <allan.jensen@digia.com>

        Atomics.h does not build on MinGW
        https://bugs.webkit.org/show_bug.cgi?id=121663

        Reviewed by Darin Adler.

        MinGW does not have _ReadWriteBarrier() intrinsic, but does have GCC
        inline assembler, so use the GCC definitions instead of MSVC ones.

        * wtf/Atomics.h:
        (WTF::compilerFence):

2013-09-20  Patrick Gansterer  <paroga@webkit.org>

        [CMake] Use COMPILE_DEFINITIONS target property for setting BUILDING_* defines
        https://bugs.webkit.org/show_bug.cgi?id=121672

        Reviewed by Gyuyoung Kim.

        Since the scope of add_definitions() is always a whole file, we need to use
        target properties instead to set definitions only for specific targets.

        * wtf/CMakeLists.txt:

2013-09-20  Patrick Gansterer  <paroga@webkit.org>

        Remove duplicated secondsPerDay variables
        https://bugs.webkit.org/show_bug.cgi?id=121601

        Reviewed by Andreas Kling.

        Move secondsPerDay from the source into the header file
        to make it accessible by other code too.

        * wtf/DateMath.cpp:
        * wtf/DateMath.h:

2013-09-19  Joseph Pecoraro  <pecoraro@apple.com>

        ASSERTs in isMainThread after USE(WEB_THREAD) MainThread changes
        https://bugs.webkit.org/show_bug.cgi?id=121650

        Reviewed by Benjamin Poulain.

        * wtf/mac/MainThreadMac.mm:
        (WTF::initializeMainThreadPlatform):

2013-09-19  Daniel Bates  <dabates@apple.com>

        [iOS] Define mainThreadEstablishedAsPthreadMain to be true in WTF::initializeMainThreadPlatform()

        Reviewed by Joseph Pecoraro.

        This change was inadvertently left out of <http://trac.webkit.org/changeset/155926>.

        * wtf/mac/MainThreadMac.mm:
        (WTF::initializeMainThreadPlatform):

2013-09-19  Sam Weinig  <sam@webkit.org>

        Remove OwnArrayPtr
        https://bugs.webkit.org/show_bug.cgi?id=121612

        Reviewed by Anders Carlsson.

        * GNUmakefile.list.am:
        * WTF.pro:
        * WTF.vcxproj/WTF.vcxproj:
        * WTF.vcxproj/WTF.vcxproj.filters:
        * WTF.xcodeproj/project.pbxproj:
        * wtf/Assertions.cpp:
        * wtf/CMakeLists.txt:
        * wtf/DateMath.h:
        * wtf/FastBitVector.h:
        * wtf/Forward.h:
        * wtf/OwnArrayPtr.h: Removed.
        * wtf/VectorTraits.h:

2013-09-19  Daniel Bates  <dabates@apple.com>

        Substitute return type void for bool in function declaration for WTF::initializeWebThread()

        Reviewed by Joseph Pecoraro.

        Make the declaration of WTF::initializeWebThread() match the function prototype
        of its definition.

        * wtf/MainThread.h:

2013-09-19  Andreas Kling  <akling@apple.com>

        Assume allocator success in Vector unless using try* functions.
        <https://webkit.org/b/121629>

        Reviewed by Anders Carlsson.

        Turn some Vector::begin() null checking into assertions instead.

        We have try* style functions for when an allocation request is so
        large that it might actually fail. fastMalloc() will never return
        null (it will just CRASH() instead.)

2013-09-18  Brent Fulgham  <bfulgham@apple.com>

        [Windows] Unreviewed build correction.

        * WTF.vcxproj/WTFGeneratedCommon.props: Export PLATFORMARCHITECTURE macro for use in
        Makefiles and shell scripts.
        * WTF.vcxproj/build-generated-files.sh: Output header search path to identify when the build
        is confused about build architecture.

2013-09-18  Anders Carlsson  <andersca@apple.com>

        RefPtrHashMap should work with move only types
        https://bugs.webkit.org/show_bug.cgi?id=121564

        Reviewed by Andreas Kling.

        Add the same rvalue references and std::forward calls that already exist in HashMap.

        * wtf/RefPtrHashMap.h:

2013-09-18  Filip Pizlo  <fpizlo@apple.com>

        DFG should support Int52 for local variables
        https://bugs.webkit.org/show_bug.cgi?id=121064

        Reviewed by Oliver Hunt.

        * wtf/PrintStream.h:
        (WTF::ValueIgnoringContext::ValueIgnoringContext):
        (WTF::ValueIgnoringContext::dump):
        (WTF::ignoringContext):

2013-09-18  Andreas Kling  <akling@apple.com>

        Put constant CachedPower table in read-only memory.
        <https://webkit.org/b/121546>

        Reviewed by Anders Carlsson.

        * wtf/dtoa/cached-powers.cc:

2013-09-18  Commit Queue  <commit-queue@webkit.org>

        Unreviewed, rolling out r156019 and r156020.
        http://trac.webkit.org/changeset/156019
        http://trac.webkit.org/changeset/156020
        https://bugs.webkit.org/show_bug.cgi?id=121540

        Broke tests (Requested by ap on #webkit).

        * wtf/PrintStream.h:

2013-09-16  Filip Pizlo  <fpizlo@apple.com>

        DFG should support Int52 for local variables
        https://bugs.webkit.org/show_bug.cgi?id=121064

        Reviewed by Oliver Hunt.

        * wtf/PrintStream.h:
        (WTF::ValueIgnoringContext::ValueIgnoringContext):
        (WTF::ValueIgnoringContext::dump):
        (WTF::ignoringContext):

2013-09-17  Anders Carlsson  <andersca@apple.com>

        Stop explicitly using PassOwnPtr in WebCore/html
        https://bugs.webkit.org/show_bug.cgi?id=121511

        Reviewed by Andreas Kling.

        Make operator= work work for different types of OwnPtrs.

        * wtf/OwnPtr.h:

2013-09-17  Sam Weinig  <sam@webkit.org>

        Add make_unique and start using it
        https://bugs.webkit.org/show_bug.cgi?id=121523

        Reviewed by Anders Carlsson.

        * wtf/StdLibExtras.h:
        (std::make_unique):
        Add temporary implementation of std::make_unique that we can use until our standard
        libraries have support for it.

2013-09-17  Darin Adler  <darin@apple.com>

        Make SVGTransform::valueAsString use StringBuilder
        https://bugs.webkit.org/show_bug.cgi?id=121498

        Reviewed by Andreas Kling.

        * wtf/text/StringBuilder.cpp: Added appendNumber functions corresponding to all remaining
        String::number functions. If we find we don't need all of these we can delete them later,
        but I don't want to give clients a reason to prefer less-efficient API to StringBuilder.
        * wtf/text/StringBuilder.h: Ditto.

2013-09-16  Anders Carlsson  <andersca@apple.com>

        HashMap should work with move-only keys
        https://bugs.webkit.org/show_bug.cgi?id=121310

        Reviewed by Darin Adler.

        Add extra overloads for add and set where the key is an rvalue reference, but not a
        template parameter rvalue reference. This way we'll coerce the key parameter to have the expected
        type instead of the passed in type, causing map.add(StringImpl::create("Hello"), 123) work when the
        type of map is HashMap<String, unsigned>.

        Also, sprinkle && and std::forward where appropriate.

        * wtf/HashMap.h:
        * wtf/HashTable.h:

2013-09-17  Sergio Martins  <sergio.martins@kdab.com>

        Fix Windows CE build on ARM.
        https://bugs.webkit.org/show_bug.cgi?id=121490

        Reviewed by Darin Adler.

        * wtf/dtoa/utils.h:

2013-09-17  Mihnea Ovidenie  <mihnea@adobe.com>

        REGRESSION(r155910): WebKit nightly builds don't load any page
        https://bugs.webkit.org/show_bug.cgi?id=121482

        Reviewed by Andreas Kling.

        Replaced C++ style comments with C style comments.

        * wtf/Platform.h:

2013-09-16  Joseph Pecoraro  <pecoraro@apple.com>

        USE(WEB_THREAD): More explicit WebThread initialization
        https://bugs.webkit.org/show_bug.cgi?id=121454

        Reviewed by Benjamin Poulain.

        Be more explicit when initializing WebThread only data.

        * wtf/MainThread.h:
        * wtf/MainThread.cpp:
        (WTF::initializeWebThreadOnce):
        (WTF::initializeWebThread):
        Ensure one time initialization.

        * wtf/mac/MainThreadMac.mm:
        (WTF::initializeMainThreadPlatform):
        (WTF::initializeWebThreadPlatform):
        Move WebThread value initialization to its own function.

        (WTF::isMainThread):
        Remove no longer invalid assert if WebThread was not initialized.

2013-09-16  Benjamin Poulain  <benjamin@webkit.org>

        Fix WebKit1 build after r155910

        Reviewed by Anders Carlsson.

        * wtf/Platform.h: Some files in WebKit include system headers before
        WTF headers, causing the macro to be defined twice. #undef the macro
        to support that case.

2013-09-16  Benjamin Poulain  <benjamin@webkit.org>

        Disable OS X's unprefixed debug macro
        https://bugs.webkit.org/show_bug.cgi?id=121460

        Reviewed by Anders Carlsson.

        * wtf/Platform.h: OS X defines a series of platform macros for debugging.
        Some of them are really annoying because they use common names (e.g. check()).

        Disable those macros so that we are not limited in how we name methods and functions.

2013-09-16  Anders Carlsson  <andersca@apple.com>

        MessageQueue should use a Deque of OwnPtrs
        https://bugs.webkit.org/show_bug.cgi?id=121450

        Reviewed by Andreas Kling.

        * wtf/MessageQueue.h:

2013-09-16  Anders Carlsson  <andersca@apple.com>

        WTF::Deque should work with move only types
        https://bugs.webkit.org/show_bug.cgi?id=121446

        Reviewed by Andreas Kling.

        * wtf/Deque.h:
        Use std::move and std::forward where appropriate and get rid of the PassTraits include.

2013-09-16  Anders Carlsson  <andersca@apple.com>

        Change a couple of COMPILE_ASSERTs to static_assert
        https://bugs.webkit.org/show_bug.cgi?id=121441

        Reviewed by Andreas Kling.

        * wtf/BloomFilter.h:
        * wtf/PackedIntVector.h:
        (WTF::PackedIntVector::PackedIntVector):
        * wtf/StdLibExtras.h:
        (WTF::bitwise_cast):
        (WTF::safeCast):
        (WTF::roundUpToMultipleOf):
        * wtf/StringHasher.h:
        (WTF::StringHasher::hashMemory):
        * wtf/Vector.h:
        * wtf/text/AtomicString.cpp:
        * wtf/unicode/Unicode.h:

2013-09-15  Gustavo Noronha Silva  <gns@gnome.org>

        Unreviewed make distcheck fix.

        * GNUmakefile.list.am:

2013-09-15  Patrick Gansterer  <paroga@webkit.org>

        Fix build with Visual Studio 2012 after r153764.
        https://bugs.webkit.org/show_bug.cgi?id=121406

        Reviewed by Brent Fulgham.

        * wtf/MathExtras.h:

2013-09-15  Alberto Garcia  <berto@igalia.com>

        Unreviewed GTK gardening.

        * GNUmakefile.list.am: remove FastAllocBase.h, this file disappeared
        in r155251.

2013-09-15  Patrick Gansterer  <paroga@webkit.org>

        [WIN] Fix build without precompiled header after r155454.

        * wtf/win/GDIObject.h: Added missing windows.h include.

2013-09-15  Andreas Kling  <akling@apple.com>

        Remove Ref(const T&) constructor.
        <https://webkit.org/b/121384>

        Reviewed by Anders Carlsson.

        This constructor was added as a stopgap measure until we got better support
        for move semantics in Vector.

        * wtf/Ref.h:

2013-09-15  Andreas Kling  <akling@apple.com>

        Unreviewed, fix ridiculous bug in WeakPtr.

        I made operator!() null check the pointer to the WeakReference. :|

        Caught by plugins/destroy-on-setwindow.html on bots.

        * wtf/WeakPtr.h:
        (WTF::WeakPtr::operator!):

2013-09-14  Andreas Kling  <akling@apple.com>

        Get rid of ref-counting on RenderWidget.
        <https://webkit.org/b/121357>

        Reviewed by Darin Adler.

        * wtf/WeakPtr.h:
        (WTF::WeakPtr::operator!):

            Add operator! to WeakPtr.

2013-09-14  Darin Adler  <darin@apple.com>

        Add NeverDestroyed::get
        https://bugs.webkit.org/show_bug.cgi?id=121358

        Reviewed by Anders Carlsson.

        * wtf/NeverDestroyed.h: Removed code to make this non-copyable, since we also
        use a macro to accomplish that.
        (WTF::NeverDestroyed::get): Added. Useful in conjuction with auto to avoid
        having to repeat the type when we want to put one of these into a reference.

2013-09-13  Anders Carlsson  <andersca@apple.com>

        Pick the correct overload when a const reference is passed to appendSlowCase.
        https://bugs.webkit.org/show_bug.cgi?id=121326

        Reviewed by Darin Adler.

        * wtf/Vector.h:
        (WTF::Vector::appendSlowCase):
        Make sure that the pointer to the element isn't const so we'll pick the right expandCapacity overload.

2013-09-13  Anders Carlsson  <andersca@apple.com>

        Avoid a couple of zero-sized fastMalloc calls
        https://bugs.webkit.org/show_bug.cgi?id=121333

        Reviewed by Geoffrey Garen.

        * wtf/text/StringBuffer.h:
        (WTF::StringBuffer::StringBuffer):
        Initialize m_data to null if m_length is null, and use Checked<size_t> to check for
        overflow when multiplying m_length with the character size.

2013-09-13  Brent Fulgham  <bfulgham@apple.com>

        [Windows] Activate FastMalloc hardening
        https://bugs.webkit.org/show_bug.cgi?id=121307

        Reviewed by Oliver Hunt.

        * wtf/FastMalloc.cpp: 
        (WTF::SLL_Next): Add workaround for MSVC compiler bug.

2013-09-13  Mikhail Pozdnyakov  <mikhail.pozdnyakov@intel.com>

        OwnArrayPtr: Never allow implicit pointer conversion
        https://bugs.webkit.org/show_bug.cgi?id=121291

        Reviewed by Anders Carlsson.

        We should never allow implicit pointer conversion in OwnArrayPtr 
        and remove its template copy constructor & template assignment operator, as:
        - these methods are never used
        - these methods are inappropriate to have in OwnArrayPtr as arrays do not
          interact well with polymorphism.

        * wtf/OwnArrayPtr.h:

2013-09-13  Allan Sandfeld Jensen  <allan.jensen@digia.com>

        Remove support for QXmlStream as the XML parser.
        https://bugs.webkit.org/show_bug.cgi?id=121229

        Reviewed by Andreas Kling.

        Removed USE flags.

        * wtf/Platform.h:

2013-09-12  Mark Hahnenberg  <mhahnenberg@apple.com>

        Bitmap's WordType should be a template parameter
        https://bugs.webkit.org/show_bug.cgi?id=121238

        Reviewed by Darin Adler.

        The code is written as if it already is. We just need to lift it out of the class.
        This simplifies code that wants to load, for example, a single byte rather than an 
        entire 32-bit word. 

        * wtf/Bitmap.h:
        (WTF::Bitmap::Bitmap):
        (WTF::Bitmap::get):
        (WTF::Bitmap::set):
        (WTF::Bitmap::testAndSet):
        (WTF::Bitmap::testAndClear):
        (WTF::Bitmap::concurrentTestAndSet):
        (WTF::Bitmap::concurrentTestAndClear):
        (WTF::Bitmap::clear):
        (WTF::Bitmap::clearAll):
        (WTF::Bitmap::nextPossiblyUnset):
        (WTF::Bitmap::findRunOfZeros):
        (WTF::Bitmap::count):
        (WTF::Bitmap::isEmpty):
        (WTF::Bitmap::isFull):

2013-09-12  Anders Carlsson  <andersca@apple.com>

        Add rudimentary support for move-only types as values in HashMap
        https://bugs.webkit.org/show_bug.cgi?id=121226

        Reviewed by Andreas Kling.

        * wtf/HashMap.h:
        Change a bunch of functions to so they can take both rvalue and lvalue references and use std::forward.

        * wtf/HashTraits.h:
        (WTF::KeyValuePair::KeyValuePair):
        Change constructors to accept both lvalues and rvalues.

2013-09-12  Mikhail Pozdnyakov  <mikhail.pozdnyakov@intel.com>

        Remove home-brewed nullptr
        https://bugs.webkit.org/show_bug.cgi?id=119624

        Reviewed by Anders Carlsson.

        The standard C++11 nullptr and std::nullptr_t type should be used now.

        * GNUmakefile.list.am:
        * WTF.pro:
        * WTF.vcxproj/WTF.vcxproj:
        * WTF.vcxproj/WTF.vcxproj.filters:
        * WTF.xcodeproj/project.pbxproj:
        * wtf/CMakeLists.txt:
        * wtf/NullPtr.cpp: Removed.
        * wtf/NullPtr.h: Removed.
        * wtf/OwnArrayPtr.h:
        * wtf/OwnPtr.h:
        * wtf/PassOwnPtr.h:
        * wtf/PassRefPtr.h:
        * wtf/RetainPtr.h:
        * wtf/win/GDIObject.h:

2013-09-11  Anders Carlsson  <andersca@apple.com>

        Use the new C++11 function declaration syntax throughout our hash collection classes
        https://bugs.webkit.org/show_bug.cgi?id=121195

        Reviewed by Andreas Kling.

        * wtf/HashMap.h:
        * wtf/HashSet.h:
        * wtf/HashTable.h:

2013-09-11  Anders Carlsson  <andersca@apple.com>

        Add HashSet::take
        https://bugs.webkit.org/show_bug.cgi?id=121192

        Reviewed by Darin Adler.

        This is mostly done to see if we can use the new C++11 function declaration syntax,
        and for parity with HashMap::take. 

        * wtf/HashMap.h:
        * wtf/HashSet.h:

2013-09-11  Anders Carlsson  <andersca@apple.com>

        HashSet should work with move only types
        https://bugs.webkit.org/show_bug.cgi?id=121188

        Reviewed by Geoffrey Garen.

        * wtf/HashSet.h:
        (WTF::HashSet::add):
        Add a new rvalue reference overload and use std::move when calling HashTable::add.

        * wtf/HashTable.h:
        (WTF::IdentityHashTranslator::translate):
        Change this to take an rvalue reference for the value so we can invoke the move assignment operator.

        (WTF::HashTable::add):
        Call the add member function template, using std::move to move the value.

        (WTF::HashTable::add):
        Add std::forward so we'll potentially move extra.

2013-09-11  Anders Carlsson  <andersca@apple.com>

        Avoid copying a hash table bucket when inserting causes a rehash
        https://bugs.webkit.org/show_bug.cgi?id=121185

        Reviewed by Darin Adler.

        Allow rehashing to track a hash bucket and return the new pointer to it, thus avoiding
        having to do a copy of a hash table bucket as well as an extra hash lookup.

        * wtf/HashTable.h:

2013-09-11  Brent Fulgham  <bfulgham@apple.com>

        [Windows] Unreviewed build fix.

        * wtf/win/GDIObject.h:
        (WTF::GDIObject::GDIObject): I forgot to check in as part of
        r155557 by using webkit-patch land in a sub-directory!

2013-09-11  Oliver Hunt  <oliver@apple.com>

        Partial Information Leakage in Hash Table implementations (PrivateName)
        https://bugs.webkit.org/show_bug.cgi?id=120663

        Reviewed by Michael Saboff.

        Unique strings now just generate a completely random value as their
        hash, rather than using their this pointer.

        * wtf/text/StringImpl.h:
        (WTF::StringImpl::StringImpl):

2013-09-11  Brent Fulgham  <bfulgham@apple.com>

        Unreviewed build correction.

        * WTF.vcxproj/copy-files.cmd: Touch file to force WTFGenerated
        build to copy updated GDIObject.h header file on build machines.

2013-09-11  Anders Carlsson  <andersca@apple.com>

        Vector::append doesn't work if element type has overloaded operator&
        https://bugs.webkit.org/show_bug.cgi?id=121175

        Reviewed by Brent Fulgham.

        Use std::addressof to get the address of the given object.

        * wtf/Vector.h:
        (WTF::::appendSlowCase):
        (WTF::::uncheckedAppend):

2013-09-11  Anders Carlsson  <andersca@apple.com>

        Vector::append doesn't work if element type has overloaded operator&
        https://bugs.webkit.org/show_bug.cgi?id=121175

        Reviewed by Brent Fulgham.

        Use std::addressof to get the address of the given object.

        * wtf/Vector.h:
        (WTF::::appendSlowCase):
        (WTF::::uncheckedAppend):

2013-09-11  Anders Carlsson  <andersca@apple.com>

        VectorBuffer::swap doesn't need to use std::swap_ranges
        https://bugs.webkit.org/show_bug.cgi?id=121164

        Reviewed by Darin Adler.

        There's a std::swap overload for swapping arrays, just use it instead.

        * wtf/Vector.h:
        (WTF::VectorBuffer::swap):

2013-09-11  Anders Carlsson  <andersca@apple.com>

        Implement Vector::append for move-only types
        https://bugs.webkit.org/show_bug.cgi?id=120805

        Reviewed by Andreas Kling.

        * wtf/Vector.h:
        (WTF::::expandCapacity):
        Remove const from the pointer passed to expandCapacity, it can be non-const if we're moving.

        (WTF::::append):
        Change append to take U&& and use std::forward when constructing the element and when passing
        the element along to appendSlowCase if that's necessary.
        
        (WTF::::appendSlowCase):
        Use std::forward.

        (WTF::::uncheckedAppend):
        Rename val to value.

2013-09-11  Mikhail Pozdnyakov  <mikhail.pozdnyakov@intel.com>

        WTF::OwnPtr should behave similarly with the rest of WTF smart pointers
        https://bugs.webkit.org/show_bug.cgi?id=120773

        Reviewed by Anders Carlsson.

        Before the change OwnPtr could take either the pointer type or the pointed-to type, which was bad
        for the following reasons:
        - It distinguished OwnPtr behaviour from other WTF smart pointer classes behaviour (so it was confusing for the Client).
        - It was potential error-prone as it actually modified the type given by the Client in opaque way.

        * wtf/OwnPtr.h:
        * wtf/PassOwnPtr.h:

2013-09-11  Mikhail Pozdnyakov  <mikhail.pozdnyakov@intel.com>

        OwnPtr: Use copy/move-and-swap for assignment operators
        https://bugs.webkit.org/show_bug.cgi?id=121154

        Reviewed by Anders Carlsson.

        Rationals:
        - decrease of repeated code
        - consistency with RefPtr

        * wtf/OwnPtr.h:
        (WTF::=):

2013-09-11  Patrick Gansterer  <paroga@webkit.org>

        [CMake] Split out generic Windows files into its own file
        https://bugs.webkit.org/show_bug.cgi?id=119514

        Reviewed by Gyuyoung Kim.

        This allows us to add smaller CMakeLists.txt files when
        adding additional Windows ports.

        * wtf/PlatformWin.cmake: Renamed from Source/WTF/wtf/PlatformWinCE.cmake.

2013-09-10  Daniel Bates  <dabates@apple.com>

        [iOS] Upstream text autosizing
        https://bugs.webkit.org/show_bug.cgi?id=121111

        Reviewed by Andy Estes and Sam Weinig.

        Define iOS text autosizing to be enabled on iOS unless otherwise defined.

        * wtf/FeatureDefines.h:

2013-09-10  Anders Carlsson  <andersca@apple.com>

        Remove wtf/Alignment.h
        https://bugs.webkit.org/show_bug.cgi?id=121077

        Reviewed by Andreas Kling.

        * GNUmakefile.list.am:
        * WTF.pro:
        * WTF.vcxproj/WTF.vcxproj:
        * WTF.vcxproj/WTF.vcxproj.filters:
        * WTF.xcodeproj/project.pbxproj:
        * wtf/Alignment.h: Removed.
        * wtf/CMakeLists.txt:
        * wtf/text/ASCIIFastPath.h:

2013-09-10  Anders Carlsson  <andersca@apple.com>

        More WTF/Alignment.h removal
        https://bugs.webkit.org/show_bug.cgi?id=121125

        Reviewed by Andreas Kling.

        * wtf/Alignment.h:
        * wtf/Vector.h:
        (WTF::VectorBuffer::swap):
        (WTF::VectorBuffer::inlineBuffer):
        * wtf/text/ASCIIFastPath.h:
        (WTF::isAlignedTo):
        (WTF::isAlignedToMachineWord):

2013-09-10  Brent Fulgham  <bfulgham@apple.com>

        Unreviewed build fix after r155476.

        * GNUmakefile.list.am: Remove reference to deleted OwnPtrWin.cpp file.
        * WTF.pro: Ditto.
        * wtf/CMakeLists.txt: Ditto.

2013-09-10  Brent Fulgham  <bfulgham@apple.com>

        [Windows] Create SharedGDIObject Class Template
        https://bugs.webkit.org/show_bug.cgi?id=121037

        Reviewed by Anders Carlsson.

        Now that the SharedGDIObject class exists we can get rid of
        the Windows-specific code in OwnPtr.

        * WTF.vcxproj/WTF.vcxproj: Remove OwnPtrWin.cpp.
        * WTF.vcxproj/WTF.vcxproj.filters: Ditto.
        * wtf/OwnPtrCommon.h: 
        (WTF::deleteOwnedPtr): Remove Windows declarations that
        are no longer needed.
        * wtf/win/GDIObject.h:
        (WTF::GDIObject::get): Change to 'const' to match
        signature (and use cases) elsewhere in the code base for
        our smart pointer classes.
        * wtf/win/OwnPtrWin.cpp: Removed.

2013-09-10  Anders Carlsson  <andersca@apple.com>

        Remove more uses of WTF::AlignedBuffer
        https://bugs.webkit.org/show_bug.cgi?id=121119

        Reviewed by Andreas Kling.

        * wtf/HashTable.h:
        * wtf/SizeLimits.cpp:

2013-09-10  Anders Carlsson  <andersca@apple.com>

        Clean up wtf/Noncopyable.h
        https://bugs.webkit.org/show_bug.cgi?id=121115

        Reviewed by Darin Adler.

        Use std::aligned_storage instead of WTF::AlignedBuffer.

        * wtf/NeverDestroyed.h:
        (WTF::NeverDestroyed::NeverDestroyed):

2013-09-09  Brent Fulgham  <bfulgham@apple.com>

        [Windows] Change from using OwnPtr<GDI Stuff> to new GDIObject template.
        https://bugs.webkit.org/show_bug.cgi?id=120778

        Reviewed by Anders Carlsson.

        * WTF.vcxproj/WTF.vcxproj: Add new GDIObject header file.
        * WTF.vcxproj/WTF.vcxproj.filters: Ditto.
        * WTF.vcxproj/copy-files.cmd: Copy new header file.
        * wtf/OwnPtrCommon.h: Remove some GDI specializations.
        * wtf/win/GDIObject.h: Added.
        (WTF::GDIObject::GDIObject):
        (WTF::GDIObject::~GDIObject):
        (WTF::GDIObject::get):
        (WTF::GDIObject::operator!):
        (WTF::GDIObject::operator UnspecifiedBoolType):
        (WTF::GDIObject::operator=):
        (WTF::GDIObject::swap):
        (WTF::::clear):
        (WTF::::leak):
        (WTF::::GDIObject):
        (WTF::=):
        (WTF::adoptGDIObject):
        (WTF::swap):
        (WTF::T):
        (WTF::HDC):
        * wtf/win/OwnPtrWin.cpp:
        (WTF::deleteOwnedPtr): Remove some GDI specializations.

2013-09-09  Anders Carlsson  <andersca@apple.com>

        Introduce WTF::createOwned
        https://bugs.webkit.org/show_bug.cgi?id=121059

        Reviewed by Andreas Kling.

        WTF::createOwned is a function template that does adoptPtr + new in a single function call,
        with all the arguments being perfectly forwarded thanks to C++11.
        
        Being forward-looking, createOwned returns an OwnPtr rather than a PassOwnPtr since the plan is 
        to get rid of PassOwnPtr and just use std::move instead.

        * wtf/FilePrintStream.cpp:
        * wtf/FilePrintStream.h:
        * wtf/HashTable.h:
        * wtf/ListHashSet.h:
        * wtf/OwnPtr.h:
        (WTF::OwnPtr::OwnPtr):
        (WTF::createOwned):
        (WTF::createThread):
        (WTF::establishIdentifierForPthreadHandle):
        (WTF::createThreadInternal):
        (WTF::Collator::userDefault):
        (WTF::Collator::userDefault):

2013-09-09  Anders Carlsson  <andersca@apple.com>

        Remove wtf/TypeTraits.h
        https://bugs.webkit.org/show_bug.cgi?id=121047

        Reviewed by Darin Adler.

        * GNUmakefile.list.am:
        * WTF.pro:
        * WTF.vcxproj/WTF.vcxproj:
        * WTF.vcxproj/WTF.vcxproj.filters:
        * WTF.xcodeproj/project.pbxproj:
        * wtf/CMakeLists.txt:
        * wtf/TypeTraits.cpp: Removed.
        * wtf/TypeTraits.h: Removed.
        * wtf/VectorTraits.h:

2013-09-09  Luciano Wolf  <luciano.wolf@openbossa.org>

        Nix upstreaming - Adding stubs and Nix specific platform files
        https://bugs.webkit.org/show_bug.cgi?id=118358

        Reviewed by Benjamin Poulain.

        Basically adding all files that have "Nix" in their names and
        are related to WebCore module.

        * wtf/nix/FeatureDefinesNix.h: Added.
        * wtf/nix/PlatformNix.h: Added.

2013-09-08  Anders Carlsson  <andersca@apple.com>

        Begin moving off of TypeTraits.h
        https://bugs.webkit.org/show_bug.cgi?id=121006

        Reviewed by Darin Adler.

        The C++11 has its own type traits implementation that is more complete and handles corner cases better
        since it ties into the compiler. Begin switching uses of WTF type traits to STL type traits.

        * wtf/CheckedArithmetic.h:
        * wtf/HashTraits.h:
        * wtf/NeverDestroyed.h:
        * wtf/OwnPtr.h:
        * wtf/PassOwnPtr.h:
        (WTF::adoptPtr):
        * wtf/RetainPtr.h:

2013-09-09  Julien Brianceau  <jbriance@cisco.com>

        [Qt] Remove FastAllocBase.h from WTF.pro.
        https://bugs.webkit.org/show_bug.cgi?id=121024

        Reviewed by Jocelyn Turcotte.

        * WTF.pro: Remove FastAllocBase.h as this file disappeared in r155251.

2013-09-08  Darin Adler  <darin@apple.com>

        Deprecate AdoptCF and AdoptNS (on all platforms except iOS for now)
        https://bugs.webkit.org/show_bug.cgi?id=121017

        Reviewed by Andreas Kling.

        * wtf/RetainPtr.h: Use the preprocessor to rename AdoptCF and AdoptNS
        to DeprecatedAdoptCF and DeprecatedAdoptNS on all platforms except
        for iOS. Also removed an unneeded explicit conversion in the retainPtr
        function. Also re-sorted the using lines at the end of the file.

2013-09-08  Anders Carlsson  <andersca@apple.com>

        Move WTF::notFound to Vector.h and delete NotFound.h
        https://bugs.webkit.org/show_bug.cgi?id=120990

        Reviewed by Sam Weinig.

        * GNUmakefile.list.am:
        * WTF.pro:
        * WTF.vcxproj/WTF.vcxproj:
        * WTF.vcxproj/WTF.vcxproj.filters:
        * WTF.xcodeproj/project.pbxproj:
        * wtf/CMakeLists.txt:
        * wtf/NotFound.h: Removed.
        * wtf/Vector.h:

2013-09-07  David Kilzer  <ddkilzer@apple.com>

        gtest fails to build due to integer type mismatch in WTF::insertIntoBoundedVector()
        <http://webkit.org/b/120983>

        Reviewed by Dan Bernstein.

        Fixes the following build failure:

            WebKitBuild/Debug/usr/local/include/wtf/StdLibExtras.h:266:23: error: implicit conversion loses integer precision: 'size_t' (aka 'unsigned long') to 'unsigned int' [-Werror,-Wshorten-64-to-32]
            for (unsigned i = size; i-- > index + 1;)
                          ~   ^~~~

        * wtf/StdLibExtras.h:
        (WTF::insertIntoBoundedVector): Use size_t instead of unsigned
        as for loop index variable.

2013-09-07  Anders Carlsson  <andersca@apple.com>

        Remove NonCopyableSort.h from WTF
        https://bugs.webkit.org/show_bug.cgi?id=120984

        Reviewed by Andreas Kling.

        std::sort as defined by C++11 moves elements when possible, so there's no need for nonCopyableSort anymore.

        * GNUmakefile.list.am:
        * WTF.pro:
        * WTF.vcxproj/WTF.vcxproj:
        * WTF.vcxproj/WTF.vcxproj.filters:
        * WTF.xcodeproj/project.pbxproj:
        * wtf/NonCopyingSort.h: Removed.

2013-09-07  Anders Carlsson  <andersca@apple.com>

        Get rid of PassOwnArrayPtr
        https://bugs.webkit.org/show_bug.cgi?id=120964

        Reviewed by Andreas Kling.

        Make OwnArrayPtr a proper move-only type and get rid of PassOwnArrayPtr.
        
        Ultimately I'd like to get rid of OwnArrayPtr as well and just have it be a specialization
        of OwnPtr<T[]>, but this is a step in the right direction.

        * GNUmakefile.list.am:
        * WTF.pro:
        * WTF.vcxproj/WTF.vcxproj:
        * WTF.vcxproj/WTF.vcxproj.filters:
        * WTF.xcodeproj/project.pbxproj:
        * wtf/Assertions.cpp:
        * wtf/CMakeLists.txt:
        * wtf/DateMath.h:
        * wtf/FastBitVector.h:
        * wtf/Forward.h:
        * wtf/OwnArrayPtr.h:
        * wtf/PassOwnArrayPtr.h: Removed.

2013-09-07  Anders Carlsson  <andersca@apple.com>

        VectorMover should use std::move
        https://bugs.webkit.org/show_bug.cgi?id=120959

        Reviewed by Geoffrey Garen.

        This lets the compiler use move constructors when moving data, which can be a performance improvement.
        If the vector element type isn't movable it will be copied instead.

        * wtf/Vector.h:
        (WTF::VectorTypeOperations::move):
        (WTF::VectorTypeOperations::moveOverlapping):

2013-09-07  Anders Carlsson  <andersca@apple.com>

        Get rid of FastAllocBase.h
        https://bugs.webkit.org/show_bug.cgi?id=120952

        Reviewed by Antti Koivisto.

        FastAllocBase.h now only contains the WTF_MAKE_FAST_ALLOCATED macro. 
        Move that macro to FastMalloc.h instead and remove FastAllocBase.h.

        * WTF.vcxproj/WTF.vcxproj:
        * WTF.vcxproj/WTF.vcxproj.filters:
        * WTF.xcodeproj/project.pbxproj:
        * wtf/DeferrableRefCounted.h:
        * wtf/FastAllocBase.h: Removed.
        * wtf/FastMalloc.h:
        * wtf/HashSet.h:
        * wtf/MediaTime.h:
        * wtf/PrintStream.h:
        * wtf/RefCounted.h:
        * wtf/RefPtr.h:
        * wtf/ThreadingPrimitives.h:
        * wtf/Vector.h:
        * wtf/gobject/GMutexLocker.h:
        * wtf/unicode/Collator.h:

2013-09-06  Anders Carlsson  <andersca@apple.com>

        Add a new smart pointer type for fastMalloc'ed memory
        https://bugs.webkit.org/show_bug.cgi?id=120911

        Reviewed by Andreas Kling.

        Due to an oversight on my part, Vector::releaseBuffer() currently returns an OwnPtr
        which means that its data will be freed with operator delete instead of fastFree.
        
        Fix this by introducing a new MllocPtr smart pointer class and change Vector::releaseBuffer() to return it instead.

        * WTF.pro:
        * WTF.vcxproj/WTF.vcxproj:
        * WTF.vcxproj/WTF.vcxproj.filters:
        * WTF.xcodeproj/project.pbxproj:
        * wtf/CMakeLists.txt:
        * wtf/FastAllocBase.h:
        * wtf/MallocPtr.h: Added.
        * wtf/Vector.h:
        * wtf/text/StringBuffer.h:
        * wtf/text/StringImpl.h:

2013-09-06  Andreas Kling  <akling@apple.com>

        Remove old workaround for Nokia's Harmattan GCC on Qt/ARM.
        <https://webkit.org/b/37253>

        Reviewed by Anders Carlsson.

        Apparently this was a workaround for GCC getting stuck in an infinite loop
        when building for ARM in a Nokia SDK over 2 years ago.

        I think it's safe to remove this now, but if I'm wrong, and you're reading
        this ChangeLog wondering why I did this to you, feel free to put it back in.

        * wtf/PassRefPtr.h:
        (WTF::refIfNotNull):
        (WTF::derefIfNotNull):

2013-09-06  Andreas Kling  <akling@apple.com>

        Remove unused RefPtr(PlacementNewAdopt) constructor.
        <https://webkit.org/b/120914>

        Reviewed by Anders Carlsson.

        * wtf/RefPtr.h:

2013-09-06  David Kilzer  <ddkilzer@apple.com>

        BUILD FIX (r155171): INSTALL_PATH_PREFIX should no longer be used beneath BUILT_PRODUCTS_DIR in HEADER_SEARCH_PATHS for iOS

        * Configurations/Base.xcconfig:
        (HEADER_SEARCH_PATHS): Change
        $(BUILT_PRODUCTS_DIR)/$(INSTALL_PATH_PREFIX)/usr/local/include to
        $(BUILT_PRODUCTS_DIR)/usr/local/include.

2013-09-06  Anders Carlsson  <andersca@apple.com>

        Remove fastNew/fastDelete
        https://bugs.webkit.org/show_bug.cgi?id=120904

        Reviewed by Andreas Kling.

        Remove the various variants of fastNew and fastDelete.

        * wtf/FastAllocBase.h:

2013-09-06  Alberto Garcia  <berto@igalia.com>

        [GTK] GlibUtilities: getCurrentExecutablePath() does not compile on GNU/Hurd
        https://bugs.webkit.org/show_bug.cgi?id=120793

        Reviewed by Gustavo Noronha Silva.

        Original patch by Svante Signell <svante.signell@telia.com>.

        PATH_MAX is not defined in GNU/Hurd, this patch adds a dummy
        implementation to make it compile.

        * wtf/gobject/GlibUtilities.cpp:
        (getCurrentExecutablePath):

2013-09-05  Dan Bernstein  <mitz@apple.com>

        INSTALL_PATH_PREFIX is used even when not installing
        https://bugs.webkit.org/show_bug.cgi?id=120810

        Reviewed by Andy Estes.

        * Configurations/CopyWTFHeaders.xcconfig: Removed INSTALL_PATH_PREFIX from
        the definition of PRIVATE_HEADERS_FOLDER_PATH. Also removed the leading
        slash, because the Xcode definition of this build setting is relative.
        * WTF.xcodeproj/project.pbxproj: Prepend INSTALL_PATH_PREFIX here when installing.

2013-09-05  Anders Carlsson  <andersca@apple.com>

        Fix build with older versions of clang from Xcode.

        * wtf/Compiler.h:

2013-09-05  Anders Carlsson  <andersca@apple.com>

        Make Vector::uncheckedAppend work with move-only types
        https://bugs.webkit.org/show_bug.cgi?id=120799

        Reviewed by Andreas Kling.

        * wtf/Vector.h:
        (WTF::::uncheckedAppend):
        Use std::forward to invoke the move constructor when possible.

2013-09-05  Anders Carlsson  <andersca@apple.com>

        Add COMPILER_SUPPORTS(CXX_AUTO_TYPE) and #error if it's 0
        https://bugs.webkit.org/show_bug.cgi?id=120794

        Reviewed by Andreas Kling.

        People have already begun using C++11 auto in WebCore, so let's make it a prerequisite.

        * wtf/Compiler.h:

2013-09-05  Anders Carlsson  <andersca@apple.com>

        Clean up wtf/Compiler.h
        https://bugs.webkit.org/show_bug.cgi?id=120790

        Reviewed by Andreas Kling.

        - Get rid of the CLANG_PRAGMA define, it's not used anywhere.
        - Remove a workaround for a bug in the version of clang that came with Xcode 4.2.
        - Replace WTF_COMPILER_SUPPORTS_CXX_FINAL_CONTROL with a compiler quirk for versions of clang
          that have a buggy final implementation and fix a bug in the macro where final would be disabled
          for versions of clang where __clang_minor__ is less than 2, regardless of the major version.
        - Fail if someone tries to compile the WebKit stack with a compiler that doesn't support rvalue
          references or static_assert.

        * wtf/Compiler.h:

2013-09-05  Anders Carlsson  <andersca@apple.com>

        Change StringBuffer back to not use an OwnPtr in an attempt to fix ports.
        
        * wtf/text/StringBuffer.h:

2013-09-04  Anders Carlsson  <andersca@apple.com>

        Vector::releaseBuffer should return an OwnPtr
        https://bugs.webkit.org/show_bug.cgi?id=120718

        Reviewed by Andreas Kling.

        Change Vector::releaseBuffer() to return an OwnPtr. I intentionally chose
        to use an OwnPtr over a PassOwnPtr since we're trying to move away from PassOwnPtr objects.
        
        Fix fallout from this change by adopting OwnPtr/PassOwnPtr in StringBuffer and the two StringImpl
        constructors that adopt the passed in pointer.

        * wtf/Vector.h:
        * wtf/text/StringBuffer.h:
        * wtf/text/StringImpl.h:

2013-09-05  Mikhail Pozdnyakov  <mikhail.pozdnyakov@intel.com>

        Remove String(RefPtr<StringImpl>) constructor
        https://bugs.webkit.org/show_bug.cgi?id=120767

        Reviewed by Anders Carlsson.

        The String(RefPtr<StringImpl>) constructor should be removed for the following reasons:
        - It almost does not have clients, so it is unneeded.
        - RefPtr should never be passed by value

        * wtf/text/StringBuilder.cpp:
        (WTF::StringBuilder::shrinkToFit):
        * wtf/text/WTFString.h:

2013-09-05  Jaehun Lim  <ljaehun.lim@samsung.com>

        Unreviewed. Fix build after r155083

        Source/WTF/wtf/Vector.h:1210:48: error: ‘>>’ should be ‘> >’ within a nested template argument list

        * wtf/Vector.h: Add missing space.

2013-09-04  Mark Rowe  <mrowe@apple.com>

        Fix AutodrainedPool.h to compile without errors under ARC.

        Rubber-stamped by Anders Carlsson.

        * wtf/AutodrainedPool.h: Some versions of Clang complain about any use of NSAutoreleasePool under ARC.
        Change the type of the member variable to id to work around this. Since the implementation file is compiled
        under manual reference counting, everything will work fine.

2013-09-04  Anders Carlsson  <andersca@apple.com>

        De-indent Vector.h.

        Rubber-stamped by Andreas Kling.
        
        I'm cleaning up Vector and making it work with move-only objects, and the namespace WTF
        indentation is driving me crazy.

        * wtf/Vector.h:

2013-09-03  Filip Pizlo  <fpizlo@apple.com>

        CodeBlock memory cost reporting should be rationalized
        https://bugs.webkit.org/show_bug.cgi?id=120615

        Reviewed by Darin Adler.

        * wtf/RefCountedArray.h:
        (WTF::RefCountedArray::refCount):

2013-09-03  Enrica Casucci  <enrica@apple.com>

        Follow up to http://trac.webkit.org/changeset/155014

        Reviewed by Alexey Proskuryakov.

        In the r155014 I renamed hasLineBreakingPropertyComplexContext
        to requiresComplexContextForWordBreaking but forgot to
        make the same change in UnicodeWchar.h.

        * wtf/unicode/wchar/UnicodeWchar.cpp:
        (WTF::Unicode::requiresComplexContextForWordBreaking):
        * wtf/unicode/wchar/UnicodeWchar.h:

2013-09-03  Enrica Casucci  <enrica@apple.com>

        Can't select Katakana word by double-clicking.
        <rdar://problem/14654926>

        Reviewed by Alexey Proskuryakov and Ryosuke Niwa.

        For some languages, like Japanese we need
        to use more context for word breaking.
        I've renamed the function to better reflect its use
        and remove the unused hasLineBreakingPropertyComplexContextOrIdeographic.

        * wtf/unicode/icu/UnicodeIcu.h:
        (WTF::Unicode::requiresComplexContextForWordBreaking):

2013-09-03  Andreas Kling  <akling@apple.com>

        Support Vector<Ref<T>>.
        <https://webkit.org/b/120637>

        Reviewed by Antti Koivisto.

        Add a Ref(const T&) constructor to enable Vector<Ref<T>>. This looks a bit awkward
        but is necessary for Vector::append(const T&) to find a constructor.

        An alternative would be to add something like std::vector::emplace_back, but I can't
        think of a good name for that, and it'd be nice if append() would "just work."

        Also add operator->(). I initially excluded this because I felt it made for
        unsafe-looking code. Things quickly got out of hand with .get() everywhere though.

        IMO -> looks OK as long as it's only used on the first link in a dereference chain,
        as that variable and its type will be "in context."

        * wtf/Ref.h:
        (WTF::Ref::Ref):
        (WTF::Ref::~Ref):
        (WTF::Ref::operator->):
        (WTF::Ref::get):
        * wtf/VectorTraits.h:

            Add simple traits for Ref<T> so it can be moved around freely by Vector.

2013-09-03  Mikhail Pozdnyakov  <mikhail.pozdnyakov@intel.com>

        Check WTF::VectorFiller template argument type size in compile time
        https://bugs.webkit.org/show_bug.cgi?id=120631

        Reviewed by Darin Adler.

        The template argument's type size in WTF::VectorFiller 'memset' specialization
        should be checked during compilation rather than in runtime.

        * wtf/Vector.h:

2013-09-02  Darin Adler  <darin@apple.com>

        Cut down on double hashing and code needlessly using hash table iterators
        https://bugs.webkit.org/show_bug.cgi?id=120611

        Reviewed by Andreas Kling.

        Double hashing is common in code that needs to combine a remove with some
        action to only be done if the code is removed. The only way to avoid it is
        to write code using find and a hash table iterator. To help with this, add
        a boolean return value to remove functions to indicate if anything was removed.

        Double hashing also happens in code that does a get followed by a remove.
        The take function is helpful in this case. To help with this, add a takeFirst
        funciton to ListHashSet.

        * wtf/HashCountedSet.h:
        (WTF::HashCountedSet::removeAll): Added a boolean return value, analogous to the one
        that the HashCountedSet::remove function already has.

        * wtf/HashMap.h:
        (WTF::HashMap::remove): Added a boolean return value, true if something was removed.
        * wtf/HashSet.h:
        (WTF::HashSet::remove): Ditto.
        * wtf/RefPtrHashMap.h:
        (WTF::RefPtrHashMap::remove): Ditto.

        * wtf/ListHashSet.h:
        (WTF::ListHashSet::takeFirst): Added.
        (WTF::ListHashSet::takeLast): Added.
        (WTF::ListHashSet::remove): Added a boolean return value, true if something was removed.

        * wtf/WTFThreadData.h:
        (JSC::IdentifierTable::remove): Use the new remove return value to get rid of most of
        the code in this function.

2013-09-02  David Kilzer  <ddkilzer@apple.com>

        Remove duplicate entries found by Xcode in WTF project

        Platform.h was duplicated in r111778 after being added in
        r111504.

        A dangling reference to Ref.h was added in r154962.

        * WTF.xcodeproj/project.pbxproj: Remove duplicate entries for
        Platform.h and Ref.h.

2013-09-02  Andreas Kling  <akling@apple.com>

        Actually add Ref.h

2013-09-02  Darin Adler  <darin@apple.com>

        [Mac] No need for HardAutorelease, which is same as CFBridgingRelease
        https://bugs.webkit.org/show_bug.cgi?id=120569

        Reviewed by Andy Estes.

        * wtf/ObjcRuntimeExtras.h: Added a FIXME about miscapitalization of ObjC.
        Deleted HardAutorelease.
        (wtfObjcMsgSend): Dropped the use of abbreviations in local class and argument names.
        (wtfCallIMP): Ditto.

2013-09-01  Andreas Kling  <akling@apple.com>

        Ref: A smart pointer for the reference age.
        <https://webkit.org/b/120570>

        Reviewed by Antti Koivisto.

        Add a very simple simple Ref<T> smart pointer class that is never null.
        It's initialized by passing a T& to the constructor and cannot be assigned to.

        operator-> is not overloaded, to prevent unsafe-looking code.
        The value is extracted by "T& get()", since C++ does not let you override operator.()

        * wtf/Ref.h:

2013-08-30  Oliver Hunt  <oliver@apple.com>

        Make JSValue bool conversion less dangerous
        https://bugs.webkit.org/show_bug.cgi?id=120505

        Reviewed by Darin Adler.

        Make LIKELY and UNLIKELY macros coerce to bool before
        passing to expect.

        * wtf/Compiler.h:

2013-08-30  Antti Koivisto  <antti@apple.com>

        Remove code behind ENABLE(DIALOG_ELEMENT)
        https://bugs.webkit.org/show_bug.cgi?id=120467

        Reviewed by Darin Adler.

        * wtf/FeatureDefines.h:

2013-08-29  Sam Weinig  <sam@webkit.org>

        Add ENABLE guards for Promises
        https://bugs.webkit.org/show_bug.cgi?id=120488

        Reviewed by Andreas Kling.

        * wtf/FeatureDefines.h:

2013-08-28  Zan Dobersek  <zdobersek@igalia.com>

        [GTK] Add support for building JSC with FTL JIT enabled
        https://bugs.webkit.org/show_bug.cgi?id=120270

        Reviewed by Filip Pizlo.

        * wtf/Platform.h: Define ENABLE_FTL_JIT to the value of 1 for the GTK port if building for the x86-64
        architecture with LLVM present and the define not being previously defined. This is applicable when
        configuring the Automake build with '--enable-ftl-jit=auto'.

2013-08-27  Arunprasad Rajkumar  <arurajku@cisco.com>

        Replace currentTime() with monotonicallyIncreasingTime() in WebCore
        https://bugs.webkit.org/show_bug.cgi?id=119958

        Reviewed by Alexey Proskuryakov.

        WTF::currentTime() is prone to NTP and manual adjustments, so use
        WTF::monotonicallyIncreasingTime() to measure elapsed time.

        It is a continuation of r154201.

        * wtf/CurrentTime.h: Edited comment.

2013-08-27  Andre Moreira Magalhaes   <andre.magalhaes@collabora.co.uk>

        [gstreamer] Make sure gstreamer source element is thread-safe
        https://bugs.webkit.org/show_bug.cgi?id=115352

        Reviewed by Philippe Normand.

        Add convenience class that simplifies locking and unlocking a GMutex.

        * GNUmakefile.list.am:
        * wtf/gobject/GMutexLocker.h: Added.
        (WebCore::GMutexLocker::GMutexLocker):
        (WebCore::GMutexLocker::~GMutexLocker):
        (WebCore::GMutexLocker::lock):
        (WebCore::GMutexLocker::unlock):
        (WebCore::GMutexLocker::mutex):

2013-08-26  Andy Estes  <aestes@apple.com>

        Don't leak objects in HardAutorelease when OBJC_NO_GC is undefined but
        Objective-C GC is disabled at runtime.
        
        Reviewed by Darin Adler.

        * wtf/ObjcRuntimeExtras.h:
        (HardAutorelease):

2013-08-23  Andy Estes  <aestes@apple.com>

        Fix issues found by the Clang Static Analyzer
        https://bugs.webkit.org/show_bug.cgi?id=120230

        Reviewed by Darin Adler.

        * wtf/ObjcRuntimeExtras.h:
        (HardAutorelease): Added a canonical implementation of HardAutorelease.

2013-08-26  Zan Dobersek  <zdobersek@igalia.com>

        Undefine __STDC_LIMIT_MACROS and __STDC_CONSTANT_MACROS before redefining them
        https://bugs.webkit.org/show_bug.cgi?id=120313

        Reviewed by Darin Adler.

        * wtf/LLVMHeaders.h: Undefine the two macros before they are defined again.
        This way we avoid the compilation-time warnings about the macros being invalidly redefined.

2013-08-26  Oliver Hunt  <oliver@apple.com>

        Building is so overrated.

        * wtf/Compression.cpp:
        (WTF::GenericCompressedData::decompress):

2013-08-26  Oliver Hunt  <oliver@apple.com>

        Disable compression under MSVC for now as we're getting
        weird release-only failures.

        * wtf/Compression.cpp:

2013-08-24  Benjamin Poulain  <benjamin@webkit.org>

        Save three bytes per CStringBuffer object
        https://bugs.webkit.org/show_bug.cgi?id=120040

        Reviewed by Darin Adler.

        Merge https://chromium.googlesource.com/chromium/blink/+/894ae8eafdb64912aefd8f9c809f4ccda84f3b89

        sizeof(CStringBuffer) was rounded up to 8 on account of struct size and
        alignment rules. This is clearly not what was intended.

        * wtf/text/CString.cpp:
        (WTF::CStringBuffer::createUninitialized):
        * wtf/text/CString.h:
        (WTF::CStringBuffer::data):
        (WTF::CStringBuffer::mutableData):

2013-08-24  Darin Adler  <darin@apple.com>

        RetainPtr lacks move constructor for case when argument is a RetainPtr of a different type
        https://bugs.webkit.org/show_bug.cgi?id=120255

        Reviewed by Andreas Kling.

        * wtf/RetainPtr.h: Added missing move constructor, modeled on the other move constructor,
        and the one from RetPtr.

2013-08-24  Oliver Hunt  <oliver@apple.com>

        Make the world build.

        * wtf/Compression.h:

2013-08-24  Oliver Hunt  <oliver@apple.com>

        REGRESSION(r154498): Crashes on EFL, GTK, Qt on release configurations
        https://bugs.webkit.org/show_bug.cgi?id=120246

        Reviewed by Antti Koivisto.

        Undestroy all the platforms that don't use the global new overload

        * wtf/Compression.h:

2013-08-21  Mark Rowe  <mrowe@apple.com>

        <https://webkit.org/b/120141> Make RetainPtr work with ARC.

        Have RetainPtr store the object its managing as a CFTypeRef and manage its lifetime with
        CFRetain / CFRelease. This is necessary to have explicit control over the lifetime of
        Objective-C objects when automatic reference counting is in use. Two helper methods are
        introduced to convert between the pointer type that the RetainPtr manages and the CFTypeRef
        that the pointer is stored as. For CF types and Objective-C types with ARC disabled,
        these methods are simply casts. For Objective-C types under ARC they need to use the
        special bridging casts to keep the compiler happy.

        Reviewed by Anders Carlsson.

        * wtf/RetainPtr.h:
        (WTF::RetainPtr::RetainPtr): Use the helper methods to convert to and from the storage
        types when necessary.
        (WTF::RetainPtr::~RetainPtr): Ditto.
        (WTF::RetainPtr::get): Ditto.
        (WTF::RetainPtr::operator->): Ditto.
        (WTF::RetainPtr::operator PtrType): Ditto.
        (WTF::::RetainPtr): Ditto.
        (WTF::::clear): Ditto.
        (WTF::::leakRef): Ditto.
        (WTF::=): Ditto.

        (WTF::RetainPtr::fromStorageTypeHelper): Use crazy template magic to determine whether to use
        a bridging cast or not depending on the desired return type.
        (WTF::RetainPtr::fromStorageType):
        (WTF::RetainPtr::toStorageType): Overloading is sufficient here.

2013-08-21  Mark Rowe  <mrowe@apple.com>

        Revert r153637.

        It didn't work with ARC like it said it would. We'll need to take a slightly different approach.

        Rubber-stamped by Anders Carlsson.

        * wtf/RetainPtr.h:
        (WTF::RetainPtr::RetainPtr):
        (WTF::RetainPtr::~RetainPtr):
        (WTF::RetainPtr::operator UnspecifiedBoolType):
        (WTF::::RetainPtr):
        (WTF::::clear):
        (WTF::=):
        (WTF::adoptCF):
        (WTF::adoptNS):

2013-08-23  Brent Fulgham  <bfulgham@apple.com>

        [Windows] Unreviewed build correction after r154513.

        * WTF.vcxproj/build-generated-files.sh: Variable was missing '$' character.

2013-08-23  Darin Adler  <darin@apple.com>

        Cut down repeated code in RefPtr and RetainPtr by using copy/move-and-swap for assignment operators
        https://bugs.webkit.org/show_bug.cgi?id=120223

        Reviewed by Anders Carlsson.

        * wtf/RefPtr.h: Switch to copy-and-swap in the assignment operators. The move ones already were done
        that way.
        * wtf/RetainPtr.h: Ditto, except for the move ones too.

2013-08-23  Oliver Hunt  <oliver@apple.com>

        Add more validation logic to CompressibleVector
        https://bugs.webkit.org/show_bug.cgi?id=120227

        Reviewed by Brent Fulgham.

        Add a pile of assertions to try on catch whatever is going wrong
        in the windows environment or other platforms.

        * wtf/Compression.cpp:
        (WTF::GenericCompressedData::create):
        (WTF::GenericCompressedData::decompress):
        * wtf/Compression.h:
        (WTF::CompressedVector::decompress):

2013-08-23  Alex Christensen  <achristensen@apple.com>

        Re-separating Win32 and Win64 builds.
        https://bugs.webkit.org/show_bug.cgi?id=120178

        Reviewed by Brent Fulgham.

        * WTF.vcxproj/WTFGenerated.make:
        Pass PlatformArchitecture as a command line parameter to bash scripts.
        * WTF.vcxproj/build-generated-files.sh:
        Use PlatformArchitecture from command line to determine which object directory to use (obj32 or obj64).

2013-08-22  Filip Pizlo  <fpizlo@apple.com>

        build-jsc --ftl-jit should work
        https://bugs.webkit.org/show_bug.cgi?id=120194

        Reviewed by Oliver Hunt.

        * wtf/LLVMHeaders.h: I don't know what went wrong here. If HAVE(LLVM), then we need those headers!

2013-08-23  Brent Fulgham  <bfulgham@apple.com>

        [Windows] Unreviewed build correction after r154498.

        * WTF.vcxproj/WTF.vcxproj.filters: Adjust files so they show up
        in the proper folders.
        * WTF.vcxproj/WTFCommon.props: Add search path for zlib header and
        include link directive.

2013-08-23  Oliver Hunt  <oliver@apple.com>

        Attempt to appease windows bot.

        * wtf/Compression.h:

2013-08-23  Oliver Hunt  <oliver@apple.com>

        Re-sort xcode project file

        * WTF.xcodeproj/project.pbxproj:

2013-08-23  Oliver Hunt  <oliver@apple.com>

        Support in memory compression of rarely used data
        https://bugs.webkit.org/show_bug.cgi?id=120143

        Reviewed by Gavin Barraclough.

        Adds a set of utility functions to wrap the use of zlib over a generic
        type or a Vector<> as well as adding CompressibleVector that wraps
        either a Vector<> or compressed data.

        * GNUmakefile.list.am:
        * WTF.pro:
        * WTF.vcxproj/WTF.vcxproj:
        * WTF.xcodeproj/project.pbxproj:
        * wtf/CMakeLists.txt:
        * wtf/CheckedArithmetic.h:
        * wtf/Compression.cpp: Added.
        (WTF::zAlloc):
        (WTF::zFree):
        (WTF::GenericCompressedData::create):
        (WTF::GenericCompressedData::decompress):
        * wtf/Compression.h: Added.
        (WTF::GenericCompressedData::compressedSize):
        (WTF::GenericCompressedData::originalSize):
        (WTF::GenericCompressedData::GenericCompressedData):
        (WTF::CompressedVector::create):
        (WTF::CompressedVector::decompress):
        (WTF::CompressedVector::size):
        (WTF::CompressibleVector::CompressibleVector):
        (WTF::CompressibleVector::shrinkToFit):
        (WTF::CompressibleVector::size):
        (WTF::CompressibleVector::operator[]):
        (WTF::CompressibleVector::at):
        (WTF::CompressibleVector::begin):
        (WTF::CompressibleVector::end):
        (WTF::CompressibleVector::data):
        (WTF::CompressibleVector::decompressIfNecessary):

2013-08-21  Commit Queue  <commit-queue@webkit.org>

        Unreviewed, rolling out r154416.
        http://trac.webkit.org/changeset/154416
        https://bugs.webkit.org/show_bug.cgi?id=120147

        Broke Windows builds (Requested by rniwa on #webkit).

        * WTF.vcxproj/WTFGenerated.make:
        * WTF.vcxproj/build-generated-files.sh:

2013-08-21  Alex Christensen  <achristensen@apple.com>

        <https://webkit.org/b/120137> Separating Win32 and Win64 builds.

        Reviewed by Brent Fulgham.

        * WTF.vcxproj/WTFGenerated.make:
        Pass PlatformArchitecture as a command line parameter to bash scripts.
        * WTF.vcxproj/build-generated-files.sh:
        Use PlatformArchitecture from command line to determine which object directory to use (obj32 or obj64).

2013-08-21  Allan Sandfeld Jensen  <allan.jensen@digia.com>

        Disable maybe-uninitialized warning in GCC 4.8
        https://bugs.webkit.org/show_bug.cgi?id=119835

        Reviewed by Anders Carlsson.

        Disable the maybe-uninitialized warning.

        * wtf/Compiler.h:

2013-08-20  Alex Christensen  <achristensen@apple.com>

        Use PlatformArchitecture to distinguish between 32-bit and 64-bit builds on Windows.
        https://bugs.webkit.org/show_bug.cgi?id=119512

        Reviewed by Brent Fulgham.

        * WTF.vcxproj/WTFGeneratedCommon.props:
        Replaced obj32, bin32, and lib32 with macros for 64-bit build.

2013-08-20  Víctor Manuel Jáquez Leal  <vjaquez@igalia.com>

        <https://webkit.org/b/120056> [GTK][ARM] enable DFG_JIT

        Reviewed by Martin Robinson.

        Enable DFG_JIT in GTK+ platform for ARM/Thumb architecture

        * wtf/Platform.h:

2013-08-19  Ryosuke Niwa  <rniwa@webkit.org>

        <https://webkit.org/b/120049> Delete code for Snow Leopard

        Reviewed by Benjamin Poulain.

        * wtf/FastMalloc.cpp:
        (WTF::TCMalloc_ThreadCache::CreateCacheIfNecessary):
        * wtf/FeatureDefines.h:
        * wtf/Platform.h:

2013-08-19  Joseph Pecoraro  <pecoraro@apple.com>

        <https://webkit.org/b/120036> [iOS] Upstream Source/WTF Xcode project for iOS

        Reviewed by David Kilzer.

        Include iOS only WebCoreThread.* files in an ios group, and clean up
        the included files a bit.

        * WTF.xcodeproj/project.pbxproj:
        * wtf/ios/WebCoreThread.cpp:
        * wtf/ios/WebCoreThread.h:

2013-08-19  Joseph Pecoraro  <pecoraro@apple.com>

        <https://webkit.org/b/119905> [iOS] Upstream Source/WTF

        Reviewed by Benjamin Poulain.

        Upstream iOS WebKit Source/WTF.

        * Configurations/Base.xcconfig:
        JavaScriptCore.framework is a public framework.

        * wtf/Assertions.h:
        Define an export macro for iOS projects just including <wtf/Assertions.h>.

        * wtf/Platform.h:
        * wtf/FeatureDefines.h:
        iOS ENABLE and USE defines.

        * wtf/MainThread.h:
        * wtf/mac/MainThreadMac.mm:
        (WTF::initializeApplicationUIThreadIdentifier):
        (WTF::initializeWebThreadIdentifier):
        (WTF::canAccessThreadLocalDataForThread):
        * wtf/WeakPtr.h:
        (WTF::WeakReference::get):
        (WTF::WeakReference::clear):
        Shared WebThread and MainThread access to thread local data.

        * wtf/WTFThreadData.cpp:
        (WTF::WTFThreadData::WTFThreadData):
        Shared WebThread and MainThread identifier tables.

        * wtf/ThreadSpecific.h:
        (WTF::::replace):
        Used later on so that WebThread can share the MainThread's thread global data.

        * wtf/text/StringStatics.cpp:
        (WTF::AtomicString::init):
        When USE(WEB_THREAD) assert AtomicString::init is initialized on the realMainThread.

        * wtf/unicode/CharacterNames.h:
        * wtf/unicode/icu/UnicodeIcu.h:
        (WTF::Unicode::hasLineBreakingPropertyComplexContextOrIdeographic):
        Minor iOS constants and functions used later by WebCore.

2013-08-16  Arunprasad Rajkumar  <arurajku@cisco.com>

        <https://webkit.org/b/119785> Replace currentTime() with monotonicallyIncreasingTime() in WebCore

        Reviewed by Alexey Proskuryakov.

        WTF::currentTime() is prone to DST changes and NTP adjustments, so use
        WTF::monotonicallyIncreasingTime() to measure elapsed time.

        * wtf/CurrentTime.h:
        (WTF::monotonicallyIncreasingTimeMS): Added mille second version of monotonic time API.

2013-08-15  Filip Pizlo  <fpizlo@apple.com>

        refCount() of a StringImpl could be zero if it's static; in that case we shouldn't report extra memory cost
        https://bugs.webkit.org/show_bug.cgi?id=119870

        Reviewed by Mark Hahnenberg.

        * wtf/text/StringImpl.h:
        (WTF::StringImpl::costDuringGC):
        (WTF::StringImpl::isStatic):
        (WTF::StringImpl::bufferOwnership):

2013-08-14  Filip Pizlo  <fpizlo@apple.com>

        Typed arrays should be rewritten
        https://bugs.webkit.org/show_bug.cgi?id=119064

        Reviewed by Oliver Hunt.
        
        - Added the notion of a reference counted object that can be marked Deferred,
          which is like a special-purpose upref.
        
        - Added a common byte flipper.

        Automake work courtesy of Zan Dobersek <zdobersek@igalia.com>.

        * GNUmakefile.list.am:
        * WTF.xcodeproj/project.pbxproj:
        * wtf/DeferrableRefCounted.h: Added.
        (WTF::DeferrableRefCountedBase::ref):
        (WTF::DeferrableRefCountedBase::hasOneRef):
        (WTF::DeferrableRefCountedBase::refCount):
        (WTF::DeferrableRefCountedBase::isDeferred):
        (WTF::DeferrableRefCountedBase::DeferrableRefCountedBase):
        (WTF::DeferrableRefCountedBase::~DeferrableRefCountedBase):
        (WTF::DeferrableRefCountedBase::derefBase):
        (WTF::DeferrableRefCountedBase::setIsDeferredBase):
        (WTF::DeferrableRefCounted::deref):
        (WTF::DeferrableRefCounted::setIsDeferred):
        (WTF::DeferrableRefCounted::DeferrableRefCounted):
        (WTF::DeferrableRefCounted::~DeferrableRefCounted):
        * wtf/FlipBytes.h: Added.
        (WTF::needToFlipBytesIfLittleEndian):
        (WTF::flipBytes):
        (WTF::flipBytesIfLittleEndian):

2013-08-14  Julien Brianceau  <jbrianceau@nds.com>

        DFG_JIT implementation for sh4 architecture.
        https://bugs.webkit.org/show_bug.cgi?id=119737

        Reviewed by Oliver Hunt.

        * wtf/Platform.h:

2013-08-13  Arunprasad Rajkumar  <arurajku@cisco.com>

        [WTF] [JSC] Replace currentTime() with monotonicallyIncreasingTime() in all possible places
        https://bugs.webkit.org/show_bug.cgi?id=119762

        Reviewed by Geoffrey Garen.

        * wtf/MainThread.cpp:
        (WTF::dispatchFunctionsFromMainThread):

2013-08-12  Ragner Magalhaes  <ranger.n@samsung.com>

        Broken build with build-webkit --no-webgl
        https://bugs.webkit.org/show_bug.cgi?id=119272

        Reviewed by Alexandru Chiculita.

        CSS_SHADERS requires WEBGL enabled.
        Add error message to dependency failure.

        * wtf/FeatureDefines.h:

2013-08-12  Joseph Pecoraro  <pecoraro@apple.com>

        [iOS] isMainThread implementation with USE(WEB_THREAD)
        https://bugs.webkit.org/show_bug.cgi?id=119644

        Reviewed by Benjamin Poulain.

        On iOS isMainThread() means that the current thread is either the
        MainThread or WebThread and the current thread has the WebThreadLock.

        * wtf/ios/WebCoreThread.cpp: Added.
        * wtf/ios/WebCoreThread.h: Added.
        * wtf/mac/MainThreadMac.mm:
        (WTF::isMainThread):

2013-08-11  Carlos Garcia Campos  <cgarcia@igalia.com>

        Unreviewed. Fix make distcheck.

        * GNUmakefile.list.am: Add missing header file.

2013-08-09  Christophe Dumez  <ch.dumez@sisa.samsung.com>

        Make atob() throw an InvalidCharacterError on excess padding characters
        https://bugs.webkit.org/show_bug.cgi?id=118898

        Reviewed by Darin Adler.

        Add a Base64FailOnInvalidCharacterOrExcessPadding value to the Base64DecodePolicy
        enumeration so that the caller can request strict padding validation in addition
        to strict character validation. This is needed so that we can use
        WTF::base64Decode() for window.atob().

        * wtf/text/Base64.cpp:
        (WTF::base64DecodeInternal):
        * wtf/text/Base64.h:

2013-08-07  Alex Christensen  <achristensen@apple.com>

        Fixed wrong definition for AppleWin port's WebGL after r153768.

        Rubberstamped by Benjamin Poulain.

        * wtf/Platform.h: Replaced WTF_USE_SURFACE with WTF_USE_GRAPHICS_SURFACE.

2013-08-04  Sam Weinig  <sam@webkit.org>

        Remove support for HTML5 MicroData
        https://bugs.webkit.org/show_bug.cgi?id=119480

        Reviewed by Anders Carlsson.

        * wtf/FeatureDefines.h:

2013-08-06  Alex Christensen  <achristensen@apple.com>

        Enabled WebGL on WinCairo port.
        https://bugs.webkit.org/show_bug.cgi?id=119502

        Reviewed by Benjamin Poulain.

        * wtf/FeatureDefines.h: Enabled WebGL.
        * wtf/Platform.h: Added definitions required for WebGL on Windows.

2013-08-05  Mark Rowe  <mrowe@apple.com>

        <rdar://problem/5927399> FastMalloc should support MallocStackLogging

        Call the malloc stack logging function from within the various entry points to FastMalloc
        when stack logging is enabled.

        Reviewed by Oliver Hunt and Geoff Garen.

        * wtf/FastMalloc.cpp:
        Call in to MallocHook::InvokeNewHook / MallocHook::InvokeDeleteHook at the appropriate entry
        points to FastMalloc. The naming comes from TCMalloc's existing, unused concept of malloc hooks.
        (WTF::MallocHook::record): Call the stack logging function with appropriate argument types.
        (WTF::MallocHook::recordAllocation): Out-of-line slow path for when stack logging is enabled
        that calls record with the values in the right arguments.
        (WTF::MallocHook::recordDeallocation): Ditto.
        (WTF::MallocHook::init): Stack logging is enabled if the system allocator has enabled stack logging.
        (WTF::MallocHook::InvokeNewHook): Call recordAllocation in the unlikely event that stack logging is
        enabled.
        (WTF::MallocHook::InvokeDeleteHook): Ditto for recordDeallocation.
        (WTF::TCMalloc_ThreadCache::InitModule): Initialize the malloc hook.

2013-08-06  Brent Fulgham  <bfulgham@apple.com>

        [Windows] Unreviewed build correction after r153754 and r153757.

        * wtf/MathExtras.h:
        (remainder): Provide implementation of C99 remainder for VS2010 (and earlier).

2013-07-23  David Farler  <dfarler@apple.com> 
        Provide optional OTHER_CFLAGS, OTHER_CPPFLAGS, OTHER_LDFLAGS additions for building with ASAN
        https://bugs.webkit.org/show_bug.cgi?id=117762

        Reviewed by Mark Rowe.

        * Configurations/DebugRelease.xcconfig:
        Add ASAN_OTHER_CFLAGS, CPLUSPLUSFLAGS.

2013-08-05  Mark Rowe  <mrowe@apple.com>

        Build fix for Qt Windows.

        * wtf/Assertions.cpp: Include StringExtras.h rather than StdLibExtras.h, since the former is where
        strncasecmp is declared.

2013-07-26  Mark Rowe  <mrowe@apple.com>

        Logging should be configurable using human-readable channel names rather than crazy bitmasks
        <http://webkit.org/b/119031>

        Implement shared logic for initializing logging channels based on human-readable channel names in WTF,
        and rework the WebCore, WebKit and WebKit2 logging initialization on top of it.

        Logging channels may now be enabled by providing a comma-separated list of channel names, with the special
        "all" name enabling all channels. Channel names prefixed with a leading "-" will result in the named channel
        being disabled. For instance, specifying "all,-history,-loading" will result in all logging channels except
        for history and loading being enabled.

        For OS X developers, this also changes the name of the user defaults used to enable logging. This is done to allow
        the old user defaults to remain set for those people that need to switch between version of WebKit before and
        after this change. Where the old user default keys were WebCoreLogLevel, WebKitLogLevel and WebKit2LogLevel,
        the new user default keys are WebCoreLogging, WebKitLogging and WebKit2Logging.

        For GTK developers, this changes the separator used in the WEBKIT_DEBUG environment variable to a comma for
        consistency with the other platforms and to enable more code sharing.

        While doing this work I've also taken the opportunity to eliminate the need to touch multiple files when
        adding a new logging channel. Now only the header in the relevant project needs to be updated.

        Reviewed by Sam Weinig.

        * wtf/Assertions.cpp:
        (WTFLogChannelByName): Iterate over the provided array of log channels, returning the first whose name
        matches case-insensitively.
        (setStateOfAllChannels): Helper function to set the state of all channels to a single value.
        (WTFInitializeLogChannelStatesFromString): Parse a string containing a case-insensitive, comma-separated list
        of channel names to enable or disable, with the latter being prefixed by a "-".
        * wtf/Assertions.h: Update the layout of WTFLogChannel to include only the state of the channel and its name.
        Declare WTFLogChannelByName and WTFInitializeLogChannelStatesFromString.
        * wtf/RefCountedLeakCounter.cpp: Update to the new format of WTFLogChannel.

2013-08-05  Benjamin Poulain  <bpoulain@apple.com>

        Disable <meter> by default on iOS, it is enabled through the xconfig files
        https://bugs.webkit.org/show_bug.cgi?id=119503

        Reviewed by Alexey Proskuryakov.

        * wtf/FeatureDefines.h:

2013-08-05  Oliver Hunt  <oliver@apple.com>

        Move TypedArray implementation into JSC
        https://bugs.webkit.org/show_bug.cgi?id=119489

        Reviewed by Filip Pizlo.

        Remove TypedArray implementation from WTF

        * GNUmakefile.list.am:
        * WTF.xcodeproj/project.pbxproj:
        * wtf/Forward.h:

2013-08-02  Benjamin Poulain  <benjamin@webkit.org>

        Remove a bunch of redundant checks for empty string in StringImpl
        https://bugs.webkit.org/show_bug.cgi?id=118768

        Reviewed by Ryosuke Niwa.

        The first thing done by createUninitialized() is check if the length passed
        is zero. Internally, there are many cases for which we know the check will never succeed.

        Clang is usually really smart for those kind of things, but there are a few cases where
        the condition to avoid returning empty() is not simply a check for the length.
        This patch adds an internal initializer to deal with that.

        * wtf/text/StringImpl.cpp:
        (WTF::StringImpl::createUninitializedInternal):
        (WTF::StringImpl::createUninitializedInternalNonEmpty):
        (WTF::StringImpl::createInternal): Create internal has a special case for null pointer
        for the characters. The test also check length, the second check for length cannot fail.
        (WTF::StringImpl::create8BitIfPossible): ditto.
        (WTF::StringImpl::lower): 3 of the calls cannot be reached for empty length. On an empty length,
        the test for (noUpper && !(ored & ~0x7F)) would have caused the function to return "this".

        For the last createUninitialized(), there is no guarantee the realLength is not zero.

        (WTF::StringImpl::replace): The first thing we do in replace(UChar,UChar) is check if there is anything
        to replace. The check for length will never succeed as there must be a character to replace at that point.
        * wtf/text/StringImpl.h:

2013-08-02  Mark Lam  <mark.lam@apple.com>

        Gardening: Touched a line in Platform.h to get all bots to do a clean build.

        Not reviewed.

        * wtf/Platform.h:

2013-08-02  Mikhail Pozdnyakov  <mikhail.pozdnyakov@intel.com>

        Check WTF::Vector size with '0' inline capacity
        https://bugs.webkit.org/show_bug.cgi?id=119397

        Reviewed by Andreas Kling.

        Putting in place the compile assertion that had been removed with r153514.

        * wtf/SizeLimits.cpp:

2013-07-26  Mark Rowe  <mrowe@apple.com>

        <http://webkit.org/b/119169> RetainPtr should support ARC for Objective-C objects.

        While RetainPtr is not necessary under ARC, having it available makes it easier to transition
        existing code from manual retain / release to ARC.

        Under ARC, the object member of RetainPtr is treated as a strong reference by the compiler.
        This means that merely assigning to the member variable is sufficient to retain the object,
        and clearing the member variable is sufficient to release it. We still need to explicitly
        CFRetain / CFRelease CoreFoundation types so the explicit calls to these functions are
        moved in to helper functions and overloading is used to have the Objective-C object versions
        of them be no-ops under ARC.

        Reviewed by Anders Carlsson.

        * wtf/RetainPtr.h:
        (WTF::retain): Continue to always CFRetain / CFRelease CoreFoundation objects. Only CFRetain / CFRelease
        Objective-C objects when using manual retain / release.
        (WTF::release): Ditto.
        (WTF::adoptNSReference): Adopting references will be handled automatically by the compiler
        when possible under ARC by eliminating redundant retain / release pairs.
        (WTF::RetainPtr::ImplicitConversionToBoolIsNotAllowed): A new method that exists only to be used by the
        conversion to the unspecified bool type.
        (WTF::RetainPtr::operator UnspecifiedBoolType): Switch to using a pointer to a member function as the
        unspecified bool type to avoid warnings from the compiler when casting Objective-C object types under ARC.

        (WTF::RetainPtr::RetainPtr): Switch to our retain / release helper functions.
        (WTF::RetainPtr::~RetainPtr): Ditto.
        (WTF::::RetainPtr): Ditto.
        (WTF::::clear): Ditto.
        (WTF::=): Ditto.
        (WTF::adoptCF): Annotate the argument with CF_RELEASES_ARGUMENT on both the declaration and the definition.
        (WTF::adoptNS): Ditto for NS_RELEASES_ARGUMENT.

2013-08-01  Mark Rowe  <mrowe@apple.com>

        <rdar://problem/14235491> FastMalloc zone enumerator responding to MALLOC_PTR_REGION_RANGE_TYPE with individual allocations

        Teach PageMapMemoryUsageRecorder::recordPendingRegions to only record data of the type that it's asked for.
        This also fixes the vmmap output to associate some regions with the FastMalloc malloc zone that were previously
        associated with it only via the VM tag, meaning they were incorrectly being omitted from the malloc statistics
        section of the report.

        Reviewed by Dan Bernstein.

        * wtf/FastMalloc.cpp:
        (WTF::PageMapMemoryUsageRecorder::recordPendingRegions): Report the individual allocations only when requested. Add
        the ability to report the regions containing pointers separately from the allocations.

2013-08-01  Mark Rowe  <mrowe@apple.com>

        <rdar://problem/14528244> False-positive leaks from FastMalloc.

        A logic error in the page map enumeration code within FastMalloc could result in a subset of the memory regions
        owned by FastMalloc being skipped by the malloc zone enumeration code used by leaks and other performance tools.
        If the only reference to an allocated object lived within one of the skipped memory regions, leaks would believe
        it had been leaked since it would not find any references to the object.

        The logic error manifested when a FastMalloc span owned a region of memory that crossed a 16MB address space boundary,
        and when there was one or more other spans immediately after it in the address space. Crossing the 16MB address space
        boundary means that the start and end points of the span are in different leaf nodes of the page map trie, and the
        code within the page map's visitValues method didn't correctly account this case when skipping to the end of the span
        after visiting it. It would resume iterating from the start of the next leaf node rather than continuing to skip values
        until the end of the span was passed. The value representing the end of the span would then be processed as if it were
        the start of a new span, and more values would be skipped even though they may contain actual spans.

        The solution is to rework the algorithm used in visitValues so that it will skip the correct number of values even when
        some of the values are in different leaf nodes. This is a more involved change than it may seem since it's also necessary
        to deal with the case where a memory region spans two separate root nodes, which can happen if the region happens to cross
        a 64GB boundary in the address space.

        Reviewed by Geoff Garen.

        * wtf/TCPageMap.h:
        (TCMalloc_PageMap3::visitValues): Use a single loop to iterate, with the loop index being the key in to the page map in the
        same form as used by get and set. This allows us to correctly deal with the index being skipped to a different intermediate or
        root node as a result of visiting a span that crosses a 16MB boundary in memory.
        (TCMalloc_PageMap2::visitValues): Ditto, but without having to deal with intermediate nodes.

2013-08-01  Ruth Fong  <ruth_fong@apple.com>

        [Forms: color] <input type='color'> popover color well implementation
        <rdar://problem/14411008> and https://bugs.webkit.org/show_bug.cgi?id=119356

        Reviewed by Benjamin Poulain.

        * wtf/FeatureDefines.h: Added and enabled INPUT_TYPE_COLOR_POPOVER.

2013-08-01  Simon Fraser  <simon.fraser@apple.com>

        REGRESSION(r145592): AutodrainedPool.h. RunLoopTimer.h, SchedulePair.h are being copied into the wrong location
        https://bugs.webkit.org/show_bug.cgi?id=112833

        Reviewed by Sam Weinig.
        
        AutodrainedPool.h and SchedulePair.h should just be project headers, not
        private headers, so they get copied into <build dir>/usr/local/include/wtf
        not <build dir>/usr/local/include

        * WTF.xcodeproj/project.pbxproj:

2013-07-31  Ruth Fong  <ruth_fong@apple.com>

        <input type=color> Mac UI behaviour
        <rdar://problem/10269922> and https://bugs.webkit.org/show_bug.cgi?id=61276

        Reviewed by Brady Eidson.

        * wtf/FeatureDefines.h: Enabled INPUT_TYPE_COLOR on Mac port.

2013-07-31  Andreas Kling  <akling@apple.com>

        Shrink Vectors with inline capacity.
        <http://webkit.org/b/119295>
        <rdar://problem/14598360>

        Reviewed by Anders Carlsson.

        Pack Vector::m_size next to VectorBufferBase::m_capacity so there's no space wasted
        on padding when sizeof(T) >= 8. Since m_size is not conceptually part of the buffer,
        I just using'ed it into Vector.

        * wtf/SizeLimits.cpp:
        * wtf/Vector.h:
        (WTF::VectorBufferBase::VectorBufferBase):
        (WTF::VectorBuffer::VectorBuffer):
        (WTF::Vector::Vector):
        (WTF::::Vector):

2013-07-30  Patrick Gansterer  <paroga@webkit.org>

        Move WindowsExtras.h from WebCore to WTF
        https://bugs.webkit.org/show_bug.cgi?id=118125

        Reviewed by Anders Carlsson.

        Move it to WTF to be able to use the functions in WTF too.

        * wtf/WindowsExtras.h: Renamed from Source/WebCore/platform/win/WindowsExtras.h.
        (WTF::getRegistryValue):
        (WTF::getWindowPointer):
        (WTF::setWindowPointer):
        * wtf/win/MainThreadWin.cpp:
        (WTF::initializeMainThreadPlatform):

2013-07-29  Carlos Garcia Campos  <cgarcia@igalia.com>

        Unreviewed. Fix make distcheck.

        * GNUmakefile.list.am: Add missing files to compilation.

2013-07-29  Mark Rowe  <mrowe@apple.com>

        <rdar://problem/14528244> Tons of FastMalloc leaks reported by leaks of objects that have already been deallocated

        Reviewed by Sam Weinig.

        * wtf/FastMalloc.cpp:
        (WTF::TCMalloc_Central_FreeList::enumerateFreeObjects): Mark objects in the transfer cache as being free.

2013-07-29  Zan Dobersek  <zdobersek@igalia.com>

        Reintroduce convenience CheckedInt*, CheckedUint* types
        https://bugs.webkit.org/show_bug.cgi?id=119213

        Reviewed by Oliver Hunt.

        Reintroduce CheckedInt* and CheckedUint* types that were previously provided for convenience
        through the CheckedInt header that was removed in r153095. The types are now based on the
        Checked class, using the RecordOverflow class as the overflow handler.

        * wtf/CheckedArithmetic.h:

2013-07-27  Ryosuke Niwa  <rniwa@webkit.org>

        REGRESSION(r153380): Can't open messages on Gmail
        https://bugs.webkit.org/show_bug.cgi?id=119165

        Reviewed by Andreas Kling.

        This bug was caused by r153380. The bug doesn't reproduce as long as WebKit is built by clang 4.2 and later
        or final is disabled (it could be clang 4.1 and later but we don't have information about that).

        Fix the bug by disabling final on earlier versions of clang. Unfortunately we can only check versions of
        Apple clang since __clang_major__ and __clang_minor__ are vendor dependent.

        * wtf/Compiler.h:

2013-07-26  Oliver Hunt <oliver@apple.com>

        ASSERT failure in wtf/CheckedBoolean.h line 43 on Windows
        https://bugs.webkit.org/show_bug.cgi?id=119170

        Reviewed by Michael Saboff.

        Added a copy constructor to CheckedBoolean.

        * wtf/CheckedBoolean.h:
        (CheckedBoolean::CheckedBoolean):

2013-07-25  Brent Fulgham  <bfulgham@apple.com>

        [Windows] Unreviewed build fix.

        * WTF.vcxproj/WTF.vcxproj: Add missing SixCharacterHash.h,.cpp files.
        * WTF.vcxproj/WTF.vcxproj.filters: Ditto.
        * wtf/NumberOfCores.h: Add export macro to numberOfProcessorCores.
        * wtf/PrintStream.h: Add export macro to dumpCharacter.
        * wtf/SixCharacterHash.h: Add export macro to sixCharacterHashStringToInteger
        and integerToSixCharacterHashString.
        * wtf/text/CString.h: Add export macro to hash and equal methods.
        (WTF::CStringHash::hash): Add export macro.

2013-07-25  peavo@outlook.com  <peavo@outlook.com>

        [Windows] Provide ASM implemenation of 8-bit compare-and-swap
        https://bugs.webkit.org/show_bug.cgi?id=119084

        Reviewed by Brent Fulgham.

        * wtf/Atomics.h:
        (WTF::weakCompareAndSwap): Add a 32-bit X86 Assembly path for
        Windows build.

2013-07-25  Brent Fulgham  <bfulgham@apple.com>

        [Windows] Unreviewed build fix.

        * WTF.vcxproj/WTF.vcxproj: Add missing CompilationThread.h,.cpp
        * WTF.vcxproj/WTF.vcxproj.filters: Ditto.

2013-07-25  Michael Brüning  <michael.bruning@digia.com>

        Fix Windows build after r153134.
        https://bugs.webkit.org/show_bug.cgi?id=119090

        Reviewed by Oliver Hunt.

        Add USE(PTHREADS) guards around pthread specific code
        for now. This will cause isCompilationThread to always
        return false on non pthread platforms such as Windows.

        We might be able to use the Windows one-time initialization
        for this, but this is only available from Windows Vista on.

        * wtf/CompilationThread.cpp:
        (WTF::initializeCompilationThreads):

2013-07-25  Allan Sandfeld Jensen  <allan.jensen@digia.com>

        Fix windows build after FTL upstream

        Unreviewed build fix.

        * wtf/Atomics.h:
        (WTF::weakCompareAndSwap):

2013-07-25  Ryuan Choi  <ryuan.choi@samsung.com>

        Unreviewed, build fix on the EFL port.

        * wtf/CMakeLists.txt: Added SixCharacterHash.cpp

2013-07-25  Gabor Rapcsanyi  <rgabor@webkit.org>

        Unreviewed, build fix on the Qt port.

        * WTF.pro: Add additional build files for the FTL.

2013-07-25  Zan Dobersek  <zdobersek@igalia.com>

        Unreviewed, further GTK build fixing.

        * GNUmakefile.am: Make libWTF.la depend on any changes made to the build targets list.
        * GNUmakefile.list.am: Add SixCharacterHash source files to the build.

2013-07-25  Csaba Osztrogonác  <ossy@webkit.org>

        [GTK] Similar fix to r153304.

        * GNUmakefile.list.am:

2013-07-25  Grzegorz Czajkowski  <g.czajkowski@samsung.com>

        Build break in debug after r153134: StringImpl.h:640: undefined reference to `WTF::isCompilationThread()
        https://bugs.webkit.org/show_bug.cgi?id=119077

        Reviewed by Christophe Dumez.

        * wtf/CMakeLists.txt:
        Added CompilationThread.{h/cpp}.

2013-07-24  Filip Pizlo  <fpizlo@apple.com>

        fourthTier: DFG IR dumps should be easier to read
        https://bugs.webkit.org/show_bug.cgi?id=119050

        Reviewed by Mark Hahnenberg.
        
        Added support for dumping values within a context. By default, if you say
        print(inContext(value, context)) it calls value.dumpInContext(out, context)
        instead of value.dump(out).
        
        Hoisted the support for six-character hashes out of JSC::CodeBlockHash into
        WTF, in the form of SixCharacterHash.h.
        
        Added a helper for creating dump contexts where the inContext() dump will
        just use a short string hash to "name" the object being dumped, and then
        will print out the full dumps in an endnote to your dump.
        
        Added support for using CString as a hashtable key.

        * WTF.xcodeproj/project.pbxproj:
        * wtf/PrintStream.h:
        (WTF):
        (ValueInContext):
        (WTF::ValueInContext::ValueInContext):
        (WTF::ValueInContext::dump):
        (WTF::inContext):
        * wtf/SixCharacterHash.cpp: Added.
        (WTF):
        (WTF::sixCharacterHashStringToInteger):
        (WTF::integerToSixCharacterHashString):
        * wtf/SixCharacterHash.h: Added.
        (WTF):
        * wtf/StringHashDumpContext.h: Added.
        (WTF):
        (StringHashDumpContext):
        (WTF::StringHashDumpContext::StringHashDumpContext):
        (WTF::StringHashDumpContext::getID):
        (WTF::StringHashDumpContext::dumpBrief):
        (WTF::StringHashDumpContext::brief):
        (WTF::StringHashDumpContext::isEmpty):
        (WTF::StringHashDumpContext::dump):
        * wtf/text/CString.cpp:
        (WTF::CString::hash):
        (WTF):
        (WTF::operator<):
        (WTF::CStringHash::equal):
        * wtf/text/CString.h:
        (WTF::CString::CString):
        (CString):
        (WTF::CString::isHashTableDeletedValue):
        (WTF):
        (WTF::CStringHash::hash):
        (CStringHash):

2013-07-21  Filip Pizlo  <fpizlo@apple.com>

        fourthTier: DFG Nodes should be able to abstractly tell you what they read and what they write
        https://bugs.webkit.org/show_bug.cgi?id=118910

        Reviewed by Sam Weinig.
        
        Fix compile goof in sortedListDump().

        * wtf/ListDump.h:
        (WTF::sortedListDump):

2013-07-16  Filip Pizlo  <fpizlo@apple.com>

        fourthTier: NaturalLoops should be able to quickly answer questions like "what loops own this basic block"
        https://bugs.webkit.org/show_bug.cgi?id=118750

        Reviewed by Mark Hahnenberg.
        
        Add a utility function for inserting an element into a vector that has bounded size,
        and where the insertion causes things to drop off the end.

        * wtf/StdLibExtras.h:
        (WTF):
        (WTF::insertIntoBoundedVector):

2013-07-12  Filip Pizlo  <fpizlo@apple.com>

        fourthTier: DFG should have an SSA form for use by FTL
        https://bugs.webkit.org/show_bug.cgi?id=118338

        Reviewed by Mark Hahnenberg.
        
        - Extend variadicity of PrintStream and dataLog.
        
        - Give HashSet the ability to add a span of things.
        
        - Give HashSet the ability to == another HashSet.
        
        - Note FIXME's in HashTable concerning copying performance, that affects
          the way that the DFG now uses HashSets and HashMaps.
        
        - Factor out the bulk-insertion logic of JSC::DFG::InsertionSet into
          WTF::Insertion, so that it can be used in more places.
        
        - Create a dumper for lists and maps.

        * WTF.xcodeproj/project.pbxproj:
        * wtf/DataLog.h:
        (WTF):
        (WTF::dataLog):
        * wtf/HashSet.h:
        (HashSet):
        (WTF):
        (WTF::::add):
        (WTF::=):
        * wtf/HashTable.h:
        (WTF::::HashTable):
        (WTF::=):
        * wtf/Insertion.h: Added.
        (WTF):
        (Insertion):
        (WTF::Insertion::Insertion):
        (WTF::Insertion::index):
        (WTF::Insertion::element):
        (WTF::Insertion::operator<):
        (WTF::executeInsertions):
        * wtf/ListDump.h: Added.
        (WTF):
        (ListDump):
        (WTF::ListDump::ListDump):
        (WTF::ListDump::dump):
        (MapDump):
        (WTF::MapDump::MapDump):
        (WTF::MapDump::dump):
        (WTF::listDump):
        (WTF::sortedListDump):
        (WTF::lessThan):
        (WTF::mapDump):
        (WTF::sortedMapDump):
        * wtf/PrintStream.h:
        (PrintStream):
        (WTF::PrintStream::print):

2013-07-02  Filip Pizlo  <fpizlo@apple.com>

        Unreviewed, fix 32-bit build.

        * wtf/Platform.h:

2013-07-02  Filip Pizlo  <fpizlo@apple.com>

        fourthTier: FTL should use the equivalent of llvm opt -O2 by default
        https://bugs.webkit.org/show_bug.cgi?id=118311

        Reviewed by Mark Hahnenberg.
        
        * wtf/LLVMHeaders.h:

2013-06-27  Filip Pizlo  <fpizlo@apple.com>

        fourthTier: JSC's disassembly infrastructure should be able to disassemble the code that LLVM generates
        https://bugs.webkit.org/show_bug.cgi?id=118148

        Reviewed by Anders Carlsson.
        
        We now use LLVM for two things: disassembler and FTL. Separate out the question
        of whether we have LLVM (HAVE(LLVM)) from whether we want to use the LLVM
        disassembler (USE(LLVM_DISASSEMBLER)) and whether we enable the FTL
        (ENABLE(FTL_JIT)).
        
        Also move the cruft for including LLVM headers into WTF since now we use it in
        a bunch of places, not all related to FTL. There's no obvious place to put that
        file in JSC so I put it in WTF.

        * WTF.xcodeproj/project.pbxproj:
        * wtf/LLVMHeaders.h: Copied from Source/JavaScriptCore/ftl/FTLLLVMHeaders.h.
        * wtf/Platform.h:

2013-06-25  Filip Pizlo  <fpizlo@apple.com>

        fourthTier: DFG should support switch_string
        https://bugs.webkit.org/show_bug.cgi?id=117967

        Reviewed by Sam Weinig.
        
        Make it possible to compare a RefPtr<StringImpl> and a StringImpl* without
        having to ref the StringImpl.

        * wtf/text/StringHash.h:
        (WTF::StringHash::equal):

2013-06-24  Filip Pizlo  <fpizlo@apple.com>

        fourthTier: Count external memory usage towards heap footprint
        https://bugs.webkit.org/show_bug.cgi?id=117948

        Reviewed by Geoffrey Garen.

        Expose some functionality needed for properly measuring StringImpl footprint.

        * wtf/Atomics.h:
        (WTF::weakCompareAndSwapSize):
        (WTF):
        * wtf/MathExtras.h:
        (divideRoundedUp):
        * wtf/text/StringImpl.h:
        (WTF::StringImpl::cost):
        (StringImpl):
        (WTF::StringImpl::costDuringGC):
        (WTF::StringImpl::refCount):

2013-06-23  Filip Pizlo  <fpizlo@apple.com>

        fourthTier: DFG should optimize identifier string equality
        https://bugs.webkit.org/show_bug.cgi?id=117920

        Reviewed by Sam Weinig.

        Note that this ChangeLog was supposed to be committed in r151890.
        
        Expose the IsIdentifier bit to the JIT.
        
        * wtf/text/StringImpl.h:
        (WTF::StringImpl::flagIsIdentifier):

2013-06-18  Filip Pizlo  <fpizlo@apple.com>

        fourthTier: DFG should have switch_char
        https://bugs.webkit.org/show_bug.cgi?id=117710

        Reviewed by Michael Saboff.
        
        I wanted to be able to say stringImpl->at(index), and now I can!

        Also made it possible to convert a UChar to a utf8 CString without
        allocating a StringImpl.

        * wtf/text/StringImpl.cpp:
        (WTF::StringImpl::utf8Impl):
        (WTF):
        (WTF::StringImpl::utf8ForCharacters):
        (WTF::StringImpl::utf8ForRange):
        * wtf/text/StringImpl.h:
        (StringImpl):
        (WTF::StringImpl::at):
        (WTF::StringImpl::operator[]):

2013-06-15  Filip Pizlo  <fpizlo@apple.com>

        fourthTier: Add CFG simplification for Switch
        https://bugs.webkit.org/show_bug.cgi?id=117677

        Reviewed by Mark Hahnenberg.

        * wtf/TriState.h:
        * wtf/text/StringImpl.h:

2013-06-15  Filip Pizlo  <fpizlo@apple.com>

        Printing a StringImpl* should really guard against NULL
        https://bugs.webkit.org/show_bug.cgi?id=117675

        Reviewed by Mark Hahnenberg.

        * wtf/PrintStream.cpp:
        (WTF::printInternal):

2013-06-11  Filip Pizlo  <fpizlo@apple.com>

        fourthTier: DFG should support op_in and it should use patching to make it fast
        https://bugs.webkit.org/show_bug.cgi?id=117385

        Reviewed by Geoffrey Garen.
        
        Now if you pass a null StringImpl* then something will still get printed instead
        of crashing. I figure that this is broadly useful for debug code, and I make use
        of it in the JSC portion of this patch.

        * wtf/PrintStream.cpp:
        (WTF::printInternal):

2013-06-09  Filip Pizlo  <fpizlo@apple.com>

        Unreviewed, fix build. On some compilers the automatic coercion from WTF::String to NSString*
        causes operator[] to appear ambiguous. One way around this is to make WTF::String behave like
        most of our other classes: at(unsigned) is always a valid synonym for operator[](unsigned).

        * wtf/text/WTFString.h:
        (WTF::String::at):
        (WTF::String::operator[]):

2013-06-08  Filip Pizlo  <fpizlo@apple.com>

        fourthTier: Recursive deadlock in DFG::ByteCodeParser
        https://bugs.webkit.org/show_bug.cgi?id=117376

        Reviewed by Mark Hahnenberg.
        
        I've often wanted to leave a lock early. Now I have that power!

        * wtf/Locker.h:
        (WTF::Locker::Locker):
        (WTF::Locker::~Locker):
        (Locker):
        (WTF::Locker::unlockEarly):
        (WTF::Locker::lock):

2013-05-27  Filip Pizlo  <fpizlo@apple.com>

        It should be possible to record heap operations (both FastMalloc and JSC GC)
        https://bugs.webkit.org/show_bug.cgi?id=116848

        Reviewed by Mark Hahnenberg.

        * WTF.xcodeproj/project.pbxproj:
        * wtf/DataLog.cpp:
        (WTF):
        (WTF::initializeLogFileOnce):
        * wtf/FastMalloc.cpp:
        (WTF::TCMalloc_ThreadCache::CreateCacheIfNecessary):
        * wtf/Platform.h:

2013-05-21  Filip Pizlo  <fpizlo@apple.com>

        fourthTier: DFG should be able to run on a separate thread
        https://bugs.webkit.org/show_bug.cgi?id=112839

        Reviewed by Geoffrey Garen.
        
        * wtf/ByteSpinLock.h:
        Make it non-copyable. We previously had bugs where we used ByteSpinLock as a locker.
        Clearly that's bad.

        * wtf/MetaAllocatorHandle.h:
        Make it thread-safe ref-counted, since we may now be passing them between the
        concurrent JIT thread and the main thread.

        * wtf/Vector.h:
        (WTF::Vector::takeLast):
        I've wanted this method for ages, and now I finally added.

2013-04-30  Filip Pizlo  <fpizlo@apple.com>

        fourthTier: DFG tries to ref/deref StringImpls in a ton of places
        https://bugs.webkit.org/show_bug.cgi?id=115300

        Reviewed by Geoffrey Garen.
        
        Make it possible to do more things directly to StringImpl*'s, including being
        able to directly do utf8 conversion on a substring without creating the
        substring first.
        
        Add assertions to StringImpl that it isn't being ref/deref'd from the
        compilation thread.

        * wtf/PrintStream.cpp:
        (WTF::printInternal):
        (WTF):
        * wtf/PrintStream.h:
        (WTF):
        (WTF::printInternal):
        * wtf/StringPrintStream.h:
        (WTF):
        (WTF::toCString):
        * wtf/text/StringImpl.cpp:
        (WTF::StringImpl::utf8ForRange):
        (WTF::StringImpl::utf8):
        (WTF):
        * wtf/text/StringImpl.h:
        (StringImpl):
        (WTF::StringImpl::hasAtLeastOneRef):
        (WTF::StringImpl::ref):
        (WTF::StringImpl::deref):

2013-04-29  Filip Pizlo  <fpizlo@apple.com>

        fourthTier: String::utf8() should also be available as StringImpl::utf8() so that you don't have to ref() a StringImpl just to get its utf8()
        https://bugs.webkit.org/show_bug.cgi?id=115393

        Reviewed by Geoffrey Garen.

        * WTF.xcodeproj/project.pbxproj:
        * wtf/text/ConversionMode.h: Added.
        (WTF):
        * wtf/text/StringImpl.cpp:
        (WTF):
        (WTF::putUTF8Triple):
        (WTF::StringImpl::utf8):
        * wtf/text/StringImpl.h:
        (StringImpl):
        * wtf/text/WTFString.cpp:
        (WTF):
        (WTF::String::utf8):
        * wtf/text/WTFString.h:
        (String):

2013-07-16  Oliver Hunt <oliver@apple.com>

        Merge dfgFourthTier r149301

    2013-04-28  Filip Pizlo  <fpizlo@apple.com>

        fourthTier: ASSERT that commonly used not-thread-safe methods in the runtime are not being called during compilation
        https://bugs.webkit.org/show_bug.cgi?id=115297

        Reviewed by Geoffrey Garen.
        
        Taught WTF the notion of compilation threads. This allows all parts of our stack
        to assert that we're not being called from a JSC compilation thread. This is in
        WTF because it will probably end up being used in StringImpl and WTFString.

        * WTF.xcodeproj/project.pbxproj:
        * wtf/CompilationThread.cpp: Added.
        (WTF):
        (WTF::initializeCompilationThreadsOnce):
        (WTF::initializeCompilationThreads):
        (WTF::isCompilationThread):
        (WTF::exchangeIsCompilationThread):
        * wtf/CompilationThread.h: Added.
        (WTF):
        (CompilationScope):
        (WTF::CompilationScope::CompilationScope):
        (WTF::CompilationScope::~CompilationScope):
        (WTF::CompilationScope::leaveEarly):

2013-07-16  Oliver Hunt <oliver@apple.com>

        Merge dfgFourthTier r148836

    2013-04-21  Filip Pizlo  <fpizlo@apple.com>

        fourthTier: It should be possible to query WatchpointSets, and add Watchpoints, even if the compiler is running in another thread
        https://bugs.webkit.org/show_bug.cgi?id=114909

        Reviewed by Oliver Hunt.
        
        Harden our notions of memory fences, now that we're doing racy algorithms.

        * wtf/Atomics.h:
        (WTF):
        (WTF::compilerFence):
        (WTF::armV7_dmb):
        (WTF::armV7_dmb_st):
        (WTF::loadLoadFence):
        (WTF::loadStoreFence):
        (WTF::storeLoadFence):
        (WTF::storeStoreFence):
        (WTF::memoryBarrierAfterLock):
        (WTF::memoryBarrierBeforeUnlock):
        (WTF::x86_mfence):

2013-07-16  Oliver Hunt <oliver@apple.com>

        Merge dfgFourthTier r148804

    2013-04-20  Filip Pizlo  <fpizlo@apple.com>

        fourthTier: value profiles and array profiles should be thread-safe enough to be accessible in a concurrent compilation thread
        https://bugs.webkit.org/show_bug.cgi?id=114906

        Reviewed by Oliver Hunt.
        
        Add ability to abstract whether or not the CodeBlock requires locking at all,
        since some platforms may not support the byte spin-locking and/or may not want
        to, if they turn off concurrent JIT.

        * WTF.xcodeproj/project.pbxproj:
        * wtf/ByteSpinLock.h:
        * wtf/NoLock.h: Added.
        (WTF):
        (NoLock):
        (WTF::NoLock::lock):
        (WTF::NoLock::unlock):
        (WTF::NoLock::isHeld):
        * wtf/Platform.h:

2013-04-17  Filip Pizlo  <fpizlo@apple.com>

        fourthTier: all inline caches should thread-safe enough to allow a concurrent compilation thread to read them safely
        https://bugs.webkit.org/show_bug.cgi?id=114762

        Reviewed by Mark Hahnenberg.
        
        Implemented a new spinlock that is optimized for compactness, by using just a byte.
        This will be useful as we start using fine-grained locking on a bunch of places.
        
        At some point I'll make these byte-sized spinlocks into adaptive mutexes, but for
        now I think it's fine to do the evil thing and use spinning particularly since we
        only use them for short critical sections.

        * WTF.xcodeproj/project.pbxproj:
        * wtf/Atomics.h:
        (WTF):
        (WTF::weakCompareAndSwap):
        * wtf/ByteSpinLock.h: Added.
        (WTF):
        (ByteSpinLock):
        (WTF::ByteSpinLock::ByteSpinLock):
        (WTF::ByteSpinLock::lock):
        (WTF::ByteSpinLock::unlock):
        (WTF::ByteSpinLock::isHeld):
        * wtf/ThreadingPrimitives.h:
        (WTF::pauseBriefly):
        (WTF):

2013-04-12  Filip Pizlo  <fpizlo@apple.com>

        fourthTier: FTL should have OSR exit
        https://bugs.webkit.org/show_bug.cgi?id=113623

        Reviewed by Oliver Hunt.
        
        Finally make toCString() somewhat variadic.

        * wtf/StringPrintStream.h:
        (WTF):
        (WTF::toCString):

2013-03-31  Filip Pizlo  <fpizlo@apple.com>

        https://bugs.webkit.org/show_bug.cgi?id=113656
        Fix Sam's nits.

        Unreviewed.
        
        Forgot to land these as part of http://trac.webkit.org/changeset/147299.

        * wtf/MathExtras.h:
        (isGreaterThanNonZeroPowerOfTwo):

2013-03-29  Filip Pizlo  <fpizlo@apple.com>

        fourthTier: FTL JIT should be able run some simple function
        https://bugs.webkit.org/show_bug.cgi?id=113481

        Reviewed by Geoffrey Garen.

        * wtf/Platform.h:

2013-07-22  Benjamin Poulain  <benjamin@webkit.org>

        String::lower() - Skip to slow path on the first failure
        https://bugs.webkit.org/show_bug.cgi?id=118885

        Reviewed by Andreas Kling.

        In the 8 bits case, we don't need to know the state of the full string before changing characters
        to their lowercase variant.
        Just fail immediately and start transforming characters from the point of failure.

        This avoid reading the string twice when the uppercase character is not at the end of the string.

        * wtf/text/StringImpl.cpp:
        (WTF::StringImpl::lower):

2013-07-22  Brent Fulgham  <bfulgham@apple.com>

        [Windows] Unreviewed build fix.

        * WTF.vcxproj/WTFGenerated.make: Stop triggering a "Build All" when things have not changed.

2013-07-19  Alex Christensen  <achristensen@apple.com>

        Added x64 configuration to Visual Studio build.
        https://bugs.webkit.org/show_bug.cgi?id=118888

        Reviewed by Brent Fulgham.

        * WTF.vcxproj/WTF.vcxproj:
        * WTF.vcxproj/WTF.vcxproj.filters:
        * WTF.vcxproj/WTFGenerated.vcxproj:

2013-07-18  Benjamin Poulain  <benjamin@webkit.org>

        Fix the build after r152881

        * wtf/text/StringImpl.cpp:
        (WTF::StringImpl::lower):

2013-07-18  Benjamin Poulain  <benjamin@webkit.org>

        Little cleaning of StringImpl::lower() and StringImpl::upper() for ARM
        https://bugs.webkit.org/show_bug.cgi?id=118831

        Reviewed by Gavin Barraclough.

        Clean lower() and upper() before trying some optimizations:
        -Prefix the code with the empty() case. Otherwise, each descending loop starts with
         a check for length == 0.
        -Change ored to a 32 bits registers. ARM only has 32 bits registers and access to full word.
         To keep the value a UChar, the compiler is adding a bunch of useless value & 0xffff in the loops.
        -Change the pointer based loops for index based loops. The compiler does a mighty job at optimizing
         those for each architecture. No need to make the code more complex.
        -Don't perform the check for int32 unless we need to. The only code limited to int is Unicode::toLower.

        * wtf/text/StringImpl.cpp:
        (WTF::StringImpl::lower):
        (WTF::StringImpl::upper):

2013-07-18  Andreas Kling  <akling@apple.com>

        CodeBlock::m_argumentValueProfiles wastes a lot of memory.
        <http://webkit.org/b/118852>
        <rdar://problem/14481659>

        Reviewed by Anders Carlsson.

        Add Vector::resizeToFit(size), like resize() but without growth padding.

        * wtf/Vector.h:
        (WTF::::resizeToFit):

2013-07-17  Benjamin Poulain  <benjamin@webkit.org>

        Add a thread safety assertion when creating an AtomicString from a StringImpl
        https://bugs.webkit.org/show_bug.cgi?id=118637

        Reviewed by Sam Weinig.

        The goal is to prevent this kind of use:
        -Someone create a String from a StringImpl.
        -At some point, the string becomes atomic.
        -Later, when the string only has one ref, its ownership is 'passed' to an other thread
         without checking String::isSafeToSendToAnotherThread().
        -In the thread B, an AtomicString is created from the String.
        ->The AtomicString's StringImpl returned is not in the current thread string table.

        * wtf/text/AtomicString.cpp:
        (WTF::AtomicString::isInAtomicStringTable):
        * wtf/text/AtomicString.h:
        (WTF::AtomicString::add):

2013-07-17  Benjamin Poulain  <benjamin@webkit.org>

        Simplify AtomicString::lower()
        https://bugs.webkit.org/show_bug.cgi?id=118719
        <rdar://problem/14452883>

        Reviewed by Gavin Barraclough.

        * wtf/text/AtomicString.cpp:
        (WTF::AtomicString::lower): Previously, the code was using a copy constructor for two path
        and one regular construction in another path.
        Just put the StringImpl where it needs to be instead.

2013-07-15  Benjamin Poulain  <benjamin@webkit.org>

        Add a threading assertion to AtomicString::remove
        https://bugs.webkit.org/show_bug.cgi?id=118695

        Reviewed by Sam Weinig.

        * wtf/text/AtomicString.cpp:
        (WTF::AtomicString::remove): The destructor of StringImpl remove
        the string from the string table if it is atomic. This needs to be done
        on the same thread as the one on which the string was added (otherwise the original
        table would keep a dangling pointer to a dead string).

2013-07-15  Benjamin Poulain  <benjamin@webkit.org>

        Minor cleaning of AtomicString::addSlowCase
        https://bugs.webkit.org/show_bug.cgi?id=118615

        Reviewed by Geoffrey Garen.

        Give the variable a proper name.
        Add assertions to clarify the in and out states.

        * wtf/text/AtomicString.cpp:
        (WTF::AtomicString::addSlowCase):

2013-07-12  Mikhail Pozdnyakov  <mikhail.pozdnyakov@intel.com>

        Improve StringImpl::constructInternal() method
        https://bugs.webkit.org/show_bug.cgi?id=118503

        Reviewed by Benjamin Poulain.

        StringImpl::constructInternal used 'if ()' statement to decide which constructor
        to invoke hence compiler had to compile both branches even though optimizer would
        have then removed one of those, and as the function is inline it could affect
        slightly the compilation time.

        The problem is solved via template specialization.

        * wtf/text/StringImpl.h:
        (WTF::LChar):
        (WTF::UChar):

2013-07-11  Patrick Gansterer  <paroga@webkit.org>

        Remove unused Windows CE files
        https://bugs.webkit.org/show_bug.cgi?id=118557

        Reviewed by Andreas Kling.

        * wtf/wince/FastMallocWinCE.h: Removed.
        * wtf/wince/MemoryManager.cpp: Removed.
        * wtf/wince/MemoryManager.h: Removed.

2013-07-10  Michael Brüning  <michael.bruning@digia.com>

        Workaround for x86 optimizer bug in MSVC 2012.
        https://bugs.webkit.org/show_bug.cgi?id=118478

        Reviewed by Benjamin Poulain.

        This is a workaround for a bug in the x86 MSVC 2012 optimizer.

        The problem is that the range comparison gets optimized out when
        the templated inline function toASCIIUpper. Copying the methods 
        content fixes the problem. 

        This is unfortunately not the nicest fix, but the alternative would
        be to turn off optimization for StringImpl::upper on the x86 MSVC 2012
        build, which might impact overall performance negatively.

        * wtf/text/StringImpl.cpp:
        (WTF::StringImpl::upper):

2013-07-08  Carlos Garcia Campos  <cgarcia@igalia.com>

        Unreviewed. Fix make distcheck.

        * GNUmakefile.list.am: Add missing header files.

2013-07-08  Antti Koivisto  <antti@apple.com>

        Add Deque::removeLast
        https://bugs.webkit.org/show_bug.cgi?id=118466

        Reviewed by Andreas Kling.
        
        Deque can remove both the first and the last element efficiently.
        
        Test: TestWebKitAPI/Tests/WTF/Deque.cpp

        * wtf/Deque.h:
        (WTF::::takeLast):
        (WTF::::removeLast):

2013-07-08  Zoltan Arvai  <zarvai@inf.u-szeged.hu>

        [Qt][Windows] Buildfix after r152426.

        Reviewed by Csaba Osztrogonác.

        * wtf/Platform.h: Do not include WTFHeaderDetection.h on Qt build.

2013-07-06  Benjamin Poulain  <benjamin@webkit.org>

        Fix the performance regressions introduced by r152418
        https://bugs.webkit.org/show_bug.cgi?id=118438

        Reviewed by Sam Weinig.

        * wtf/text/StringImpl.h:
        (WTF::equal):
        Looping between two arbitrary pointers prevents important loop
        optimizations.

2013-07-05  Brent Fulgham  <bfulgham@apple.com>

        [Windows] Unreviewed build correction.

        * WTF.vcxproj/WTFGenerated.make: Avoid syntax error in generated
        file in cases where Legible Output support is not present.

2013-07-05  Brent Fulgham  <bfulgham@apple.com>

        [Windows] Unreviewed build correction.

        * WTF.vcxproj/WTFGenerated.make: Use space (rather than double
        quotes) when handling the no-Legible-Output case.

2013-07-05  Brent Fulgham  <bfulgham@apple.com>

        [Windows] Identify OS-level at build-time.
        https://bugs.webkit.org/show_bug.cgi?id=118428

        Reviewed by Anders Carlsson.

        * WTF.vcxproj/WTFGenerated.make: Check for Legible Output featurs
        and set build environment as appropriate.
        * wtf/Platform.h: Activate Legible Output features if present.

2013-07-05  Mikhail Pozdnyakov  <mikhail.pozdnyakov@intel.com>

        A lot of code duplication within StringImpl 'equal' functions
        https://bugs.webkit.org/show_bug.cgi?id=118415

        Reviewed by Anders Carlsson.

        There has been a lot of code duplication within StringImpl 'equal' functions:
        the whole logic was copied to every overloaded 'equal' function.
        Fixed now using templates and std::equal.

        * wtf/text/StringImpl.cpp:
        (WTF::equalInternal):
        (WTF::equal):
        * wtf/text/StringImpl.h:
        (WTF::arraysEqual):
        (WTF::equal):

2013-07-05  Mikhail Pozdnyakov  <mikhail.pozdnyakov@intel.com>

        Remove code duplication from StringImpl create()/reallocate() methods
        https://bugs.webkit.org/show_bug.cgi?id=118355

        Reviewed by Andreas Kling.

        StringImpl create()/reallocate() methods accepting LChar and UChar used to have
        duplicated code. The code duplication is removed now via used templates.

        * wtf/text/StringImpl.cpp:
        (WTF::StringImpl::constructInternal):
        (WTF::LChar):
        (WTF::StringImpl::createUninitializedInternal):
        (WTF::StringImpl::createUninitialized):
        (WTF::StringImpl::reallocateInternal):
        (WTF::StringImpl::reallocate):
        (WTF::StringImpl::createInternal):
        (WTF::StringImpl::create):
        * wtf/text/StringImpl.h:

2013-07-03  Brent Fulgham  <bfulgham@apple.com>

        [Windows] Unreviewed build correction.

        * WTF.vcxproj/copy-files.cmd: Limit path (for this file) to DOS-only to avoid
        the Cygwin variant of rmdir from being used.

2013-07-03  Commit Queue  <commit-queue@webkit.org>

        Unreviewed, rolling out r152356.
        http://trac.webkit.org/changeset/152356
        https://bugs.webkit.org/show_bug.cgi?id=118361

        Broke JSCore tests (Requested by andersca on #webkit).

        * wtf/text/StringImpl.cpp:
        (WTF::StringImpl::createUninitialized):
        (WTF::StringImpl::reallocate):
        (WTF::StringImpl::create):
        * wtf/text/StringImpl.h:

2013-07-03  Mikhail Pozdnyakov  <mikhail.pozdnyakov@intel.com>

        Remove code duplication from StringImpl create()/reallocate() methods
        https://bugs.webkit.org/show_bug.cgi?id=118355

        Reviewed by Anders Carlsson.

        StringImpl create()/reallocate() methods accepting LChar and UChar used to have
        duplicated code. The code duplication is removed now via used templates.

        * wtf/text/StringImpl.cpp:
        (WTF::StringImpl::constructInternal):
        (WTF::LChar):
        (WTF::StringImpl::createUninitializedInternal):
        (WTF::StringImpl::createUninitialized):
        (WTF::StringImpl::reallocateInternal):
        (WTF::StringImpl::reallocate):
        (WTF::StringImpl::createInternal):
        (WTF::StringImpl::create):
        * wtf/text/StringImpl.h:

2013-07-03  Csaba Osztrogonác  <ossy@webkit.org>

        Fix cast-align warnings in FastMalloc.cpp
        https://bugs.webkit.org/show_bug.cgi?id=117991

        Reviewed by Mark Hahnenberg.

        * wtf/FastMalloc.cpp:

2013-07-02  Geoffrey Garen  <ggaren@apple.com>

        plainText() is O(N^2)
        https://bugs.webkit.org/show_bug.cgi?id=118282
        <rdar://problem/14284360>

        Reviewed by Alexey Proskuryakov.

        * wtf/text/StringBuilder.cpp:
        (WTF::expandCapacity): Factored out this helper function to simplify
        some code that was duplicated in four places.

        (WTF::StringBuilder::appendUninitializedSlow):
        (WTF::StringBuilder::append): Use expandCapacity(). One of the cases
        was not doing anything special, and so was O(N^2).

        Also, always call expandCapacity() it in a standard way, calling
        capacity() first, so it's easy to tell at a glance that you got it right.

2013-07-02  Mikhail Pozdnyakov  <mikhail.pozdnyakov@intel.com>

        Avoid code duplication inside String::append()
        https://bugs.webkit.org/show_bug.cgi?id=118290

        Reviewed by Anders Carlsson.

        The implementation of 'append(UChar)' had been repeated inside 'append(LChar)',
        this duplication is obviated now.

        * wtf/text/WTFString.cpp:
        (WTF::String::appendInternal):
        (WTF::String::append):
        * wtf/text/WTFString.h:

2013-06-28  Anders Carlsson  <andersca@apple.com>

        Remove String::deprecatedCharactersWithNullTermination() and related code
        https://bugs.webkit.org/show_bug.cgi?id=118211

        Reviewed by Benjamin Poulain.

        Remove String::deprecatedCharactersWithNullTermination, StringImpl::createWithTerminatingNullCharacter
        and the s_hashFlagHasTerminatingNullCharacter flag. We no longer care about whether strings have a
        terminating null character.

        * wtf/text/StringImpl.cpp:
        (WTF::StringImpl::createFromLiteral):
        (WTF::StringImpl::createWithoutCopying):
        (WTF::StringImpl::getData16SlowCase):
        (WTF::StringImpl::sizeInBytes):
        * wtf/text/StringImpl.h:
        (WTF::StringImpl::StringImpl):
        (WTF::StringImpl::createFromLiteral):
        (WTF::StringImpl::isolatedCopy):
        * wtf/text/WTFString.cpp:
        * wtf/text/WTFString.h:

2013-06-27  Anders Carlsson  <andersca@apple.com>

        Add a new String::charactersWithNullTermination() function that returns a vector
        https://bugs.webkit.org/show_bug.cgi?id=118155

        Reviewed by Andreas Kling.

        This new String::charactersWithNullTermination() function returns a new Vector<UChar>
        and does not modify the underlying string data.

        * wtf/text/WTFString.cpp:
        (WTF::String::charactersWithNullTermination):
        * wtf/text/WTFString.h:

2013-06-26  Anders Carlsson  <andersca@apple.com>

        Deprecate StringImpl::charactersWithNullTermination
        https://bugs.webkit.org/show_bug.cgi?id=118108

        Reviewed by Beth Dakin.

        The optimization in String and StringImpl to keep track of whether a string
        has a null terminator isn't worth it; in most cases we call charactersWithNullTermination() on
        temporary strings which ends up copying strings anyway.
        
        A better solution is to have a charactersWithNullTermination() function that returns a Vector<UChar>,
        which is similar to what we have for String::utf8() and String::ascii(). This will be done in a follow-up patch.

        * wtf/text/WTFString.cpp:
        (WTF::String::deprecatedCharactersWithNullTermination):
        * wtf/text/WTFString.h:

2013-06-26  Anders Carlsson  <andersca@apple.com>

        Add JSStringCreateWithCharactersNoCopy SPI
        https://bugs.webkit.org/show_bug.cgi?id=118074
        <rdar://problem/14279905>

        Reviewed by Geoffrey Garen.

        * wtf/text/StringImpl.cpp:
        (WTF::StringImpl::createFromLiteral):
        Use the new ConstructWithoutCopying constructor, passing DoesHaveTerminatingNullCharacter to it.
        Change the other createFromLiteral overload to just call the first.

        (WTF::StringImpl::createWithoutCopying):
        Add helper functions for creating strings that shouldn't copy their underlying data.

        * wtf/text/StringImpl.h:
        (WTF::StringImpl::StringImpl):
        Rename the ConstructFromLiteralTag constructor enum to ConstructWithoutCopyingTag. Change the constructor
        to take an enum that states whether the string has a terminating null character or not.

        (WTF::StringImpl::createFromLiteral):
        Call createWithoutCopying.

        (WTF::StringImpl::requiresCopy):
        Rename this from isASCIILiteral() and make it more generic so it can handle 16-bit strings as well.

        (WTF::StringImpl::isolatedCopy):
        If this string doesn't have to be copied, just create a new StringImpl object that references the current data.

2013-06-26  Jer Noble  <jer.noble@apple.com>

        Potential use-after-free after neutering AudioBuffer's underlying ArrayBuffer.
        https://bugs.webkit.org/show_bug.cgi?id=118040

        Reviewed by Filip Pizlo.

        Add support for 'unneuterable' ArrayBufferViews. Views marked as such will have their underlying
        ArrayBuffer objects copied rather than transferred to a new view.

        * wtf/ArrayBuffer.cpp:
        (WTF::ArrayBuffer::transfer): Check whether the associated views are neuterable, and if not
                clone the ArrayBuffer rather than transferring it.
        * wtf/ArrayBuffer.h:
        (WTF::ArrayBufferContents::copyTo): Added. Utility function.
        * wtf/ArrayBufferView.cpp:
        (WTF::ArrayBufferView::ArrayBufferView):
        (WTF::ArrayBufferView::neuter):
        * wtf/ArrayBufferView.h:
        (WTF::ArrayBufferView::setNeuterable):
        (WTF::ArrayBufferView::isNeuterable):

2013-06-26  Brent Fulgham  <bfulgham@apple.com>

        [Windows] Enable CaptionUserPreferenceMediaAF on Windows.
        https://bugs.webkit.org/show_bug.cgi?id=118076

        Reviewed by Eric Carlson.

        * wtf/Platform.h: Enable Media Accessibility Framework in Windows build environments
          that support it.

2013-06-24  Roger Fong  <roger_fong@apple.com>

        Unreviewed. AppleWin build fix, followup to r151915.

        * WTF.vcxproj/WTFProduction.props:

2013-06-24  Mikhail Pozdnyakov  <mikhail.pozdnyakov@intel.com>

        HashMap: reverse the order of the template arguments at alternate 'find', 'contains' and 'add' methods
        https://bugs.webkit.org/show_bug.cgi?id=117911

        Reviewed by Anders Carlsson.

        The order of the template arguments at HashMap alternate 'find', 'contains' and
        'add' methods is reversed so that callers can just pass the translator
        and let the compiler deduce input argument type.

        Another rational is consistency with HashSet class.

        * wtf/HashMap.h:

2013-06-24  peavo@outlook.com  <peavo@outlook.com>

        [WinCairo] WTF.dll is linking with CoreFoundation.lib in VS2010.
        https://bugs.webkit.org/show_bug.cgi?id=117294

        Reviewed by Brent Fulgham.

        WinCairo build should not use CoreFoundation.

        * WTF.vcxproj/WTFCFLite.props: Added.
        * WTF.vcxproj/WTFCommon.props: Remove CoreFoundation.lib from depencency list.
        * WTF.vcxproj/WTFCoreFoundation.props: Added.
        * WTF.vcxproj/WTFDebug.props: Import WTFCoreFoundation.props for WinApple.
        * WTF.vcxproj/WTFDebugWinCairo.props: Import WTFCFLite.props for WinCairo.
        * WTF.vcxproj/WTFRelease.props: Import WTFCoreFoundation.props for WinApple.
        * WTF.vcxproj/WTFReleaseWinCairo.props: Import WTFCFLite.props for WinCairo.

2013-06-17  Darin Adler  <darin@apple.com>

        Sort all the Xcode project files
        https://bugs.webkit.org/show_bug.cgi?id=117696

        Reviewed by Anders Carlsson.

        * WTF.xcodeproj/project.pbxproj: Ran the sort-Xcode-project-file script.

2013-06-20  Sergio Correia  <sergio.correia@openbossa.org>

        [WK2] Looping for EINTR on close() is incorrect for Linux, at least
        https://bugs.webkit.org/show_bug.cgi?id=117266

        Reviewed by Darin Adler.

        Added file UniStdExtras with a closeWithRetry() function that works around
        the EINTR behavior on Linux during a close() call: it closes the descriptor
        unconditionally even when the call is interrupted.

        * wtf/UniStdExtras.h: Added.
        (WTF::closeWithRetry): Wrapper around POSIX close() that handles EINTR
        correctly.

2013-06-20  Mark Lam  <mark.lam@apple.com>

        Refine the StackBounds computation for Windows.
        https://bugs.webkit.org/show_bug.cgi?id=117854.

        Reviewed by Brent Fulgham.

        * wtf/StackBounds.cpp:
        (WTF::StackBounds::initialize):

2013-06-20  Mark Lam  <mark.lam@apple.com>

        [Windows] Undoing r150621 to roll r150600 back in as the jsc test
        failures have been fixed in r151808.
        https://bugs.webkit.org/show_bug.cgi?id=116661.

        Reviewed by Brent Fulgham.

        * wtf/StackBounds.cpp:
        (WTF::StackBounds::initialize):

2013-06-20  Mikhail Pozdnyakov  <mikhail.pozdnyakov@intel.com>

        HashSet: reverse the order of the template arguments at alternate 'find', 'contains' and 'add' methods
        https://bugs.webkit.org/show_bug.cgi?id=117830

        Reviewed by Anders Carlsson.

        The order of the template arguments at HashSet alternate 'find', 'contains' and
        'add' methods is reversed so that callers can just pass the translator
        and let the compiler deduce input argument type.

        * wtf/HashSet.h:
        * wtf/text/AtomicString.cpp:
        (WTF::addToStringTable):
        (WTF::findString):

2013-06-20  Roger Fong  <roger_fong@apple.com>

        Make Windows makefile copy build output to a different folder.
        <rdar://problem/14219184>.

        * WTF.vcxproj/WTF.make:

2013-06-19  Geoffrey Garen  <ggaren@apple.com>

        Remove the SegmentedVector inline segment to shrink CodeBlock by 6X
        https://bugs.webkit.org/show_bug.cgi?id=117808

        Reviewed by Oliver Hunt.

        SegmentedVector allocation isn't super hot, but we do tend to have many
        live SegmentedVectors at runtime, particularly in CodeBlocks, so the
        right tradeoff is to allocate segments out-of-line as needed.

        This reduces startup memory usage @ google.com by about 6MB.

        No regression on SunSpider.

        * wtf/SegmentedVector.h:
        (WTF::SegmentedVector::SegmentedVector):
        (WTF::SegmentedVector::at):
        (WTF::SegmentedVector::append):
        (WTF::SegmentedVector::removeLast):
        (WTF::SegmentedVector::clear):
        (WTF::SegmentedVector::deleteAllSegments): No more inline segment.

        (WTF::SegmentedVector::ensureSegmentsFor): This code used to assume
        that there was always a 0 segment, so the math would underflow if there
        were no 0 segment. I udpated the math to account for having no segments.

2013-06-19  David Kilzer  <ddkilzer@apple.com>

        BUILD FIX (r151663): Fix build for iOS WebKit

        * wtf/text/AtomicStringTable.cpp: Include MainThread.h.
        (WTF::AtomicStringTable::create): Use AtomicStringTable::destroy
        instead of non-existent destroyAtomicStringTable function.

2013-06-18  Roger Fong  <roger_fong@apple.com>

        Replace tools32 folder with tools and update WebKit Windows solution accordingly.
        <rdar://problem/14118143>.

        Rubberstamped by Brent Fulgham.

        * WTF.vcxproj/WTF.vcxproj:
        * WTF.vcxproj/WTFDebug.props:
        * WTF.vcxproj/WTFDebugWinCairo.props:
        * WTF.vcxproj/WTFGenerated.vcxproj:
        * WTF.vcxproj/WTFGeneratedDebug.props:
        * WTF.vcxproj/WTFGeneratedProduction.props:
        * WTF.vcxproj/WTFGeneratedRelease.props:
        * WTF.vcxproj/WTFProduction.props:
        * WTF.vcxproj/WTFRelease.props:
        * WTF.vcxproj/WTFReleaseWinCairo.props:
        * WTF.vcxproj/work-around-vs-dependency-tracking-bugs.py:
        (react_to_vsprops_changes):

2013-06-18  Mikhail Pozdnyakov  <mikhail.pozdnyakov@intel.com>

        PackedIntVector: check template arguments at compile time
        https://bugs.webkit.org/show_bug.cgi?id=117737

        Use 'COMPILE_ASSERT' instead of 'ASSERT' in PackedIntVector class
        constructor.

        Reviewed by Sam Weinig.

        * wtf/PackedIntVector.h:
        (WTF::PackedIntVector::PackedIntVector):

2013-06-17  Andy Estes  <aestes@apple.com>

        A static_assert() in RetainPtr.h sometimes causes the build to fail.

        Wrap the first argument to a static_assert() in parentheses since it
        contains a comma, which sometimes tricks the preprocessor into thinking
        the macro is being passed three arguments rather than two.

        Reviewed by Brian Weinstein.

        * wtf/RetainPtr.h:
        (WTF::RetainPtr::RetainPtr):

2013-06-17  Zan Dobersek  <zdobersek@igalia.com>

        REGRESSION (r149184): Build errors in RefPtr.h when building with Clang, C++98 standard
        https://bugs.webkit.org/show_bug.cgi?id=116352

        Reviewed by Anders Carlsson.

        Use the __has_feature macro instead of the __has_extension one when detecting what features the Clang compiler
        that's being used is capable to provide. With the project moving onto using C++11 throughout its components,
        there currently exist cases where C++11-specific functionality (for instance std::move) is used despite being
        guarded by compiler-specific feature guards that still get enabled even when compiling in C++98 with Clang.
        The problematic features are enabled because they're available as C++98 language extensions by Clang.

        Using __has_feature instead enables the feature guard only if the tested feature is actually standardized in
        the currently used language standard.

        * wtf/Compiler.h:

2013-06-17  Ryosuke Niwa  <rniwa@webkit.org>

        Initialize AtomicStringTable in WTFThreadData's constructor
        https://bugs.webkit.org/show_bug.cgi?id=117671

        Reviewed by Geoffrey Garen.

        Extracted AtomicStringTable from AtomicString.cpp into AtomicStringTable.h/cpp
        and made WTFThreadDada::WTFThreadData create the atomic string table for the thread.

        This eliminates a branch from stringTable() in AtomicString.cpp.

        * GNUmakefile.list.am:
        * WTF.pro:
        * WTF.vcxproj/WTF.vcxproj:
        * WTF.vcxproj/WTF.vcxproj.filters:
        * WTF.xcodeproj/project.pbxproj:
        * wtf/CMakeLists.txt:
        * wtf/WTFThreadData.cpp:
        (WTF::WTFThreadData::WTFThreadData):
        * wtf/text/AtomicString.cpp:
        (WTF::stringTable):
        * wtf/text/AtomicStringTable.cpp: Added.
        (WTF::AtomicStringTable::create):
        (WTF::AtomicStringTable::destroy):
        * wtf/text/AtomicStringTable.h: Added.
        (WTF::AtomicStringTable::table):

2013-06-17  Roger Fong  <roger_fong@apple.com>

        Modify Windows makefiles to copy some bin output into Program Files.
        https://bugs.webkit.org/show_bug.cgi?id=117714.
        <rdar://problem/14179054>

        Reviewed by Brent Fulgham.

        * WTF.vcxproj/WTF.make:

2013-06-17  Grzegorz Czajkowski  <g.czajkowski@samsung.com>

        Unreviewed, rolling out r151632.
        http://trac.webkit.org/changeset/151632
        https://bugs.webkit.org/show_bug.cgi?id=117585

        Debug build error ASSERT(WTF_USE_GRAMMAR_CHECKING) for non MAC
        platforms

        * wtf/Platform.h:

2013-06-14  Grzegorz Czajkowski  <g.czajkowski@samsung.com>

        Context menu grammar checking items are available when GRAMMAR_CHECKING macro is off
        https://bugs.webkit.org/show_bug.cgi?id=117585

        Reviewed by Anders Carlsson.

        Enable GRAMMAR_CHECKING for WebKit ports that use/implement it.

        * wtf/Platform.h:

2013-06-14  Patrick Gansterer  <paroga@webkit.org>

        Introduce USE(WINGDI) for the Windows port
        https://bugs.webkit.org/show_bug.cgi?id=116138

        Reviewed by Ryosuke Niwa.

        Using USE(WINGDI) instead of OS(WINCE) will allow us to
        compile the GDI based Windows port on WinNT too.

        * wtf/Platform.h:

2013-06-13  Ryosuke Niwa  <rniwa@webkit.org>

        Remove LiteralIdentifierTable
        https://bugs.webkit.org/show_bug.cgi?id=117613

        Reviewed by Geoffrey Garen.

        Removed LiteralIdentifierTable since it doesn't seem to have any perf. impact now.

        * wtf/WTFThreadData.h:

2013-06-13  Brent Fulgham  <bfulgham@apple.com>

        [WinCairo] Correct FeatureDefines.h Default for ENABLE_VIEW_MODE_CSS_MEDIA
        https://bugs.webkit.org/show_bug.cgi?id=114396

        Reviewed by Dean Jackson.

        * wtf/FeatureDefines.h: The WinCairo port does not (currently) support Media elements,
        so make sure we do not enable this feature by default for that port.

2013-06-13  Brent Fulgham  <bfulgham@apple.com>

        [Windows] Unreviewed gardening.

        * WTF.vcxproj/WTF.vcxproj: Add FeatureDefines.h to visible files.
        * WTF.vcxproj/WTF.vcxproj.filters: Ditto.

2013-06-13  Gyuyoung Kim  <gyuyoung.kim@samsung.com>

        Optimize String::fromUTF8 for ASCII
        https://bugs.webkit.org/show_bug.cgi?id=117586

        Reviewed by Brent Fulgham.

        From Blink r152243 by <abarth@chromium.org>

        Current String::fromUTF8() implementation converts 8 bit ASCII character into 16 bit.
        Instead of always trying to convert into a 16 bit buffer, we can add a call to charactersAreAllASCII.
        In the common case when characters are ASCII, we directly copy it into an 8 bit string buffer.

        * wtf/text/WTFString.cpp:
        (WTF::String::fromUTF8):

2013-06-12  Brent Fulgham  <bfulgham@apple.com>

        [Windows] Activate supported C++11 Features for VS2010
        https://bugs.webkit.org/show_bug.cgi?id=117569

        Reviewed by Anders Carlsson.

        * wtf/Compiler.h: Turn on rvalue references and static_assert
        when compiling with VS2010 (or newer)

2013-06-07  Roger Fong  <roger_fong@apple.com>

        Unreviewed. Makefile fix. Copy WTF.dll over as well.

        * WTF.vcxproj/WTF.make:

2013-06-07  Commit Queue  <commit-queue@webkit.org>

        Unreviewed, rolling out r151318.
        http://trac.webkit.org/changeset/151318
        https://bugs.webkit.org/show_bug.cgi?id=117356

        Broke Windows Release Build (Requested by bfulgham on
        #webkit).

        * WTF.vcxproj/WTF.vcxproj:
        * WTF.vcxproj/WTFCommon.props:
        * WTF.vcxproj/WTFCoreFoundation.props: Removed.
        * WTF.vcxproj/WTFDebug.props:
        * WTF.vcxproj/WTFRelease.props:

2013-06-07  peavo@outlook.com  <peavo@outlook.com>

        [WinCairo] WTF.dll is linking with CoreFoundation.lib in VS2010.
        https://bugs.webkit.org/show_bug.cgi?id=117294

        Reviewed by Darin Adler.

        WinCairo build should not use CoreFoundation.

        * WTF.vcxproj/WTF.vcxproj: Exclude unneeded file from WinCairo build.
        * WTF.vcxproj/WTFCommon.props: Removed CoreFoundation.lib from common props.
        * WTF.vcxproj/WTFCoreFoundation.props: Added.
        * WTF.vcxproj/WTFDebug.props: Inherit from WTFCoreFoundations.props.
        * WTF.vcxproj/WTFRelease.props: Inherit from WTFCoreFoundations.props.

2013-06-06  Roger Fong  <roger_fong@apple.com>

        Unreviewed. Fix typo with winmm linker input.

        * WTF.vcxproj/WTFCommon.props:

2013-06-05  Benjamin Poulain  <bpoulain@apple.com>

        WebSQL forces 16-bit strings
        https://bugs.webkit.org/show_bug.cgi?id=116935

        Reviewed by Darin Adler.

        Merge chromium 49c9632ac135f6f06e623a7a81d9da1f6bb7196f.
        https://chromium.googlesource.com/chromium/blink/+/49c9632ac135f6f06e623a7a81d9da1f6bb7196f

        * wtf/text/StringImpl.cpp:
        (WTF::StringImpl::create8BitIfPossible):
        * wtf/text/StringImpl.h:
        (WTF::lengthOfNullTerminatedString):
        * wtf/text/WTFString.cpp:
        (WTF::String::String):

2013-06-03  Roger Fong  <roger_fong@apple.com>

        Nuke VS2005 files from the tree.
        <rdar://problem/14042021>.

        Rubberstamped by Brent Fulgham.

        * WTF.vcproj: Removed.
        * WTF.vcproj/WTF.make: Removed.
        * WTF.vcproj/WTF.sln: Removed.
        * WTF.vcproj/WTF.vcproj: Removed.
        * WTF.vcproj/WTFCommon.vsprops: Removed.
        * WTF.vcproj/WTFDebug.vsprops: Removed.
        * WTF.vcproj/WTFDebugAll.vsprops: Removed.
        * WTF.vcproj/WTFDebugCairoCFLite.vsprops: Removed.
        * WTF.vcproj/WTFGenerated.make: Removed.
        * WTF.vcproj/WTFGenerated.vcproj: Removed.
        * WTF.vcproj/WTFGeneratedCommon.vsprops: Removed.
        * WTF.vcproj/WTFGeneratedDebug.vsprops: Removed.
        * WTF.vcproj/WTFGeneratedDebugAll.vsprops: Removed.
        * WTF.vcproj/WTFGeneratedDebugCairoCFLite.vsprops: Removed.
        * WTF.vcproj/WTFGeneratedProduction.vsprops: Removed.
        * WTF.vcproj/WTFGeneratedRelease.vsprops: Removed.
        * WTF.vcproj/WTFGeneratedReleaseCairoCFLite.vsprops: Removed.
        * WTF.vcproj/WTFPostBuild.cmd: Removed.
        * WTF.vcproj/WTFPreBuild.cmd: Removed.
        * WTF.vcproj/WTFProduction.vsprops: Removed.
        * WTF.vcproj/WTFRelease.vsprops: Removed.
        * WTF.vcproj/WTFReleaseCairoCFLite.vsprops: Removed.
        * WTF.vcproj/build-generated-files.sh: Removed.
        * WTF.vcproj/copy-files.cmd: Removed.
        * WTF.vcproj/work-around-vs-dependency-tracking-bugs.py: Removed.

2013-06-03  Patrick Gansterer  <paroga@webkit.org>

        Unreviewed WinCE build fix after r150833.

        * wtf/DateMath.cpp:
        (WTF::calculateDSTOffset):

2013-06-03  Gyuyoung Kim  <gyuyoung.kim@samsung.com>

        [WTF] Add OwnArrayPtr vectortraits template 
        https://bugs.webkit.org/show_bug.cgi?id=117131

        Reviewed by Darin Adler.

        To support Vector<OwnArrayPtr<P>>, which will be used by EFL port.

        * wtf/VectorTraits.h:

2013-05-31  Rafael Brandao  <rafael.lobo@openbossa.org>

        Fix double hash lookup in PageMapMemoryUsageRecorder::visit
        https://bugs.webkit.org/show_bug.cgi?id=117071

        Reviewed by Andreas Kling.

        * wtf/FastMalloc.cpp:
        (WTF::TCMalloc_ThreadCache::CreateCacheIfNecessary):

2013-05-31  Brent Fulgham  <bfulgham@apple.com>

        [Windows] Speculative build fix for pre-VS2010 compilers

        * wtf/Platform.h: Only treat WTF as DLL for VS2010 builds

2013-05-31  Zan Dobersek  <zdobersek@igalia.com>

        Move MD5, SHA1 unit tests from WTF to TestWebKitAPI
        https://bugs.webkit.org/show_bug.cgi?id=116445

        Reviewed by Benjamin Poulain.

        Remove the MD5 and SHA1 test cases from the WTF code. The same cases are now built and run under TestWebKitAPI.

        * wtf/MD5.cpp:
        (WTF::MD5::MD5):
        * wtf/SHA1.cpp:
        (WTF::SHA1::SHA1):

2013-05-30  Roger Fong  <roger_fong@apple.com>

        Another unreviewed build fix for Mac.

        * wtf/text/WTFString.h:
        (WTF::String::fromUTF8WithLatin1Fallback):

2013-05-30  Roger Fong  <roger_fong@apple.com>

        Unreviewed build fix for Mac.

        * wtf/OSAllocator.h:
        * wtf/text/WTFString.h:
        (WTF::String::fromUTF8):

2013-05-30  Roger Fong  <roger_fong@apple.com>

        Get rid of JavaScript exports file on AppleWin port.
        https://bugs.webkit.org/show_bug.cgi?id=117050.

        Reviewed by Darin Adler.

        This requires turning WTF into a shared library and adding the WTF_EXPORT_PRIVATE to some methods where it was missed.

        * WTF.vcxproj/WTF.vcxproj:
        * WTF.vcxproj/WTFCommon.props:
        * wtf/DateMath.h:
        * wtf/ExportMacros.h:
        * wtf/FilePrintStream.h:
        * wtf/OSAllocator.h:
        * wtf/PageAllocationAligned.h:
        * wtf/Platform.h:
        * wtf/PrintStream.h:
        * wtf/StackBounds.h:
        * wtf/StringPrintStream.h:
        * wtf/ThreadSpecific.h:
        * wtf/WTFThreadData.h:
        * wtf/dtoa/cached-powers.h:
        * wtf/dtoa/double-conversion.h:
        * wtf/text/WTFString.h:
        * wtf/unicode/Collator.h:
        * wtf/unicode/UTF8.h:

2013-05-29  Kent Tamura  <tkent@chromium.org>

        Remove ENABLE_INPUT_MULTIPLE_FIELDS_UI.
        https://bugs.webkit.org/show_bug.cgi?id=116796

        Reviewed by Ryosuke Niwa.

        * wtf/FeatureDefines.h:

2013-05-27  Gavin Barraclough  <barraclough@apple.com>

        String(new Date(2010,10,1)) is wrong in KRAT, YAKT
        https://bugs.webkit.org/show_bug.cgi?id=106750

        Reviewed by Darin Adler.

        First part of a fix, simplfy date handling code, instead of operating separately
        on the UTC-standard and standard-DST offsets, just generate a combined UTC-local
        offset (this is what we actually need, and what the OS gives us).

        * wtf/DateMath.cpp:
        (WTF::calculateUTCOffset):
        (WTF::calculateDSTOffset):
            - made static, now not called from outside of this file.
        (WTF::calculateLocalTimeOffset):
            - This combines the 2038 related adjustment from calculateDSTOffset with the
              maxUnixTime adjustment from calculateDSTOffsetSimple. Then, if HAVE(TM_GMTOFF)
              just call getLocalTime, if not use calculateUTCOffset/calculateDSTOffset.
        (WTF::parseDateFromNullTerminatedCharacters):
            - call calculateLocalTimeOffset instead of calculateUTCOffset/calculateDSTOffset
        * wtf/DateMath.h:
        (WTF::LocalTimeOffset::LocalTimeOffset):
        (LocalTimeOffset):
        (WTF::LocalTimeOffset::operator==):
            - new struct type, a tuple of UTC-local offset & isDST flag.
            - replaced calculateUTCOffset/calculateDSTOffset with calculateLocalTimeOffset
        * wtf/GregorianDateTime.cpp:
        (WTF::GregorianDateTime::setToCurrentLocalTime):
            - call calculateLocalTimeOffset instead of calculateUTCOffset/calculateDSTOffset

2013-05-27  Patrick Gansterer  <paroga@webkit.org>

        Use correct stack size on Solaris and OpenBSD
        https://bugs.webkit.org/show_bug.cgi?id=114978

        Recommit after wrong rollout in r150621.

        * wtf/StackBounds.cpp:
        (WTF):
        (WTF::StackBounds::initialize):

2013-05-27  Patrick Gansterer  <paroga@webkit.org>

        Use ICU_INCLUDE_DIRS in BlackBerry CMake files
        https://bugs.webkit.org/show_bug.cgi?id=116210

        Reviewed by Rob Buis.

        Set and use the ICU_INCLUDE_DIRS variable to avoid
        duplicated adding of the ICU include directory.

        * wtf/PlatformBlackBerry.cmake:

2013-05-27  Ádám Kallai  <kadam@inf.u-szeged.hu>

        [Qt] Enable parallel GC. Probably it has been fixed in r131791.
        https://bugs.webkit.org/show_bug.cgi?id=90957

        Reviewed by Csaba Osztrogonác.

        * wtf/Platform.h:

2013-05-26  Patrick Gansterer  <paroga@webkit.org>

        [WINCE] Add wtf_bsearch()
        https://bugs.webkit.org/show_bug.cgi?id=116528

        Reviewed by Darin Adler.

        r149833 introduced usage of ::bsearch(), which does not exist on Windwos CE.
        Add our own implementation of this function as wtf_bsearch and define
        bsearch as wtf_bsearch to fix compilation on Windwos CE.

        * wtf/StdLibExtras.h:
        (wtf_bsearch):

2013-05-26  Kent Tamura  <tkent@chromium.org>

        Remove ENABLE_CALENDAR_PICKER
        https://bugs.webkit.org/show_bug.cgi?id=116795

        Reviewed by Ryosuke Niwa.

        * wtf/FeatureDefines.h:

2013-05-24  Benjamin Poulain  <bpoulain@apple.com>

        Inline TCMalloc_Central_FreeList's RemoveRange and FetchFromSpansSafe
        https://bugs.webkit.org/show_bug.cgi?id=116700

        Reviewed by Darin Adler.

        The two functions only have one call site each.

        * wtf/FastMalloc.cpp:
        (WTF::TCMalloc_Central_FreeList::RemoveRange):
        (WTF::TCMalloc_Central_FreeList::FetchFromSpansSafe):

2013-05-24  Filip Pizlo  <fpizlo@apple.com>

        We broke !(0/0)
        https://bugs.webkit.org/show_bug.cgi?id=116736

        Reviewed by Gavin Barraclough.

        * wtf/MathExtras.h:
        (isNotZeroAndOrdered):
        (isZeroOrUnordered):

2013-05-24  Anders Carlsson  <andersca@apple.com>

        Remove PagePopup code
        https://bugs.webkit.org/show_bug.cgi?id=116732

        Reviewed by Andreas Kling.

        Remove ENABLE_PAGE_POPUP.

        * wtf/FeatureDefines.h:

2013-05-25  Jer Noble  <jer.noble@apple.com>

        Mac: Set the default audio buffer size to a large value for <video> elements.
        https://bugs.webkit.org/show_bug.cgi?id=116342

        Reviewed by Eric Carlson.

        * wtf/Platform.h: Add a WTF_USE_AUDIO_SESSION setting.

2013-05-23  Brent Fulgham  <bfulgham@apple.com>

        [Windows] Rolling back r150600 as it breaks the VS2010 builds.

        * wtf/StackBounds.cpp: Rollback.

2013-05-23 Patrick Gansterer <paroga@webkit.org>

        Use correct stack size on Solaris and OpenBSD
        https://bugs.webkit.org/show_bug.cgi?id=114978

        Reviewed by Oliver Hunt.

        Original patch by David Hill <david@wmol.com>.

        Use stack_t.ss_size for getting the size of the stack.

        * wtf/Platform.h:
        * wtf/StackBounds.cpp:
        (WTF):
        (WTF::StackBounds::initialize):

2013-05-23  Patrick Gansterer  <paroga@webkit.org>

        [WIN] Implement correct detection of stack size
        https://bugs.webkit.org/show_bug.cgi?id=116661

        Reviewed by Oliver Hunt.

        * wtf/StackBounds.cpp:
        (WTF):
        (WTF::StackBounds::initialize):

2013-05-22  Dean Jackson  <dino@apple.com>

        Rolling out r150555. It borked about 30 media tests.

        * wtf/Platform.h:

2013-05-21  Anders Carlsson  <andersca@apple.com>

        Build fix.

        * wtf/NeverDestroyed.h:
        (NeverDestroyed):

2013-05-20  Anders Carlsson  <andersca@apple.com>

        Add WTF::NeverDestroyed and start using it in WTF
        https://bugs.webkit.org/show_bug.cgi?id=116472

        Reviewed by Benjamin Poulain.

        NeverDestroyed is a class template that can be used for singletons and other objects that we never
        want to destroy. It's intended as a replacement for WTF_STATIC_LOCAL with the advantage that it doesn't
        fragment the heap.

        * GNUmakefile.list.am:
        * WTF.vcproj/WTF.vcproj:
        * WTF.vcxproj/WTF.vcxproj:
        * WTF.vcxproj/WTF.vcxproj.filters:
        * WTF.xcodeproj/project.pbxproj:
        Add NeverDestroyed.h

        * wtf/Compiler.h:
        Add a helper macro, WTF_DELETED_FUNCTION.

        * wtf/CryptographicallyRandomNumber.cpp:
        Use NeverDestroyed.

        * wtf/NeverDestroyed.h: Added.

        * wtf/Noncopyable.h:
        Use WTF_DELETED_FUNCTION.

        * wtf/text/WTFString.cpp:
        (WTF::emptyString):
        Use 

2013-05-20  Zan Dobersek  <zdobersek@igalia.com>

        Use '__typeof__' keyword to avoid problems when compiling in C++11 standard compliance
        https://bugs.webkit.org/show_bug.cgi?id=116447

        Reviewed by Darin Adler.

        The 'typeof' keyword is a GNU C extension which becomes unavailable when compiling in ANSI or specific standard mode
        (such as -std=c++11). The '__typeof__' keyword should be used instead as it's available in all modes both under GCC and Clang.

        * wtf/FastMalloc.cpp:
        (WTF): Replace the 'typeof' keyword with '__typeof__'.

2013-05-19  Anders Carlsson  <andersca@apple.com>

        Remove link prerendering code
        https://bugs.webkit.org/show_bug.cgi?id=116415

        Reviewed by Darin Adler.

        This code was only used by Chromium and is dead now.

        * wtf/FeatureDefines.h:

2013-05-18  Patrick Gansterer  <paroga@webkit.org>

        [CMake] Replace *_LIBRARY_NAME with *_OUTPUT_NAME
        https://bugs.webkit.org/show_bug.cgi?id=114554

        Reviewed by Gyuyoung Kim.

        Using variables as target names is very uncommon in CMake.
        The usual way to specify the name of the resulting binary
        is to set the OUTPUT_NAME target property.

        * wtf/CMakeLists.txt:

2013-05-17  Andreas Kling  <akling@apple.com>

        Re-align the OS(AIX) macro...
        ...in the hopes that the resulting world rebuild will fix failures after r150294.

        * wtf/Platform.h:

2013-05-17  Anders Carlsson  <andersca@apple.com>

        WKKeyValueStorageManagerGetKeyValueStorageOrigins should get origins from the UI process
        https://bugs.webkit.org/show_bug.cgi?id=116346
        <rdar://problem/13852829>

        Reviewed by Andreas Kling.

        Add forward declaration for Function.

        * wtf/Forward.h:

2013-05-17  Patrick Gansterer  <paroga@webkit.org>

        [CMake] Remove invalid include paths
        https://bugs.webkit.org/show_bug.cgi?id=116213

        Reviewed by Gyuyoung Kim.

        Since "${JAVASCRIPTCORE_DIR}/wtf" does not exist, it is safe
        to remove them from the list of include directories.

        * wtf/PlatformEfl.cmake:
        * wtf/PlatformGTK.cmake:

2013-05-16  Benjamin Poulain  <bpoulain@apple.com>

        Add the symbol WTFInvokeCrashHook back for binary compatibility.

        Reviewed by Ryosuke Niwa.

        * wtf/Assertions.cpp:
        * wtf/Assertions.h:

2013-05-16  Seokju Kwon  <seokju.kwon@gmail.com>

        [CMAKE] Need to set WTF_LIBRARIES in wtf/CMakeLists.txt
        https://bugs.webkit.org/show_bug.cgi?id=116209

        Reviewed by Gyuyoung Kim.

        * wtf/CMakeLists.txt: Replace list with set.

2013-05-16  Benjamin Poulain  <benjamin@webkit.org>

        Crash properly on iOS
        https://bugs.webkit.org/show_bug.cgi?id=115782

        Reviewed by Darin Adler.

        Improve crash handling. <rdar://problem/13842771>

        * wtf/Assertions.cpp:
        * wtf/Assertions.h:

2013-05-15  Ryuan Choi  <ryuan.choi@samsung.com>

        Unreviewed build fix after r150123

        * wtf/CMakeLists.txt: 

2013-05-15  Oliver Hunt  <oliver@apple.com>

        RefCountedArray needs to use vector initialisers for its backing store
        https://bugs.webkit.org/show_bug.cgi?id=116194

        Reviewed by Gavin Barraclough.

        Use VectorOperations to operate on the backing store

        * wtf/RefCountedArray.h:
        (WTF::RefCountedArray::RefCountedArray):
        (WTF::RefCountedArray::operator=):
        (WTF::RefCountedArray::~RefCountedArray):

2013-05-15  Nico Weber  <thakis@chromium.org>

        WebKit doesn't support MSVS2003 any more, remove preprocessor checks for older versions.
        https://bugs.webkit.org/show_bug.cgi?id=116157

        Reviewed by Anders Carlsson.

        Also remove a gcc3.2 workaround.

        Merges parts of these two commits by the talented Nico Weber:
        https://chromium.googlesource.com/chromium/blink/+/3677e2f47348daeff405a40b6f90fbdf0654c2f5
        https://chromium.googlesource.com/chromium/blink/+/0fcd96c448dc30be1416dcc15713c53710c1a312

        * wtf/Alignment.h:
        (WTF):
        * wtf/Assertions.h:
        * wtf/Atomics.h:
        (WTF):
        * wtf/Compiler.h:
        * wtf/DateMath.cpp:
        (WTF::getLocalTime):
        * wtf/MathExtras.h:
        * wtf/RefCountedLeakCounter.h:
        (RefCountedLeakCounter):
        * wtf/StaticConstructors.h:

2013-05-15  Patrick Gansterer  <paroga@webkit.org>

        Consolidate lists in WTF CMake files
        https://bugs.webkit.org/show_bug.cgi?id=116142

        Reviewed by Martin Robinson.

        Move common files into the CMakeLists.txt to avoid duplicating the list of files.
        Also rebase the recently added GTK files to match the other CMake ports, since
        the submitted patch was based on an older version of the source tree.

        * wtf/CMakeLists.txt:
        * wtf/PlatformBlackBerry.cmake:
        * wtf/PlatformEfl.cmake:
        * wtf/PlatformGTK.cmake:
        * wtf/PlatformWinCE.cmake:

2013-05-14  Carlos Garcia Campos  <cgarcia@igalia.com>

        Remove WTF_USE_PLATFORM_STRATEGIES
        https://bugs.webkit.org/show_bug.cgi?id=114431

        Reviewed by Darin Adler.

        * wtf/Platform.h:

2013-05-14  Carlos Garcia Campos  <cgarcia@igalia.com>

        [BlackBerry] Use requestAnimationFrame for animations
        https://bugs.webkit.org/show_bug.cgi?id=115896

        Reviewed by Rob Buis.

        * wtf/Platform.h: Disable REQUEST_ANIMATION_FRAME_TIMER and
        WTF_USE_REQUEST_ANIMATION_FRAME_DISPLAY_MONITOR for BlackBerry
        port.

2013-05-14  Carlos Garcia Campos  <cgarcia@igalia.com>

        [BlackBerry] Implement platform strategies
        https://bugs.webkit.org/show_bug.cgi?id=112162

        Reviewed by Rob Buis.

        * wtf/Platform.h: Add BlackBerry platform to the list of platforms
        using platform strategies.

2013-05-13  Benjamin Poulain  <benjamin@webkit.org>

        Improve stringProtoFuncLastIndexOf for the prefix case
        https://bugs.webkit.org/show_bug.cgi?id=115952

        Reviewed by Geoffrey Garen.

        Add an optimized version of StringImpl::startsWith() for JavaScriptCore.

        * wtf/text/StringImpl.cpp:
        (WTF::StringImpl::startsWith):
        * wtf/text/StringImpl.h:
        (StringImpl):
        (WTF::StringImpl::startsWith):
        * wtf/text/WTFString.h:
        (WTF::String::startsWith):

2013-05-13  Carlos Garcia Campos  <cgarcia@igalia.com>

        Unreviewed. Fix Qt Linux MIPS32R2 build after r149879.

        Bring back GLIB_CHECK_VERSION for GBytes since Qt Linux MIPS32R2
        depends on glib 2.24.2.

        * wtf/gobject/GRefPtr.cpp:
        (_GBytes):
        (WTF::refGPtr):
        (WTF::derefGPtr):

2013-05-13  Anders Carlsson  <andersca@apple.com>

        Remove UnusedParam.h
        https://bugs.webkit.org/show_bug.cgi?id=116029

        Reviewed by Andreas Kling.

        Remove UnusedParam.h, it's empty now.

        * GNUmakefile.list.am:
        * WTF.pro:
        * WTF.vcproj/WTF.vcproj:
        * WTF.vcxproj/WTF.vcxproj:
        * WTF.vcxproj/WTF.vcxproj.filters:
        * WTF.xcodeproj/project.pbxproj:
        * wtf/CMakeLists.txt:
        * wtf/UnusedParam.h: Removed.

2013-05-13  Zalan Bujtas  <zalan@apple.com>

        WebProcess consuming very high CPU on linkedin.com
        https://bugs.webkit.org/show_bug.cgi?id=115601

        Reviewed by Andreas Kling.

        Disable WEB_TIMING_MINIMAL.
        Turn off window.performance and performance.now(). Some JS frameworks expect
        additional Web Timing APIs, when performance.now() is available.

        * wtf/FeatureDefines.h:

2013-05-12  Anders Carlsson  <andersca@apple.com>

        Stop including UnusedParam.h
        https://bugs.webkit.org/show_bug.cgi?id=116003

        Reviewed by Sam Weinig.

        UnusedParam.h is empty now so there's no need to include it anymore.

        * wtf/Atomics.h:
        * wtf/BoundsCheckedPointer.h:
        * wtf/DateMath.h:
        * wtf/FastMalloc.cpp:
        * wtf/NumberOfCores.cpp:
        * wtf/OSAllocator.h:
        * wtf/OSAllocatorPosix.cpp:
        * wtf/PageAllocation.h:
        * wtf/RefCounted.h:
        * wtf/TCSystemAlloc.cpp:
        * wtf/ThreadingPthreads.cpp:
        * wtf/Vector.h:
        * wtf/dtoa/cached-powers.cc:
        * wtf/dtoa/fixed-dtoa.cc:

2013-05-12  Anders Carlsson  <andersca@apple.com>

        Move UNUSED_PARAM and UNUSED_LABEL macros to Compiler.h
        https://bugs.webkit.org/show_bug.cgi?id=115997

        Reviewed by Benjamin Poulain.

        UnusedParam.h predates Compiler.h and the macros defined there should just go into Compiler.h

        * wtf/Compiler.h:
        (unusedParam):
        * wtf/UnusedParam.h:

2013-05-12  Anders Carlsson  <andersca@apple.com>

        Remove Complex.h from WTF
        https://bugs.webkit.org/show_bug.cgi?id=115989

        Reviewed by Beth Dakin.

        Complex.h contains a typedef and a single function (that already has an equivalent in the STL).
        The header is used by three files in WebCore, so just use std::complex<double> and std::polar directly.

        * GNUmakefile.list.am:
        * WTF.vcproj/WTF.vcproj:
        * WTF.vcxproj/WTF.vcxproj:
        * WTF.vcxproj/WTF.vcxproj.filters:
        * WTF.xcodeproj/project.pbxproj:
        * wtf/CMakeLists.txt:
        * wtf/Complex.h: Removed.

2013-05-11  Martin Robinson  <mrobinson@igalia.com>

        [GTK] Add a basic cmake build for WTF and JavaScriptCore
        https://bugs.webkit.org/show_bug.cgi?id=115967

        Reviewed by Laszlo Gombos.

        * wtf/PlatformGTK.cmake: Added.

2013-05-11  Martin Robinson  <mrobinson@igalia.com>

        Move defines to platform

        [GTK] Move defines that will never be configured to Platform.h
        https://bugs.webkit.org/show_bug.cgi?id=115965

        Reviewed by Andreas Kling.

        * wtf/Platform.h: Add new defines that were previously in the autoconf header.

2013-05-12  Anders Carlsson  <andersca@apple.com>

        Simplify AutodrainedPool
        https://bugs.webkit.org/show_bug.cgi?id=115986

        Reviewed by Andreas Kling.

        Remove the ability to cycle an AutodrainedPool, as well as the iteration count.
        Creating and draining pools is fast enough now that we don't need to try to be clever about it.

        * wtf/AutodrainedPool.h:
        (AutodrainedPool):
        (WTF::AutodrainedPool::AutodrainedPool):
        * wtf/AutodrainedPoolMac.mm:
        (WTF::AutodrainedPool::AutodrainedPool):

2013-05-12  Anders Carlsson  <andersca@apple.com>

        Move RemoteMemoryReader into FastMalloc.cpp
        https://bugs.webkit.org/show_bug.cgi?id=115985

        Reviewed by Andreas Kling.

        RemoteMemoryReader is only used in FastMalloc.cpp, and even had one of its member functions
        implemented there, so move the entire class template there and remove MallocZoneSupport.h.

        * GNUmakefile.list.am:
        * WTF.pro:
        * WTF.vcproj/WTF.vcproj:
        * WTF.vcxproj/WTF.vcxproj:
        * WTF.vcxproj/WTF.vcxproj.filters:
        * WTF.xcodeproj/project.pbxproj:
        * wtf/CMakeLists.txt:
        * wtf/FastMalloc.cpp:
        (WTF):
        (PageHeapAllocator):
        (WTF::TCMalloc_ThreadCache::CreateCacheIfNecessary):
        * wtf/MallocZoneSupport.h: Removed.

2013-05-10  Laszlo Gombos  <l.gombos@samsung.com>

        Remove USE(OS_RANDOMNESS)
        https://bugs.webkit.org/show_bug.cgi?id=108095

        Reviewed by Darin Adler.

        Remove the USE(OS_RANDOMNESS) guard as it is turned on for all
        ports.

        * wtf/CryptographicallyRandomNumber.cpp:
        (WTF::cryptographicallyRandomValues):
        * wtf/CryptographicallyRandomNumber.h:
        * wtf/OSRandomSource.cpp:
        (WTF::cryptographicallyRandomValuesFromOS):
        * wtf/OSRandomSource.h:
        * wtf/Platform.h:
        * wtf/RandomNumber.cpp:
        (WTF::randomNumber):
        * wtf/RandomNumber.h:
        * wtf/RandomNumberSeed.h:
        (WTF::initializeRandomNumberGenerator):

2013-05-10  Carlos Garcia Campos  <cgarcia@igalia.com>

        [GTK] Remove unnecessary GLIB_CHECK_VERSION #ifdefs
        https://bugs.webkit.org/show_bug.cgi?id=115904

        Reviewed by Martin Robinson.

        * wtf/gobject/GRefPtr.cpp:

2013-05-09  Darin Adler  <darin@apple.com>

        RenderQuote has giant function for language to quotes map
        https://bugs.webkit.org/show_bug.cgi?id=115807

        Reviewed by Anders Carlsson.

        * wtf/unicode/CharacterNames.h: Added a couple of character names.

2013-05-08  Michael Saboff  <msaboff@apple.com>

        JSC: There should be a disassembler for ARM Thumb 2
        https://bugs.webkit.org/show_bug.cgi?id=115827

        Reviewed by Filip Pizlo.

        Added a new disassembler for ARMv7 Thumb2 instructions for use by the JSC debugging
        and profiling code.  Enabled the disassembler for IOS bulds.

        * wtf/Platform.h:

2013-05-08  Mikhail Pozdnyakov  <mikhail.pozdnyakov@intel.com>

        Simplify RetainPtrObjectHashTraits
        https://bugs.webkit.org/show_bug.cgi?id=115822

        Reviewed by Benjamin Poulain.

        RetainPtrObjectHashTraits is inherited from SimpleClassHashTraits
        instead of GenericHashTraits re-using more shared functionality.

        * wtf/RetainPtr.h:
        (WTF::RetainPtrObjectHashTraits::emptyValue):

2013-05-08  Anders Carlsson  <andersca@apple.com>

        Assert at compile time that we don't pass Objective-C object pointers to adoptCF
        https://bugs.webkit.org/show_bug.cgi?id=115823

        Reviewed by Geoffrey Garen.

        static_assert in adoptCF that the object passed in is not an Objective-C object.
        * wtf/RetainPtr.h:

2013-05-08  Anders Carlsson  <andersca@apple.com>

        Remove RetainPtr::adoptNS and RetainPtr::adoptCF
        https://bugs.webkit.org/show_bug.cgi?id=115817

        Reviewed by Jessie Berlin.

        These functions are now unused so remove them. The preferred way to create a RetainPtr with an
        adopted reference is to use the adoptNS/adoptCF free functions.
        
        Rewrite the move assignment operators to just call CFRelease explicitly.

        * wtf/RetainPtr.h:

2013-05-08  Anders Carlsson  <andersca@apple.com>

        Remove ThreadingNone.cpp

        Rubber-stamped by Beth Dakin.

        ThreadingNone.cpp is empty and not used anywhere.

        * wtf/ThreadingNone.cpp: Removed.

2013-05-08  Anders Carlsson  <andersca@apple.com>

        Remove HashMap::deleteAllKeys
        https://bugs.webkit.org/show_bug.cgi?id=115806

        Reviewed by Brent Fulgham.

        This function was not used anywhere so let's get rid of it.

        * wtf/HashMap.h:

2013-05-08  Eric Carlson  <eric.carlson@apple.com>

        [Mac] Inband text tracks are not in track menu on Lion
        https://bugs.webkit.org/show_bug.cgi?id=115740

        Reviewed by Dean Jackson.

        * wtf/Platform.h: AVFOUNDATION_TEXT_TRACK_SUPPORT -> AVFOUNDATION_MEDIA_SELECTION_GROUP

2013-05-08  Mikhail Pozdnyakov  <mikhail.pozdnyakov@intel.com>

        HashTraits<RefPtr<P> >::peek should consider empty value
        https://bugs.webkit.org/show_bug.cgi?id=115799

        Reviewed by Darin Adler.

        HashTraits<RefPtr<P> >::peek() should consider passing of empty value which is
        raw pointer equal to '0', and return it right away instead of converting it to RefPtr
        and invoking get().

        * wtf/HashTraits.h:

2013-05-08  Mikhail Pozdnyakov  <mikhail.pozdnyakov@intel.com>

        Avoid unnecessary arguments copying inside GenericHashTraits methods
        https://bugs.webkit.org/show_bug.cgi?id=115733

        Reviewed by Darin Adler.

        Before the change both WTF::GenericHashTraits::passOut and WTF::GenericHashTraits::passOut
        used to return the given argument always by value and that caused implicit extra
        copying of the argument. It was OK as long as argument type T was POD, as compiler
        could optimize it, but in case T was a class having non-trivial copy constructor the
        extra copying of the argument could not have been obviated.

        The proposed solution is to provide overloaded functions that accept non-temporary
        values and return them by reference thus avoiding extra copying.

        The proposed solution made an impact on the size of libjavascriptcore_efl.so (EFL
        release build): the size decreased from 6554992 bytes to 6554560 bytes.

        * wtf/HashTraits.h:
        (WTF::GenericHashTraits::passOut): 
        (WTF::GenericHashTraits::peek):

2013-05-07  Anders Carlsson  <andersca@apple.com>

        Remove AlwaysInline.h from WTF
        https://bugs.webkit.org/show_bug.cgi?id=115727

        Reviewed by Brent Fulgham.

        The macro that used to be in AlwaysInline.h is now in Compiler.h so there's no reason
        to keep AlwaysInline.h around anymore.

        * WTF.vcproj/WTF.vcproj:
        * WTF.vcxproj/WTF.vcxproj:
        * WTF.vcxproj/WTF.vcxproj.filters:
        * WTF.xcodeproj/project.pbxproj:
        * wtf/AlwaysInline.h: Removed.
        * wtf/BloomFilter.h:
        * wtf/FastMalloc.cpp:
        * wtf/PassRefPtr.h:
        * wtf/dtoa.cpp:
        * wtf/gobject/GRefPtr.h:

2013-05-07  Mikhail Pozdnyakov  <mikhail.pozdnyakov@intel.com>

        HashTraits<RefPtr<P> >::PeekType should be raw pointer for better performance
        https://bugs.webkit.org/show_bug.cgi?id=115646

        Reviewed by Darin Adler.

        HashTraits<RefPtr<P> >::PeekType should be raw pointer so that we
        can obviate multiple RefPtr copying when invoking HashMap<.., RefPtr>::get()
        method.

        * wtf/HashTraits.h:

2013-05-06  Cosmin Truta  <ctruta@blackberry.com>

        Cherry-pick fixes to bignum from upstream
        https://bugs.webkit.org/show_bug.cgi?id=115658

        Reviewed by Darin Adler.

        Cherry-picked the following change lists:

        Fix bug in bignum implementation
        http://codereview.chromium.org/13454019

        Make VS2005 project files compile without errors
        http://codereview.chromium.org/6286135

        * wtf/dtoa/bignum.cc:

2013-05-06  Mikhail Pozdnyakov  <mikhail.pozdnyakov@intel.com>

        Change HashTraits<RefPtr<P> >::PassOutType to PassRefPtr for better performance
        https://bugs.webkit.org/show_bug.cgi?id=115410

        Reviewed by Darin Adler.

        The type HashTraits<RefPtr<P> >::PassOutType is PassRefPtr now to
        avoid extra ref/unrefing on return from HashMap methods that transfer
        ownership, such as take.

        * wtf/HashTable.h:
        (WTF::IdentityHashTranslator::equal):
        * wtf/HashTraits.h:

2013-05-05  Anders Carlsson  <andersca@apple.com>

        Remove Vector::prepend
        https://bugs.webkit.org/show_bug.cgi?id=115618

        Reviewed by Geoffrey Garen.

        Given the performance characteristics of prepending something to a Vector, not having prepend
        will hopefully make developers think about whether prepending is necessary at all. For example,
        the functions in HexNumber.h were easily converted to using Vector::append and then Vector::reverse.

        * wtf/HexNumber.h:
        (WTF::appendUnsignedAsHex):
        (WTF::appendUnsignedAsHexFixedSize):
        * wtf/Vector.h:
        (Vector):

2013-05-05  Anders Carlsson  <andersca@apple.com>

        Remove the Vector::append overload that takes a Vector
        https://bugs.webkit.org/show_bug.cgi?id=115535

        Reviewed by Andreas Kling.

        The Vector::append overload that takes a Vector conflicts with rvalues in C++11, so remove it and
        replace calls to it with calls to appendVector.

        * wtf/Vector.h:
        (Vector):

2013-05-04  Andreas Kling  <akling@apple.com>

        Unreviewed, rolling out r149563.
        http://trac.webkit.org/changeset/149563
        https://bugs.webkit.org/show_bug.cgi?id=115587

        Broke LLInt build.

        * wtf/text/StringImpl.h:
        (StringImpl):

2013-05-04  Xan Lopez  <xlopez@igalia.com>

        No need to declare JSC::LLInt::Data as friend class of WTF::StringImpl
        https://bugs.webkit.org/show_bug.cgi?id=115587

        Reviewed by Andreas Kling.

        No need to declare LLInt::Data as friend class of WTF::StringImpl,
        it does not use any private method/data member of the latter.

        * wtf/text/StringImpl.h:
        (StringImpl):

2013-05-03  Brent Fulgham  <bfulgham@webkit.org>

        Make ThreadFunctionInvocation fast allocated.
        https://bugs.webkit.org/show_bug.cgi?id=115552

        Reviewed by Benjamin Poulain.

        * wtf/ThreadFunctionInvocation.h:
        (ThreadFunctionInvocation): Make Fast-allocated.

2013-05-03  Mikhail Pozdnyakov  <mikhail.pozdnyakov@intel.com>

        Remove WTF::ListRefPtr class
        https://bugs.webkit.org/show_bug.cgi?id=115516

        Reviewed by Anders Carlsson.

        ListRefPtr was used only by FontFamily class, besides it strongly depended
        on FontFamily class semantics which made it non-generic and inappropriate
        for being present inside WTF.

        This patch removes WTF::ListRefPtr class and moves its the functionality
        into FontFamily class.

        * GNUmakefile.list.am:
        * WTF.pro:
        * WTF.vcproj/WTF.vcproj:
        * WTF.vcxproj/WTF.vcxproj:
        * WTF.vcxproj/WTF.vcxproj.filters:
        * WTF.xcodeproj/project.pbxproj:
        * wtf/CMakeLists.txt:
        * wtf/Forward.h:
        (WTF):
        * wtf/ListRefPtr.h: Removed.

2013-05-02  Brent Fulgham  <bfulgham@webkit.org>

        [WinCairo] Unreviewed build fix.

        * WTF.vcxproj/WTF.vcxproj: Use WinCairo FeatureDefines
        * WTF.vcxproj/WTF.vcxproj.filters: Use WinCairo FeatureDefines
        * WTF.vcxproj/WTFDebugWinCairo.props: Added.
        * WTF.vcxproj/WTFReleaseWinCairo.props: Added.

2013-05-02  Brent Fulgham  <bfulgham@webkit.org>

        [Windows, WinCairo] Fix crash in fast/js/create-lots-of-workers.html
        https://bugs.webkit.org/show_bug.cgi?id=115130

        Reviewed by Tim Horton.

        Windows is suffering from mismatched allocation/deallocation
        between the system allocator and fastMalloc/fastFree.  By turning
        off the global switch to fastMalloc, only classes specified to
        honor fastMalloc/fastFree are affected, and other memory allocation
        and freeing is done with consistent library calls.

        * wtf/Platform.h: Deactivate ENABLE_GLOBAL_FASTMALLOC_NEW for
        the Windows build.

2013-05-02  Eric Carlson  <eric.carlson@apple.com>

        Caption menu does not include in-band captions
        https://bugs.webkit.org/show_bug.cgi?id=111934

        Reviewed by Dean Jackson.

        * wtf/Platform.h: Define HAVE_AVFOUNDATION_TEXT_TRACK_SUPPORT on 10.8 and higher. Added
            HAVE_AVFOUNDATION_LEGIBLE_OUTPUT_SUPPORT.

2013-05-02  Brent Fulgham  <bfulgham@webkit.org>

        Make BloomFilter fast allocated.
        https://bugs.webkit.org/show_bug.cgi?id=115519

        Reviewed by Benjamin Poulain.

        * wtf/BloomFilter.h:
        (BloomFilter): Make BloomFilter Fast-allocated.

2013-05-01  Michael Saboff  <msaboff@apple.com>

        FastMalloc.cpp should use system defined page size instead of literal constant
        https://bugs.webkit.org/show_bug.cgi?id=115502

        Reviewed by Geoffrey Garen.

        Updated kPageShift to be PAGE_SHIFT for Mac.  Changed kMaxSize to be fixed at 32K.
        Updated kNumClasses for 4K and 16K page sizes.

        * wtf/FastMalloc.cpp:
        kPageShift: Changed this to be PAGE_SHIFT on mac.

2013-05-01  Roger Fong  <roger_fong@apple.com>

        Set Path in makefile for AppleWin.

        * WTF.vcxproj/WTF.make:

2013-05-01  Anders Carlsson  <andersca@apple.com>

        Add FunctionDispatcher class and make RunLoop derive from it
        https://bugs.webkit.org/show_bug.cgi?id=115480

        Reviewed by Sam Weinig.

        Add FunctionDispatcher files.

        * WTF.pro:
        * WTF.vcproj/WTF.vcproj:
        * WTF.vcxproj/WTF.vcxproj:
        * WTF.xcodeproj/project.pbxproj:
        * wtf/FunctionDispatcher.cpp: Added.
        (WTF::FunctionDispatcher::FunctionDispatcher):
        (WTF::FunctionDispatcher::~FunctionDispatcher):
        * wtf/FunctionDispatcher.h: Added.

2013-05-01  Zoltan Arvai  <zarvai@inf.u-szeged.hu>

        [Qt][Win] Fix build after r149416.
        https://bugs.webkit.org/show_bug.cgi?id=115474

        Reviewed by Anders Carlsson.

        * WTF.pro:
        * wtf/threads/BinarySemaphore.h:
        (BinarySemaphore):

2013-05-01  Zoltan Arvai  <zarvai@inf.u-szeged.hu>

        [Qt] Unreviewed buildfix after r149416.

        * WTF.pro:

2013-04-30  Anders Carlsson  <andersca@apple.com>

        Remove the WebKit2 BinarySemaphore class
        https://bugs.webkit.org/show_bug.cgi?id=115458

        Reviewed by Benjamin Poulain.

        * wtf/Forward.h:
        Add BinarySemaphore forward declaration.

        * wtf/threads/BinarySemaphore.h:
        Add WTF_EXPORT_PRIVATE to declarations.

2013-04-30  Commit Queue  <rniwa@webkit.org>

        Unreviewed, rolling out r149408.
        http://trac.webkit.org/changeset/149408
        https://bugs.webkit.org/show_bug.cgi?id=115453

        Broke Windows Build (Requested by bfulgham on #webkit).

        * wtf/Platform.h:

2013-04-30  Brent Fulgham  <bfulgham@webkit.org>

        [Windows, WinCairo] Fix crash in fast/js/create-lots-of-workers.html
        https://bugs.webkit.org/show_bug.cgi?id=115130

        Reviewed by Tim Horton.

        Windows is suffering from mismatched allocation/deallocation
        between the system allocator and fastMalloc/fastFree.  By turning
        off the global switch to fastMalloc, only classes specified to
        honor fastMalloc/fastFree are affected, and other memory allocation
        and freeing is done with consistent library calls.

        * wtf/Platform.h: Deactivate ENABLE_GLOBAL_FASTMALLOC_NEW for
        the Windows build.

2013-04-30  Commit Queue  <rniwa@webkit.org>

        Unreviewed, rolling out r149349 and r149354.
        http://trac.webkit.org/changeset/149349
        http://trac.webkit.org/changeset/149354
        https://bugs.webkit.org/show_bug.cgi?id=115444

         The Thumb version of compileSoftModulo make invalid use of
        registers (Requested by benjaminp on #webkit).

        * wtf/Platform.h:

2013-04-30  Darin Adler  <darin@apple.com>

        [Mac] Make adoptNS faster on platforms without garbage collection by skipping a CFRetain/NSRelease pair
        https://bugs.webkit.org/show_bug.cgi?id=115424

        Reviewed by Eric Carlson.

        * wtf/RetainPtr.h:
        (WTF::adoptNSReference): When OBJC_NO_GC is set, make this an empty function, because in that case
        CFRetain and -[NSObject retain] are the same thing and there is no need to call CFRetain and
        -[NSObject release] to adopt an Objective-C object.

2013-04-30  Anders Carlsson  <andersca@apple.com>

        String::isolatedCopy() can avoid a copy if the original is a temporary
        https://bugs.webkit.org/show_bug.cgi?id=115425

        Reviewed by Darin Adler.

        * wtf/Compiler.h:
        Add WTF_COMPILER_SUPPORTS_CXX_REFERENCE_QUALIFIED_FUNCTIONS define.

        * wtf/text/WTFString.cpp:
        (WTF::String::isolatedCopy):
        * wtf/text/WTFString.h:
        If COMPILER_SUPPORTS(CXX_REFERENCE_QUALIFIED_FUNCTIONS) is true, add two overloads of String::isolatedCopy().
        One is used if *this is an lvalue, and one is used if *this is an rvalue. In the latter case, we know that the original
        String object is a temporary and will be going away, so if it's safe to send it to another thread (if it's not an AtomicString,
        and if it's refcount is 1), then we can just steal the StringImpl from the original and avoid a copy altogether.

2013-04-30  Zalan Bujtas  <zalan@apple.com>

        Animations fail to start on http://www.google.com/insidesearch/howsearchworks/thestory/
        https://bugs.webkit.org/show_bug.cgi?id=111244

        Reviewed by David Kilzer.
        
        Enable performance.now() as a minimal subset of Web Timing API. 
        It returns DOMHighResTimeStamp, a monotonically increasing value representing the 
        number of milliseconds from the start of the navigation of the current document.
        JS libraries use this API to check against the requestAnimationFrame() timestamp.

        * wtf/FeatureDefines.h:

2013-04-29  Cosmin Truta  <ctruta@blackberry.com>

        [ARM] Expand the use of integer division
        https://bugs.webkit.org/show_bug.cgi?id=115138

        Reviewed by Benjamin Poulain.

        * wtf/Platform.h: Added ENABLE_ARM_INTEGER_DIV.

2013-04-29  Anders Carlsson  <andersca@apple.com>

        It should be an error to use adoptPtr with RefCounted subclasses
        https://bugs.webkit.org/show_bug.cgi?id=115389

        Reviewed by Benjamin Poulain.

        * wtf/PassOwnPtr.h:
        (WTF::adoptPtr):
        Add COMPILE_ASSERTs.

2013-04-29  Patrick Gansterer  <paroga@webkit.org>

        [WIN] Add workaround for UNUSED_PARAM()
        https://bugs.webkit.org/show_bug.cgi?id=115350

        Reviewed by Andreas Kling.

        r147882 added an workaround for the MSVC compiler on Windows CE.
        Extend this workaround to whole MSVC compiler, since the same
        problem occurs with the Visual Studio 10 compiler too.

        * wtf/UnusedParam.h:

2013-04-29  Patrick Gansterer  <paroga@webkit.org>

        [WIN] Add WTF_USE_IMLANG_FONT_LINK2
        https://bugs.webkit.org/show_bug.cgi?id=115198

        Reviewed by Andreas Kling.

        * wtf/Platform.h:

2013-04-29  Patrick Gansterer  <paroga@webkit.org>

        Define USE(ICU_UNICODE) if USE(WCHAR_UNICODE) is false
        https://bugs.webkit.org/show_bug.cgi?id=115349

        Reviewed by Andreas Kling.

        Since we support only ICU and WCHAR as Unicode backend (ICU is the default)
        automatically use ICU if WCHAR was not selected via compiler defines.

        * wtf/Platform.h:

2013-04-29  Patrick Gansterer  <paroga@webkit.org>

        Build fix for WinCE after r148888 and r149097
        https://bugs.webkit.org/show_bug.cgi?id=115168

        Reviewed by Anders Carlsson.

        When using compiler intrinsics on Windows CE the compiler complains
        about wrong linkage specification of replaced CRT functions defined
        in math.h. This is because the compiler has intrinsics for this
        functions defined, and requires them to have extern "C" linkage.

        * wtf/MathExtras.h:
        (wtf_atan2): Added extern "C" to function signature.
        (wtf_fmod): Ditto.
        (wtf_pow): Ditto.

2013-04-29  Carlos Garcia Campos  <cgarcia@igalia.com>

        Unreviewed. Fix make distcheck.

        * GNUmakefile.list.am: Add missing header file to compilation.

2013-04-27  Darin Adler  <darin@apple.com>

        Move from constructor and member function adoptCF/NS to free function adoptCF/NS.
        https://bugs.webkit.org/show_bug.cgi?id=115307

        Reviewed by Geoffrey Garen.

        * wtf/RunLoopTimerCF.cpp:
        (WTF::RunLoopTimerBase::start):
        * wtf/SchedulePair.h:
        (WTF::SchedulePair::SchedulePair):
        * wtf/SchedulePairMac.mm:
        (WTF::SchedulePair::SchedulePair):
        * wtf/unicode/icu/CollatorICU.cpp:
        (WTF::Collator::userDefault):
        Use adoptCF free function.

2013-04-26  Geoffrey Garen  <ggaren@apple.com>

        Filled out more cases of branch folding in bytecode when emitting expressions into a branching context
        https://bugs.webkit.org/show_bug.cgi?id=115057

        Reviewed by Filip Pizlo.

        Added a helper constructor for TriState so clients can make one without
        branching or making assumptions about the integer values of TriStates.

        * wtf/TriState.h:
        (WTF::triState):
        (WTF):

2013-04-26  Roger Fong  <roger_fong@apple.com>

        Make Apple Windows VS2010 build results into and get dependencies from __32 suffixed folders.
        Make the DebugSuffix configuration use _debug dependencies.

        * WTF.vcxproj/WTF.make:
        * WTF.vcxproj/WTF.vcxproj:
        * WTF.vcxproj/WTFCommon.props:
        * WTF.vcxproj/WTFDebug.props:
        * WTF.vcxproj/WTFGenerated.make:
        * WTF.vcxproj/WTFGenerated.vcxproj:
        * WTF.vcxproj/WTFGeneratedCommon.props:
        * WTF.vcxproj/WTFGeneratedDebug.props:
        * WTF.vcxproj/WTFGeneratedProduction.props:
        * WTF.vcxproj/WTFGeneratedRelease.props:
        * WTF.vcxproj/WTFProduction.props:
        * WTF.vcxproj/WTFRelease.props:
        * WTF.vcxproj/build-generated-files.sh:
        * WTF.vcxproj/work-around-vs-dependency-tracking-bugs.py:
        (react_to_vsprops_changes):

2013-04-26  Martin Robinson  <mrobinson@igalia.com>

        Remove the remaining Skia #ifdefs
        https://bugs.webkit.org/show_bug.cgi?id=114886

        Reviewed by Benjamin Poulain.

        * wtf/Platform.h:

2013-04-26  Mikhail Pozdnyakov  <mikhail.pozdnyakov@intel.com>

        Add move semantics to RefPtr
        https://bugs.webkit.org/show_bug.cgi?id=115033

        Reviewed by Anders Carlsson.

        Add move constructors and move assignment operators to RefPtr when
        COMPILER_SUPPORTS(CXX_RVALUE_REFERENCES).
        This obviates unnecessary reffing/ureffing when RefPtr is created
        or assigned from rvalue references.

        * wtf/RefPtr.h:
        (RefPtr):
        (WTF::RefPtr::RefPtr):
        (WTF::RefPtr::operator=):

2013-04-26  Andreas Kling  <akling@apple.com>

        Remove wxWebKit from WTF.
        <http://webkit.org/b/115249>

        Reviewed by Antti Koivisto.

        * wscript: Removed.
        * wtf/ArrayBufferView.h:
        (ArrayBufferView):
        * wtf/CurrentTime.cpp:
        * wtf/DisallowCType.h:
        * wtf/ExportMacros.h:
        * wtf/FeatureDefines.h:
        * wtf/Platform.h:
        * wtf/text/WTFString.h:
        (String):
        * wtf/wx/MainThreadWx.cpp: Removed.
        * wtf/wx/StringWx.cpp: Removed.

2013-04-25  Filip Pizlo  <fpizlo@apple.com>

        Unreviewed, roll out http://trac.webkit.org/changeset/148999
        It broke http://kripken.github.io/ammo.js/examples/new/ammo.html

        * wtf/TriState.h:

2013-04-25  Oliver Hunt  <oliver@apple.com>

        Fix 32bit build

        * wtf/StackBounds.cpp:
        (WTF::StackBounds::initialize):

2013-04-25  Oliver Hunt  <oliver@apple.com>

        Stack guards are too conservative
        https://bugs.webkit.org/show_bug.cgi?id=115147

        Reviewed by Mark Hahnenberg.

        Use getrlimit on darwin to get the stack size for the main thread.

        * wtf/StackBounds.cpp:
        (WTF::StackBounds::initialize):

2013-04-25  Andreas Kling  <akling@apple.com>

        Remove ENABLE(PARSED_STYLE_SHEET_CACHING) and make it always-on.

        Rubber-stamped by Anders Koivisto.

        * wtf/FeatureDefines.h:

2013-04-25  peavo@outlook.com  <peavo@outlook.com>

        [Windows] Compile fix.
        https://bugs.webkit.org/show_bug.cgi?id=115170

        Reviewed by Filip Pizlo.

        Forward declare function, instead of including intrin.h.

        * wtf/Atomics.h:

2013-04-25  Mikhail Pozdnyakov  <mikhail.pozdnyakov@intel.com>

        Use std::move in AtomicString
        https://bugs.webkit.org/show_bug.cgi?id=115102

        Reviewed by Anders Carlsson.

        Use std::move in AtomicString instead of direct casting to rvalue references.

        * wtf/text/AtomicString.h:
        (AtomicString):
        (WTF::AtomicString::AtomicString):
        (WTF::AtomicString::operator=):

2013-04-25  Patrick Gansterer  <paroga@webkit.org>

        Unreviewed WinCE build fix after r148888.

        * wtf/Atomics.h: WinCE version of intrin.h is called cmnintrin.h.

2013-04-24  Roger Fong  <roger_fong@apple.com>

        Have VS2010 WebKit solution look in WebKit_Libraries/lib32 for dependencies.

        * WTF.vcxproj/build-generated-files.sh:

2013-04-24  Benjamin Poulain  <benjamin@webkit.org>

        Use post-branch store for RefCountedBase::derefBase
        https://bugs.webkit.org/show_bug.cgi?id=115078

        Reviewed by Andreas Kling.

        * wtf/RefCounted.h:
        (WTF::RefCountedBase::derefBase): This makes the assembly easier to follow.

2013-04-23  Geoffrey Garen  <ggaren@apple.com>

        Filled out more cases of branch folding in bytecode when emitting expressions into a branching context
        https://bugs.webkit.org/show_bug.cgi?id=115057

        Reviewed by Filip Pizlo.

        Added a helper constructor for TriState so clients can make one without
        branching or making assumptions about the integer values of TriStates.

        * wtf/TriState.h:
        (WTF::triState):
        (WTF):

2013-04-23  Roger Fong  <roger_fong@apple.com>

        AppleWin build fix.

        * WTF.vcproj/WTF.vcproj:

2013-04-23  Benjamin Poulain  <bpoulain@apple.com>

        Remove unused code of RefCounted after chromium removal
        https://bugs.webkit.org/show_bug.cgi?id=115009

        Reviewed by Ryosuke Niwa.

        * wtf/RefCounted.h:
        (WTF::RefCountedBase::refCount):
        (RefCountedBase):
        It looks like addressOfCount() is no longer needed.
        Also change the type back to unsigned as it make more sense.

2013-04-23  David Kilzer  <ddkilzer@apple.com>

        RetainPtr.h should compile with -Wshorten-64-to-32
        <http://webkit.org/b/115047>

        Reviewed by Anders Carlsson.

        Fixes the following warning:

            RetainPtr.h:318:20: error: implicit conversion loses integer precision: 'CFHashCode' (aka 'unsigned long') to 'unsigned int' [-Werror,-Wshorten-64-to-32]
                        return CFHash(o.get());
                        ~~~~~~ ^~~~~~~~~~~~~~~

        * wtf/RetainPtr.h:
        (WTF::RetainPtrObjectHash::hash): Cast return value of CFHash()
        to unsigned.  This has no effect on 32-bit architectures, but
        takes the lower 32-bits of the CFHashCode (unsigned long) on
        64-bit architectures, which is what happens implicitly now.

2013-04-22  Patrick Gansterer  <paroga@webkit.org>

        [CMake] Move NullPtr.cpp from PlatformWinCE.cmake to CMakeLists.txt
        https://bugs.webkit.org/show_bug.cgi?id=114557

        Reviewed by Laszlo Gombos.

        This file is not specific to Windwos CE. Move it the the general
        CMakeLists.txt so other ports can use it to. It does not affect
        ports which do not need it, since it contains a preprocessor guard.

        * wtf/CMakeLists.txt:
        * wtf/PlatformWinCE.cmake:

2013-04-22  Benjamin Poulain  <benjamin@webkit.org>

        Remove the memory instrumentation code
        https://bugs.webkit.org/show_bug.cgi?id=114931

        Reviewed by Andreas Kling.

        On Mac x86_64, the code removal cause the binary to be
        9224 bytes smaller.

        * GNUmakefile.list.am:
        * WTF.pro:
        * WTF.vcproj/WTF.vcproj:
        * WTF.vcxproj/WTF.vcxproj:
        * WTF.vcxproj/WTF.vcxproj.filters:
        * WTF.xcodeproj/project.pbxproj:
        * wtf/CMakeLists.txt:
        * wtf/Forward.h:
        * wtf/ListHashSet.h:
        (ListHashSet):
        (ListHashSetNodeAllocator):
        (WTF::ListHashSetNodeAllocator::pool):
        (WTF::ListHashSetNodeAllocator::pastPool):
        * wtf/MemoryInstrumentation.cpp: Removed.
        * wtf/MemoryInstrumentation.h: Removed.
        * wtf/MemoryInstrumentationArrayBufferView.h: Removed.
        * wtf/MemoryInstrumentationHashCountedSet.h: Removed.
        * wtf/MemoryInstrumentationHashMap.h: Removed.
        * wtf/MemoryInstrumentationHashSet.h: Removed.
        * wtf/MemoryInstrumentationListHashSet.h: Removed.
        * wtf/MemoryInstrumentationSequence.h: Removed.
        * wtf/MemoryInstrumentationString.h: Removed.
        * wtf/MemoryInstrumentationVector.h: Removed.
        * wtf/MemoryObjectInfo.h: Removed.
        * wtf/text/AtomicString.h:
        * wtf/text/StringImpl.h:
        (WTF::StringImpl::isASCIILiteral):
        * wtf/text/WTFString.h:

2013-04-22  David Kilzer  <ddkilzer@apple.com>

        StringImpl.h should compile with -Wshorten-64-to-32
        <http://webkit.org/b/114970>

        Reviewed by Darin Adler.

        Fixes the following warnings with -Wshorten-64-to-32:

            StringImpl.h:317:25: error: implicit conversion loses integer precision: 'uintptr_t' (aka 'unsigned long') to 'unsigned int' [-Werror,-Wshorten-64-to-32]
                    unsigned hash = reinterpret_cast<uintptr_t>(this);
                             ~~~~   ^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

        * wtf/text/StringImpl.h:
        (WTF::StringImpl::StringImpl): Add static_cast<uint32_t>() to
        formalize taking the lower 32-bits of the pointer value on
        64-bit architectures.

2013-04-22  Andreas Kling  <akling@apple.com>

        Shrink baseline size of WTF::Vector on 64-bit by switching to unsigned capacity and size.
        <http://webkit.org/b/97268>
        <rdar://problem/12376519>

        Reviewed by Sam Weinig.

        Shrink Vector by 8 bytes on 64-bit by using 32-bit capacity and size.
        Vector now inherits from VectorBuffer instead of having a VectorBuffer member;
        this is necessary for m_size to fall into the padding after the base class members.

        The WTF::Vector API still uses size_t.

        Based on Blink r148313 by <cevans@chromium.org>.

        * wtf/SizeLimits.cpp:
        * wtf/Vector.h:
        (WTF::VectorBufferBase::allocateBuffer):
        (WTF::VectorBufferBase::tryAllocateBuffer):
        (VectorBufferBase):
        (WTF::VectorBuffer::shouldReallocateBuffer):
        (Vector):
        (WTF::Vector::Vector):
        (WTF::Vector::capacity):
        (WTF::Vector::at):
        (WTF::Vector::data):
        (WTF::Vector::swap):
        (WTF::::Vector):
        (WTF::::reserveCapacity):
        (WTF::::tryReserveCapacity):
        (WTF::::reserveInitialCapacity):
        (WTF::::shrinkCapacity):
        (WTF::::releaseBuffer):

2013-04-21  Filip Pizlo  <fpizlo@apple.com>

        Memory barrier support should also ensure that we always do a compiler fence
        https://bugs.webkit.org/show_bug.cgi?id=114934

        Reviewed by Michael Saboff.
        
        This is a cherry-pick merge of the WTF part of r148836 from the dfgFourthTier
        branch. It fixes a memory ordering bug that is likely asymptomatic, but
        nonetheless real: TCSpinLock expects that using a memoryBarrierBeforeUnlock()
        prior to setting lockword_ to 0 will ensure that the assignment to lockword_
        won't get floated above any of the stores in the critical section. While that
        memory barrier does indeed do the right thing on ARM, it doesn't do the right
        thing on other architectures: it turns into empty code that the compiler blows
        away, which is fine for the hardware since X86 won't reorder that store - but
        it's not fine for the compiler, which may still do its own reorderings.
        
        The WTF part of r148836 fixes this by using a compiler fence: an empty asm
        volatile block that is marked as clobbering memory.
        
        Instead of doing a separate surgical fix in trunk, I decided to merge the
        whole WTF change over, to make merging easier in the future.
        
        Performance testing of this change in dfgFourthTier showed no regression.

        * wtf/Atomics.h:
        (WTF::compilerFence):
        (WTF::armV7_dmb):
        (WTF::armV7_dmb_st):
        (WTF::loadLoadFence):
        (WTF::loadStoreFence):
        (WTF::storeLoadFence):
        (WTF::storeStoreFence):
        (WTF::memoryBarrierAfterLock):
        (WTF::memoryBarrierBeforeUnlock):
        (WTF::x86_mfence):

2013-04-22  David Kilzer  <ddkilzer@apple.com>

        WTF::AtomicString::find() should take unsigned 'start' argument
        <http://webkit.org/b/114958>

        Reviewed by Darin Adler.

        Fixes the following warnings with -Wshorten-64-to-32:

            AtomicString.h:113:76: error: implicit conversion loses integer precision: 'size_t' (aka 'unsigned long') to 'unsigned int' [-Werror,-Wshorten-64-to-32]
                size_t find(UChar c, size_t start = 0) const { return m_string.find(c, start); }
                                                                      ~~~~~~~~         ^~~~~
            AtomicString.h:115:35: error: implicit conversion loses integer precision: 'size_t' (aka 'unsigned long') to 'unsigned int' [-Werror,-Wshorten-64-to-32]
                    { return m_string.find(s, start, caseSentitive); }
                             ~~~~~~~~         ^~~~~
            AtomicString.h:117:35: error: implicit conversion loses integer precision: 'size_t' (aka 'unsigned long') to 'unsigned int' [-Werror,-Wshorten-64-to-32]
                    { return m_string.find(s, start, caseSentitive); }
                             ~~~~~~~~         ^~~~~

        * wtf/text/AtomicString.h:
        (WTF::AtomicString::find): Change type of 'start' argument from
        size_t to unsigned.

2013-04-21  Benjamin Poulain  <benjamin@webkit.org>

        Improve StringImpl code density for older ARM hardware
        https://bugs.webkit.org/show_bug.cgi?id=114898

        Reviewed by Geoffrey Garen.

        Reduce the number of instructions needed for StringImpl::deref
        on older ARM hardware.

        The extra indirection should have a negligible impact on x86_64.

        * wtf/text/StringImpl.cpp:
        (WTF::StringImpl::destroy):
        * wtf/text/StringImpl.h:
        (StringImpl):
        (WTF::StringImpl::deref):

2013-04-20  Allan Sandfeld Jensen  <allan.jensen@digia.com>

        LLint should be able to use x87 instead of SSE for floating pointer
        https://bugs.webkit.org/show_bug.cgi?id=112239

        Reviewed by Filip Pizlo.

        Disable GTK workaround now that LLInt does not require SSE2.

        * wtf/Platform.h:

2013-04-19  Roger Fong  <roger_fong@apple.com>

        Remove uses of WebKit_Source from AppleWin build in WTF.

        * WTF.vcxproj/WTF.make:
        * WTF.vcxproj/copy-files.cmd:
        * WTF.vcxproj/work-around-vs-dependency-tracking-bugs.py:
        (react_to_vsprops_changes):
        (react_to_webkit1_interface_changes):

2013-04-19  Benjamin Poulain  <benjamin@webkit.org>

        Remove the declaration of MemoryObjectInfo from StringImpl
        https://bugs.webkit.org/show_bug.cgi?id=114788

        Reviewed by Andreas Kling.

        * wtf/text/StringImpl.h: The declaration is an other left over from chromium.

2013-04-19  Benjamin Poulain  <benjamin@webkit.org>

        Make StringImpl::cost const
        https://bugs.webkit.org/show_bug.cgi?id=114790

        Reviewed by Andreas Kling.

        * wtf/text/StringImpl.h:
        (WTF::StringImpl::cost):

2013-04-19  Roger Fong  <roger_fong@apple.com>

        Unreviewed. WebKit_Source is incorrectly set.

        * WTF.vcxproj/WTF.make:

2013-04-19  Alberto Garcia  <agarcia@igalia.com>

        OSAllocatorPosix: fix build warnings about unused parameters in QNX
        https://bugs.webkit.org/show_bug.cgi?id=114859

        Reviewed by Carlos Garcia Campos.

        * wtf/OSAllocatorPosix.cpp:
        (WTF::OSAllocator::reserveUncommitted):

2013-04-19  Dan Beam  <dbeam@chromium.org>

        Remove unmaintained feature REQUEST_AUTOCOMPLETE
        https://bugs.webkit.org/show_bug.cgi?id=114846

        Reviewed by Kent Tamura.

        * wtf/FeatureDefines.h: Remove REQUEST_AUTOCOMPLETE as a feature definition.

2013-04-18  Zoltan Arvai  <zarvai@inf.u-szeged.hu>

        Speculative build fix for Qt Mountain Lion Release after r148639.
        https://bugs.webkit.org/show_bug.cgi?id=114793

        Reviewed by Michael Saboff.

        * wtf/CurrentTime.cpp:

2013-04-17  Mark Lam  <mark.lam@apple.com>

        Added currentCPUTime() and currentCPUTimeMS().
        https://bugs.webkit.org/show_bug.cgi?id=114577.

        Reviewed by Geoffrey Garen.

        The currentCPUTime() implementation came from the old TimeoutChecker.cpp.

        * wtf/CurrentTime.cpp:
        (WTF::currentCPUTime):
        (WTF::currentCPUTimeMS):
        * wtf/CurrentTime.h:

2013-04-17  Ryosuke Niwa  <rniwa@webkit.org>

        REGRESSION(r148584): WebKit nightly builds don't load any page
        https://bugs.webkit.org/show_bug.cgi?id=114752

        Reviewed by Anders Carlsson.

        We can't use C++ style (//) comments in Platform.h because WebKit2/DerivedSource.make doesn't know
        how to strip it to be merged with *.sb.in to generate *.sb files. Specifically, we have:
        
        # Some versions of clang incorrectly strip out // comments in c89 code.
        # Use -traditional as a workaround, but only when needed since that causes
        # other problems with later versions of clang.
        ifeq ($(shell echo '//x' | $(CC) -E -P -x c -std=c89 - | grep x),)
        TEXT_PREPROCESSOR_FLAGS=-E -P -x c -traditional -w
        else
        TEXT_PREPROCESSOR_FLAGS=-E -P -x c -std=c89 -w
        endif

        * wtf/Platform.h:

2013-04-17  Brent Fulgham  <bfulgham@webkit.org>

        [Windows, WinCairo] Remove Include Settings for Pthreads from WTF
        https://bugs.webkit.org/show_bug.cgi?id=114694

        Reviewed by Ryosuke Niwa.

        * WTF.vcproj/WTFCommon.vsprops: Remove pthread search path.
        * WTF.vcxproj/WTFCommon.props: Remove pthread search path.
        * wtf/FastMalloc.cpp: Guard pthread.h include for non-pthread
        builds.

2013-04-16  Oliver Hunt  <oliver@apple.com>

        Harden FastMalloc against partial pointer overflows
        https://bugs.webkit.org/show_bug.cgi?id=114716

        Reviewed by Gavin Barraclough.

        Bite the bullet and perform object alignment checks on free.
        malloc/free micro benchmark shows a regression, but real
        benchmarks don't.  There's a little code motion in this avoid
        taking too much of a performance hit.  In addition to the
        alignment check we also validate the containing span as
        we've already taken the hit of finding it.

        * wtf/FastMalloc.cpp:
        (WTF::TCMalloc_ThreadCache::CreateCacheIfNecessary):

2013-04-16  Sam Weinig  <sam@webkit.org>

        Fix fallout after r148545.

        * wtf/Platform.h:
        Move Platform defines that were incorrectly in WebCore, into Platform.h

2013-04-15  Commit Queue  <rniwa@webkit.org>

        Unreviewed, rolling out r148488.
        http://trac.webkit.org/changeset/148488
        https://bugs.webkit.org/show_bug.cgi?id=114660

        Roll back in r148462 since it was a false positive. (Requested
        by rniwa on #webkit).

        * wtf/FastMalloc.cpp:
        (WTF):
        (WTF::setThreadHeap):
        (WTF::TCMalloc_ThreadCache::GetThreadHeap):
        (WTF::TCMalloc_ThreadCache::InitTSD):
        * wtf/ThreadSpecificWin.cpp:
        (WTF::destructorsList):
        (WTF::destructorsMutex):
        (WTF::threadSpecificKeyCreate):
        (WTF::threadSpecificKeyDelete):

2013-04-15  Commit Queue  <rniwa@webkit.org>

        Unreviewed, rolling out r148462.
        http://trac.webkit.org/changeset/148462
        https://bugs.webkit.org/show_bug.cgi?id=114658

        Broke Windows builds (Requested by rniwa on #webkit).

        * wtf/FastMalloc.cpp:
        (WTF):
        (WTF::setThreadHeap):
        (WTF::TCMalloc_ThreadCache::GetThreadHeap):
        (WTF::TCMalloc_ThreadCache::InitTSD):
        * wtf/ThreadSpecificWin.cpp:
        (WTF::destructorsList):
        (WTF::destructorsMutex):
        (WTF::threadSpecificKeyCreate):
        (WTF::threadSpecificKeyDelete):

2013-04-15  Julien Brianceau  <jbrianceau@nds.com>

        LLInt SH4 backend implementation
        https://bugs.webkit.org/show_bug.cgi?id=112886

        Reviewed by Oliver Hunt.

        * wtf/Platform.h:

2013-04-15  Patrick Gansterer  <paroga@webkit.org>

        [CMake] Add WTF_USE_*_UNICODE variables
        https://bugs.webkit.org/show_bug.cgi?id=114556

        Reviewed by Brent Fulgham.

        WTF_USE_ICU_UNICODE and WTF_USE_WCHAR_UNICODE are used to
        reduce duplication in the platform specific CMake files.

        * wtf/CMakeLists.txt:
        * wtf/PlatformBlackBerry.cmake:
        * wtf/PlatformEfl.cmake:
        * wtf/PlatformWinCE.cmake:

2013-04-15  Patrick Gansterer  <paroga@webkit.org>

        [WIN] Remove remaining calls to pthread from WTF
        https://bugs.webkit.org/show_bug.cgi?id=114563

        Reviewed by Brent Fulgham.

        Replace pthread_key_create with threadSpecificKeyCreate and
        pthread_setspecific with threadSpecificSet from ThreadSpecific.h.
        These functions provide a windows-specific implementation for the pthread functions,
        but require that the thread has been created with WTF::createThread(),
        which is the case for all threads created within WebKit.
        To call this function from fastMalloc we must not call fastMalloc in them.
        To fulfill this constraint ThreadSpecificWin will allocated its memory through the
        original malloc implementation and use the stack for local and static variables.
        Keep the Darwin implementation as it is, since it contains some performance tweaks.

        * wtf/FastMalloc.cpp:
        * wtf/ThreadSpecificWin.cpp:
        (WTF::destructorsList):
        (WTF::destructorsMutex):
        (WTF::threadSpecificKeyCreate):
        (WTF::threadSpecificKeyDelete):

2013-04-14  Oliver Hunt  <oliver@apple.com>

        Try to fix non-apple windows builds

        * wtf/Platform.h:

2013-04-14  David Kilzer  <ddkilzer@apple.com>

        Add EnumClass.h to project files
        <http://webkit.org/b/114582>

        Rubber-stamped by Dan Bernstein.

        * WTF.pro: Add EnumClass.h to project.
        * WTF.vcproj/WTF.vcproj: Ditto.
        * WTF.vcxproj/WTF.vcxproj: Ditto.
        * WTF.vcxproj/WTF.vcxproj.filters: Ditto.
        * WTF.xcodeproj/project.pbxproj: Ditto.

2013-04-12  Oliver Hunt  <oliver@apple.com>

        Apologies to all, I have no idea what happened to cause this change.

        * wtf/Platform.h:

2013-04-12  Oliver Hunt  <oliver@apple.com>

        [Qt][Win] r148257 broke the build
        https://bugs.webkit.org/show_bug.cgi?id=114512

        Build fix.

        * wtf/Platform.h:

2013-04-11  Oliver Hunt  <oliver@apple.com>

        Add more type validation to debug builds
        https://bugs.webkit.org/show_bug.cgi?id=114478

        Reviewed by Mark Hahnenberg.

        Add BINDING_VALIDATION flag and make RELEASE_ASSERT use UNLIKELY.

        * wtf/Assertions.h:
        * wtf/Platform.h:

2013-04-10  Thiago Marcos P. Santos  <thiago.santos@intel.com>

        [WTF] Get rid of truncated thread name warnings for non-Windows platforms
        https://bugs.webkit.org/show_bug.cgi?id=114266

        Reviewed by Ryosuke Niwa.

        Hide the annoying message from ports that are not really interested
        about it.

        * wtf/Threading.cpp:
        (WTF::createThread):

2013-04-10  Benjamin Poulain  <bpoulain@apple.com>

        Mass remove all the empty directories

        Rubberstamped by Ryosuke Niwa.

        * wtf/qt/compat: Removed.
        * wtf/unicode/glib: Removed.
        * wtf/unicode/qt4: Removed.
        * wtf/unicode/wince: Removed.

2013-04-08  Anders Carlsson  <andersca@apple.com>

        Remove unneeded headers from FrameLoader.h
        https://bugs.webkit.org/show_bug.cgi?id=114223

        Reviewed by Geoffrey Garen.

        * wtf/Forward.h:
        Add PrintStream.

        * wtf/HashTable.h:
        Don't include DataLog.h unless DUMP_HASHTABLE_STATS_PER_TABLE is 1.

2013-04-10  Laszlo Gombos  <l.gombos@samsung.com>

        Remove ENABLE_3D_PLUGIN
        https://bugs.webkit.org/show_bug.cgi?id=108002

        Reviewed by Antti Koivisto.

        Remove ENABLE_3D_PLUGIN, it was only used by Chromium.

        * wtf/FeatureDefines.h:

2013-04-09  Patrick Gansterer  <paroga@webkit.org>

        [CMake] Remove conditional source file lists in WTF
        https://bugs.webkit.org/show_bug.cgi?id=114250

        Reviewed by Laszlo Gombos.

        Use the #ifdef in the source file instead of conditional adding
        files to the list of source files. This allows us to remove the
        information of enabled features from CMake in next step.

        * wtf/CMakeLists.txt:

2013-04-08  Ryosuke Niwa  <rniwa@webkit.org>

        Remove WTF.gyp/WTF.gypi
        https://bugs.webkit.org/show_bug.cgi?id=114237

        Reviewed by Maciej Stachowiak.

        * WTF.gyp: Removed.
        * WTF.gyp/.gitignore: Removed.
        * WTF.gyp/WTF.gyp: Removed.
        * WTF.gypi: Removed.

2013-04-08  Benjamin Poulain  <benjamin@webkit.org>

        Remove HTML Notification
        https://bugs.webkit.org/show_bug.cgi?id=114231

        Reviewed by Ryosuke Niwa.

        * wtf/FeatureDefines.h:

2013-04-08  Benjamin Poulain  <benjamin@webkit.org>

        wtf/dtoa/* uses a confusing name to reference its buffers
        https://bugs.webkit.org/show_bug.cgi?id=109709

        Reviewed by Darin Adler.

        The data structure Vector in wtf/dtoa has nothing to do with a traditional
        vector, is it just a pointer and the length of the pointed buffer.

        Rename it to BufferReference to avoid mistakes.

        * wtf/dtoa/bignum-dtoa.cc:
        * wtf/dtoa/bignum-dtoa.h:
        * wtf/dtoa/bignum.cc:
        * wtf/dtoa/bignum.h:
        (Bignum):
        * wtf/dtoa/double-conversion.cc:
        * wtf/dtoa/fast-dtoa.cc:
        * wtf/dtoa/fast-dtoa.h:
        * wtf/dtoa/fixed-dtoa.cc:
        * wtf/dtoa/fixed-dtoa.h:
        (double_conversion):
        * wtf/dtoa/strtod.cc:
        * wtf/dtoa/strtod.h:
        (double_conversion):
        * wtf/dtoa/utils.h:
        (double_conversion):
        (WTF::double_conversion::BufferReference::BufferReference):
        (WTF::double_conversion::BufferReference::SubBufferReference):
        (StringBuilder):

2013-04-08  Alberto Garcia  <agarcia@igalia.com>

        [BlackBerry] MathExtras: macros defined in math.h conflict with the real functions
        https://bugs.webkit.org/show_bug.cgi?id=112683

        Reviewed by Darin Adler.

        After calls to signbit and friends were prefixed with std:: in
        r143232, the BlackBerry port no longer compiles.

        The solution is to get rid of the macros defined in math.h and use
        the real functions instead.

        * wtf/MathExtras.h:

2013-04-08  Max Vujovic  <mvujovic@adobe.com>

        REGRESSION (r147502): Animations of CA filters broken
        https://bugs.webkit.org/show_bug.cgi?id=114067

        Reviewed by Dean Jackson.

        Revert r147502 [1] because it broke CA filter animations.
        
        [1]: http://trac.webkit.org/changeset/147502

        * wtf/Platform.h:

2013-04-08  Andreas Kling  <akling@apple.com>

        REGRESSION(r147894): Broke WTFReportBacktrace() on Mac.
        <http://webkit.org/b/114174>

        Reviewed by Anders Carlsson.

        An #elif !OS(ANDROID) block was erroneously removed, turn it into an #else instead since
        that path will still be taken for OS(DARWIN).

        * wtf/Assertions.cpp:

2013-04-08  Oliver Hunt  <oliver@apple.com>

        Build fix.

        Remove unnecessary include of <wtf/Forward.h> from Vector.h

        * wtf/Vector.h:

2013-04-08  Csaba Osztrogonác  <ossy@webkit.org>

        Unreviewed trivial buildfix after r147799.

        Add an ifdef guard to ensure Qt uses its own monotonicallyIncreasingTime()
        implemenation instead of the GLIB based one.

        * wtf/CurrentTime.cpp:
        (WTF):

2013-04-07  Benjamin Poulain  <benjamin@webkit.org>

        Remove the android code from WebKit Template Framework
        https://bugs.webkit.org/show_bug.cgi?id=114138

        Reviewed by Dirk Schulze.

        * wtf/Assertions.cpp:
        * wtf/Atomics.h:
        * wtf/MathExtras.h:
        * wtf/Platform.h:
        * wtf/ThreadIdentifierDataPthreads.cpp:

2013-04-07  Oliver Hunt  <oliver@apple.com>

        Add bounds checking for WTF::Vector::operator[]
        https://bugs.webkit.org/show_bug.cgi?id=89600

        Reviewed by Filip Pizlo.

        Add a template parameter to Vector<> that controls whether
        bounds checking is performed in release builds or not.
        Defaults to crashing on overflow.

        * wtf/Forward.h:
        (WTF):
        * wtf/Vector.h:
        (WTF):
        (Vector):
        (WTF::Vector::at):
        (WTF::Vector::removeLast):
        (WTF::::Vector):
        (WTF::=):
        (WTF::::contains):
        (WTF::::find):
        (WTF::::reverseFind):
        (WTF::::fill):
        (WTF::::appendRange):
        (WTF::::expandCapacity):
        (WTF::::tryExpandCapacity):
        (WTF::::resize):
        (WTF::::shrink):
        (WTF::::grow):
        (WTF::::reserveCapacity):
        (WTF::::tryReserveCapacity):
        (WTF::::reserveInitialCapacity):
        (WTF::::shrinkCapacity):
        (WTF::::append):
        (WTF::::tryAppend):
        (WTF::::appendSlowCase):
        (WTF::::uncheckedAppend):
        (WTF::::appendVector):
        (WTF::::insert):
        (WTF::::prepend):
        (WTF::::remove):
        (WTF::::reverse):
        (WTF::::releaseBuffer):
        (WTF::::checkConsistency):
        (WTF::deleteAllValues):
        (WTF::swap):
        (WTF::operator==):
        (WTF::operator!=):

2013-04-07  Patrick Gansterer  <paroga@webkit.org>

        [WIN] Fix problems with export macros of AutodrainedPool
        https://bugs.webkit.org/show_bug.cgi?id=114132

        Reviewed by Geoffrey Garen.

        Exporting an inline function results in an error with the MS compiler.

        * wtf/AutodrainedPool.h:
        (AutodrainedPool):
        (WTF::AutodrainedPool::AutodrainedPool):
        (WTF::AutodrainedPool::~AutodrainedPool):
        (WTF::AutodrainedPool::cycle):

2013-04-07  Patrick Gansterer  <paroga@webkit.org>

        [WinCE] Add workaround for UNUSED_PARAM()
        https://bugs.webkit.org/show_bug.cgi?id=113440

        Reviewed by Benjamin Poulain.

        The MSVC compiler for Windwos CE throws an error when
        an function parameter is passed to UNUSED_PARAM() and
        its type is only forward declared.

        * wtf/UnusedParam.h:

2013-04-07  Patrick Gansterer  <paroga@webkit.org>

        Do not check if WTF_ARM_ARCH_VERSION is defined in WTF_ARM_ARCH_AT_LEAST macro
        https://bugs.webkit.org/show_bug.cgi?id=114127

        Reviewed by Benjamin Poulain.

        Platform.h defines WTF_ARM_ARCH_VERSION for CPU(ARM) always and removing
        the check works around a bug in older Microsoft compiler versions.

        * wtf/Platform.h:

2013-04-07  David Kilzer  <ddkilzer@apple.com>

        Remove the rest of SVG_DOM_OBJC_BINDINGS
        <http://webkit.org/b/114112>

        Reviewed by Geoffrey Garen.

        * wtf/FeatureDefines.h:
        - Remove ENABLE_SVG_DOM_OBJC_BINDINGS macro.

2013-04-06  Geoffrey Garen  <ggaren@apple.com>

        Removed v8 bindings hooks from IDL files
        https://bugs.webkit.org/show_bug.cgi?id=114091

        Reviewed by Anders Carlsson and Sam Weinig.

        * wtf/ArrayBuffer.h:
        (WTF):
        (WTF::ArrayBufferContents::ArrayBufferContents):
        (WTF::ArrayBufferContents::transfer):
        (ArrayBufferContents):
        (ArrayBuffer):
        (WTF::ArrayBufferContents::~ArrayBufferContents):
        * wtf/Platform.h:

2013-04-05  Jesus Sanchez-Palencia  <jesus.palencia@openbossa.org>

        [GTK] Change from PLATFORM(GTK) to USE(GLIB) in WTF/CurrentTime.cpp
        https://bugs.webkit.org/show_bug.cgi?id=114061

        Reviewed by Gustavo Noronha Silva.

        Now other ports using GLib can use the correct implementation
        and not the fallback one without adding any other PLATFORM guards
        here.

        * wtf/CurrentTime.cpp:
        (WTF):

2013-04-05  Geoffrey Garen  <ggaren@apple.com>

        Made USE(JSC) unconditional
        https://bugs.webkit.org/show_bug.cgi?id=114058

        Reviewed by Anders Carlsson.

        * wtf/ThreadRestrictionVerifier.h:
        (WTF):
        * wtf/WTFThreadData.cpp:
        (WTF::WTFThreadData::WTFThreadData):
        (WTF::WTFThreadData::~WTFThreadData):
        * wtf/WTFThreadData.h:
        (WTFThreadData):
        * wtf/text/StringImpl.cpp:
        (WTF::StringImpl::~StringImpl):

2013-04-05  Roger Fong  <roger_fong@apple.com>

        More VS2010 solution makefile fixes.
        <rdar://problem/13588964>

        * WTF.vcxproj/WTF.make:

2013-04-05  Anders Carlsson  <andersca@apple.com>

        Remove more dead Chromium code from WTF
        https://bugs.webkit.org/show_bug.cgi?id=114037

        Reviewed by Allan Sandfeld Jensen.

        * wtf/CurrentTime.cpp:
        (WTF):
        * wtf/DisallowCType.h:
        * wtf/ExportMacros.h:
        * wtf/MainThread.cpp:
        * wtf/Platform.h:

2013-04-05  Raphael Kubo da Costa  <raphael.kubo.da.costa@intel.com>

        [EFL] Disable GLOBAL_FAST_MALLOC_NEW by default.
        https://bugs.webkit.org/show_bug.cgi?id=114031

        Reviewed by Alexis Menard.

        Follow what some other ports already do and avoid globally overriding
        the `new' and `delete' operators with the ones in FastMalloc.

        In many cases, third-party or client code allocates memory with
        standard library calls but the memory gets deleted by FastMalloc,
        causing a crash. The reverse (ie. memory being allocated by FastMalloc
        and freed by the system libraries) is also possible.

        Commits 135666 and 121018 provide more information about this, as well
        as comment 6 in bug 89358.

        * wtf/Platform.h:

2013-04-05  Benjamin Poulain  <bpoulain@apple.com>

        Remove WTFURL from WebKit
        https://bugs.webkit.org/show_bug.cgi?id=113994

        Reviewed by Ryosuke Niwa.

        Painful, but that is for the best now :(

        * GNUmakefile.list.am:
        * WTF.xcodeproj/project.pbxproj:
        * wtf/MemoryInstrumentationParsedURL.h: Removed.
        * wtf/url/api/ParsedURL.cpp: Removed.
        * wtf/url/api/ParsedURL.h: Removed.
        * wtf/url/api/URLBuffer.h: Removed.
        * wtf/url/api/URLQueryCharsetConverter.h: Removed.
        * wtf/url/api/URLString.cpp: Removed.
        * wtf/url/api/URLString.h: Removed.
        * wtf/url/src/RawURLBuffer.h: Removed.
        * wtf/url/src/URLCanon.h: Removed.
        * wtf/url/src/URLCanonEtc.cpp: Removed.
        * wtf/url/src/URLCanonFilesystemurl.cpp: Removed.
        * wtf/url/src/URLCanonFileurl.cpp: Removed.
        * wtf/url/src/URLCanonHost.cpp: Removed.
        * wtf/url/src/URLCanonICU.cpp: Removed.
        * wtf/url/src/URLCanonIP.cpp: Removed.
        * wtf/url/src/URLCanonInternal.cpp: Removed.
        * wtf/url/src/URLCanonInternal.h: Removed.
        * wtf/url/src/URLCanonMailto.cpp: Removed.
        * wtf/url/src/URLCanonPath.cpp: Removed.
        * wtf/url/src/URLCanonPathurl.cpp: Removed.
        * wtf/url/src/URLCanonQuery.cpp: Removed.
        * wtf/url/src/URLCanonRelative.cpp: Removed.
        * wtf/url/src/URLCanonStdURL.cpp: Removed.
        * wtf/url/src/URLCharacterTypes.cpp: Removed.
        * wtf/url/src/URLCharacterTypes.h: Removed.
        * wtf/url/src/URLComponent.h: Removed.
        * wtf/url/src/URLFile.h: Removed.
        * wtf/url/src/URLParse.cpp: Removed.
        * wtf/url/src/URLParse.h: Removed.
        * wtf/url/src/URLParseFile.cpp: Removed.
        * wtf/url/src/URLParseInternal.h: Removed.
        * wtf/url/src/URLSegments.cpp: Removed.
        * wtf/url/src/URLSegments.h: Removed.
        * wtf/url/src/URLUtil.cpp: Removed.
        * wtf/url/src/URLUtil.h: Removed.
        * wtf/url/src/URLUtilInternal.h: Removed.

2013-04-04  Geoffrey Garen  <ggaren@apple.com>

        Nixed the defunct chromium folder from WTF
        https://bugs.webkit.org/show_bug.cgi?id=113992

        Reviewed by Ryosuke Niwa.

        * wtf/chromium: Removed.
        * wtf/chromium/ChromiumThreading.h: Removed.
        * wtf/chromium/MainThreadChromium.cpp: Removed.

2013-04-04  Martin Robinson  <mrobinson@igalia.com>

        [GTK] Remove the gyp build
        https://bugs.webkit.org/show_bug.cgi?id=113942

        Reviewed by Gustavo Noronha Silva.

        * WTF.gyp/WTFGTK.gyp: Removed.

2013-04-04  Anders Carlsson  <andersca@apple.com>

        ObjcRuntimeExtras.h should use variadic templates
        https://bugs.webkit.org/show_bug.cgi?id=113941

        Reviewed by Andreas Kling.

        Reimplement wtfObjcMsgSend and wtfCallIMP as variadic function templates.

        * wtf/ObjcRuntimeExtras.h:
        (wtfObjcMsgSend):
        (wtfCallIMP):

2013-04-04  Andras Becsi  <andras.becsi@digia.com>

        Fix the build with GCC 4.8
        https://bugs.webkit.org/show_bug.cgi?id=113147

        Reviewed by Allan Sandfeld Jensen.

        Disable diagnostic warning -Wunused-local-typedefs for GCC 4.8
        since dummy typedefs are commonly used in the codebase.

        * wtf/Compiler.h:

2013-04-03  Pratik Solanki  <psolanki@apple.com>

        Enable HAVE_MADV_FREE_REUSE on iOS
        https://bugs.webkit.org/show_bug.cgi?id=113892
        <rdar://problem/12787563>

        Reviewed by Mark Rowe.

        * wtf/Platform.h:

2013-04-02  Ryosuke Niwa  <rniwa@webkit.org>

        Remove code for Mac 10.5 and earlier from WTF and WebKit2
        https://bugs.webkit.org/show_bug.cgi?id=113844

        Reviewed by Benjamin Poulain.

        Removed the code for 10.5 and removed if-def for 10.6.

        * wtf/FastMalloc.cpp:
        (WTF::TCMalloc_ThreadCache::CreateCacheIfNecessary):
        * wtf/Platform.h:
        * wtf/ThreadingPthreads.cpp:
        (WTF::initializeCurrentThreadInternal):
        * wtf/unicode/icu/CollatorICU.cpp:
        (WTF::Collator::userDefault):

2013-04-02  Max Vujovic  <mvujovic@adobe.com>

        [CSS Filters] Filter outsets clipped on composited layers when filter is applied after first layout
        https://bugs.webkit.org/show_bug.cgi?id=109098

        Reviewed by Dean Jackson.

        * wtf/Platform.h:
            Add flag for HAVE(COMPOSITOR_FILTER_OUTSETS) macro. This is used to check if a
            platform's compositor expands layers internally for filter outsets when it applies
            filters like drop-shadow and blur. Currently, only CoreAnimation does has this
            capability.

2013-04-02  Yury Semikhatsky  <yurys@chromium.org>

        Web Inspector: memory instrumentation for external arrays is broken
        https://bugs.webkit.org/show_bug.cgi?id=113790

        Reviewed by Pavel Feldman.

        * wtf/MemoryInstrumentationArrayBufferView.h: report buffer pointer as retaining one as
        we know that the pointer is not broken.
        (WTF::reportMemoryUsage):

2013-04-01  Han Shen  <shenhan@google.com>

        Move definition of nested classes that inherit enclosing class outside class definition.
        https://bugs.webkit.org/show_bug.cgi?id=113454

        Reviewed by Benjamin Poulain.

        HashMap.h does not build on GCC 4.8. Inside this file,
        HashMapKeysProxy and HashMapValuesProxy are defined as nested
        class inside HashMap - which is legal - the illegal part is that
        these 2 classes inherit HashMap, that is the enclosing class, that
        causes "reference to in-complete definition" error.

        The fix is to move outside the definition of these 2 classes, and
        leave only declaration part inside HashMap as is illustrated below -

          template class <typename T>
          class HashMap {
            ... ...
            ... ...
          private:
            class HashMapKeysProxy;

            // ERROR - nested class inherits enclosing class.
            class HashMapKeysProxy : private HashMap {
                ... ...
            };
            ... ...
            ... ...
            class HashMapKeysProxy : private HashMap {
                ... ...
            };
            ... ...
            ... ...
          };

        Fixed as below:
          template class <typename T>
          class HashMap {
            ... ...
            ... ...
          private:
            class HashMapKeysProxy;
            class HashMapValuesProxy;

            ... ...
            ... ...
          };

          template <typename T>
          class HashMap<T>::HashMapKeysProxy : private HashMap<T> {
            ... ...
          };

          template <typename T>
          class HashMap<T>::HashMapValuesProxy : private HashMap<T> {
            ... ...
          };

        * wtf/HashMap.h:
        (HashMap):
        (WTF): Factor out nested class definition from enclosing class.

2013-03-31  Mark Hahnenberg  <mhahnenberg@apple.com>

        Regions should be allocated from the same contiguous segment of virtual memory
        https://bugs.webkit.org/show_bug.cgi?id=113662

        Reviewed by Filip Pizlo.

        Instead of letting the OS spread our Regions all over the place, we should allocate them all within 
        some range of each other. This change will open the door to some other optimizations, e.g. doing simple 
        range checks for our write barriers and compressing JSCell pointers to 32-bits.

        * wtf/MetaAllocator.cpp: Changed the MetaAllocator to allow custom page sizes if the derived class wants to
        use something other than the system page size.
        (WTF::MetaAllocator::MetaAllocator):
        * wtf/MetaAllocator.h:
        (MetaAllocator):

2013-04-01  Yury Semikhatsky  <yurys@chromium.org>

        Web Inspector: add memory instrumentation for StringBuffer
        https://bugs.webkit.org/show_bug.cgi?id=113507

        Reviewed by Pavel Feldman.

        Added memory instrumentation for StringBuffer.

        * wtf/MemoryInstrumentationString.h:
        (WTF):
        (WTF::reportMemoryUsage):

2013-03-30  Tom Sepez  <tsepez@chromium.org>

        View-source iframes are dangerous (and not very useful).
        https://bugs.webkit.org/show_bug.cgi?id=113345

        Reviewed by Adam Barth.

        * wtf/FeatureDefines.h:
        Default definition of ENABLE_VIEWSOURCE_ATTRIBUTE is enabled.

2013-03-27  Patrick Gansterer  <paroga@webkit.org>

        Set WTF_ARM_ARCH_VERSION to correct value when used with MSVC
        https://bugs.webkit.org/show_bug.cgi?id=113436

        Reviewed by Benjamin Poulain.

        The Microsoft compiler defines _M_ARM with used ARM version.

        * wtf/Platform.h:

2013-03-27  Allan Sandfeld Jensen  <allan.jensen@digia.com>

        Support C++11 static_assert
        https://bugs.webkit.org/show_bug.cgi?id=113308

        Reviewed by Alexey Proskuryakov.

        Use the C++11 static_assert for COMPILE_ASSERT when it is available. Note that
        even when compiling with C++11 support, static_assert will not always be available
        since Assertions.h may also be used outside of C++.

        C11 _Static_assert is enabled for GCC when it has C11 support (gcc>=4.7 -std=c11).

        * wtf/Assertions.h:
        * wtf/Compiler.h:

2013-03-25  Oliver Hunt  <oliver@apple.com>

        RefCountedArray needs a size based constructor
        https://bugs.webkit.org/show_bug.cgi?id=113277

        Reviewed by Benjamin Poulain.

        Simple patch to add a size based constructor for RefCountedArray
        so that we can create an sharable array without a copy.

        * wtf/RefCountedArray.h:
        (RefCountedArray):
        (WTF::RefCountedArray::RefCountedArray):

2013-03-26  James Robinson  <jamesr@chromium.org>

        Compile fix - OS(WINDOWS), not OS(WIN).

        * wtf/ProcessID.h:
        (WTF::getCurrentProcessID):

2013-03-26  James Robinson  <jamesr@chromium.org>

        Fix compile for OS(WIN) != PLATFORM(WIN)
        https://bugs.webkit.org/show_bug.cgi?id=113356

        Reviewed by Tim Horton.

        * wtf/ProcessID.h:
        (WTF::getCurrentProcessID):

2013-03-23  Filip Pizlo  <fpizlo@apple.com>

        JSC_enableProfiler=true should also cause JSGlobalData to save the profiler output somewhere
        https://bugs.webkit.org/show_bug.cgi?id=113144

        Reviewed by Geoffrey Garen.
        
        I got tired of the fact that getpid(2) is not a syscall on Windows (unless you do
        _getpid() I believe), so I wrote a header that abstracts it. I also changed existing
        code that uses getpid() to use WTF::getCurrentProcessID().

        * GNUmakefile.list.am:
        * WTF.gypi:
        * WTF.pro:
        * WTF.vcproj/WTF.vcproj:
        * WTF.xcodeproj/project.pbxproj:
        * wtf/CMakeLists.txt:
        * wtf/MetaAllocator.cpp:
        (WTF::MetaAllocator::dumpProfile):
        * wtf/ProcessID.h: Added.
        (WTF):
        (WTF::getCurrentProcessID):
        * wtf/text/StringImpl.cpp:
        (WTF::StringStats::printStats):

2013-03-25  Kent Tamura  <tkent@chromium.org>

        Rename ENABLE_INPUT_TYPE_DATETIME
        https://bugs.webkit.org/show_bug.cgi?id=113254

        Reviewed by Kentaro Hara.

        Rename ENABLE_INPUT_TYPE_DATETIME to ENABLE_INPUT_TYPE_DATETIME_INCOMPLETE.
        Actually I'd like to remove the code, but we shouldn't remove it yet
        because we shipped products with it on some platforms.

        * wtf/FeatureDefines.h:

2013-03-25  David Kilzer  <ddkilzer@apple.com>

        WTF::binarySearchImpl() should compile with -Wshorten-64-to-32
        <http://webkit.org/b/113170>

        Reviewed by Dan Bernstein.

        Fixes the following build failure:

            /usr/local/include/wtf/StdLibExtras.h:190:30: error: implicit conversion loses integer precision: 'unsigned long' to 'int' [-Werror,-Wshorten-64-to-32]
                    int pos = (size - 1) >> 1;
                        ~~~   ~~~~~~~~~~~^~~~
            1 error generated.

        * wtf/StdLibExtras.h:
        (WTF::binarySearchImpl): Switch type from int to size_t.

2013-03-22  Benjamin Poulain  <bpoulain@apple.com>

        Remove 2 bad branches from StringHash::equal() and CaseFoldingHash::equal()
        https://bugs.webkit.org/show_bug.cgi?id=113003

        Reviewed by Eric Seidel.

        StringHash::equal() and CaseFoldingHash::equal() were both testing for
        the nullity of the two input pointers. The catch is: neither traits handle
        null pointers, and any client code would have crashed on hash(), before equal()
        is called.
        Consequently, the two branches had a pass rate of zero when called from a HashMap code.

        The function is also never inlined because it is too big (the code of equal() for characters
        is always inlined, causing the function to be quite big).

        This patch introduces two new functions in the StringImpl API: equalNonNull() and
        equalIgnoringCaseNonNull(). Those functions are similar to their equal() equivalent
        but make the assumtion the input is never null.

        The functions are used for StringHash to avoid the useless branches.

        * wtf/text/StringHash.h:
        (WTF::StringHash::equal):
        (WTF::CaseFoldingHash::equal):
        * wtf/text/StringImpl.cpp:
        (WTF::stringImplContentEqual):
        (WTF::equal):
        (WTF::equalNonNull):
        (WTF::equalIgnoringCase):
        (WTF::equalIgnoringCaseNonNull):
        (WTF::equalIgnoringNullity):
        * wtf/text/StringImpl.h:
        (WTF::equalIgnoringCase):

2013-03-22  Benjamin Poulain  <bpoulain@apple.com>

        Name correctly the argument of StringImpl::setIsAtomic()
        https://bugs.webkit.org/show_bug.cgi?id=113000

        Reviewed by Geoffrey Garen.

        * wtf/text/StringImpl.h:
        (WTF::StringImpl::setIsAtomic):
        The argument was probably an unfortunate copy-paste from setIsIdentifier().
        Fix the name.

2013-03-22  Hajime Morrita  <morrita@google.com>

        Custom Elements: "readyCallback" lifecycle callback should be called.
        https://bugs.webkit.org/show_bug.cgi?id=112538

        Reviewed by Elliott Sprehn.

        * wtf/HashSet.h:
        (WTF::copyToVector): Generalized to let it accept variants like ListHahsSet instead of only HashSet.

2013-03-22  Sheriff Bot  <webkit.review.bot@gmail.com>

        Unreviewed, rolling out r146534 and r146565.
        http://trac.webkit.org/changeset/146534
        http://trac.webkit.org/changeset/146565
        https://bugs.webkit.org/show_bug.cgi?id=113017

        "r146534 caused perf regression on Chromium Linux x64"
        (Requested by yurys on #webkit).

        * wtf/HashSet.h:
        (WTF):
        (WTF::copyToVector):

2013-03-21  Hajime Morrita  <morrita@google.com>

        Custom Elements: "readyCallback" lifecycle callback should be called.
        https://bugs.webkit.org/show_bug.cgi?id=112538

        Reviewed by Elliott Sprehn.

        * wtf/HashSet.h:
        (WTF::copyToVector): Generalized to let it accept variants like ListHahsSet instead of only HashSet.

2013-03-21  Mark Lam  <mark.lam@apple.com>

        Introducing String::findNextLineStart().
        https://bugs.webkit.org/show_bug.cgi?id=112957.

        Reviewed by Geoffrey Garen.

        This is replaces String::reverseFindLineTerminator() in the JSC
        debugger's code for computing column numbers.

        * wtf/text/StringImpl.cpp:
        (WTF::StringImpl::findNextLineStart):
        * wtf/text/StringImpl.h:
        (WTF::findNextLineStart):
        * wtf/text/WTFString.h:
        (WTF::String::findNextLineStart):

2013-03-21  Adam Barth  <abarth@webkit.org>

        HTMLNames should construct strings at compile time
        https://bugs.webkit.org/show_bug.cgi?id=112831

        Reviewed by Darin Adler.

        * wtf/text/StringImpl.h:
        (StringImpl):
        (StaticASCIILiteral):
            - This struct lets us construct StringImpl objects at compile time.
        (WTF::StringImpl::assertHashIsCorrect):
            - This function lets us sanity check StringImpl objects created from StaticData.
        (WTF::StringImpl::find): Remove a stray ;
        (WTF::StringImpl::findIgnoringCase): ditto
        (WTF::StringImpl::startsWith): ditto
        (WTF::ValueCheck<StringImpl*>):
        * wtf/text/AtomicStringImpl.h:
        (WTF::ValueCheck<AtomicStringImpl*>):

2013-03-21  Gabor Rapcsanyi  <rgabor@webkit.org>

        Implement LLInt for CPU(ARM_TRADITIONAL)
        https://bugs.webkit.org/show_bug.cgi?id=97589

        Reviewed by Zoltan Herczeg.

        Enable LLInt for ARMv5 and ARMv7 traditional as well.

        * wtf/Platform.h:

2013-03-20  Sheriff Bot  <webkit.review.bot@gmail.com>

        Unreviewed, rolling out r146419.
        http://trac.webkit.org/changeset/146419
        https://bugs.webkit.org/show_bug.cgi?id=112870

        Broke many tests on debug builds (Requested by rniwa_ on
        #webkit).

        * wtf/text/StringImpl.h:
        (StringImpl):

2013-03-20  Adam Barth  <abarth@webkit.org>

        HTMLNames should construct strings at compile time
        https://bugs.webkit.org/show_bug.cgi?id=112831

        Reviewed by Darin Adler.

        * wtf/text/StringImpl.h:
        (StringImpl):
        (StaticASCIILiteral):
            - This struct lets us construct StringImpl objects at compile time.
        (WTF::StringImpl::assertValidHash):
            - This function lets us sanity check StringImpl objects created from StaticData.

2013-03-20  Jessie Berlin  <jberlin@apple.com>

        REGRESSION(r145592): AutodrainedPool.h. RunLoopTimer.h, SchedulePair.h are being copied into
        the wrong location
        https://bugs.webkit.org/show_bug.cgi?id=112833

        Reviewed by Darin Adler.

        * WTF.xcodeproj/project.pbxproj:
        Make sure those three headers are copied with the rest of the WTF headers.

2013-03-20  Mark Rowe  <mrowe@apple.com>

        FastMalloc scavenge timer specifies an overly narrow leeway value.

        Reviewed by Alexey Proskuryakov.

        There's no need to allow only 1ms of leeway on a 2s timer.

        * wtf/FastMalloc.cpp:
        (WTF::TCMalloc_PageHeap::initializeScavenger): Bump the leeway window
        to 10% of the scavenge timer.

2013-03-20  JungJik Lee  <jungjik.lee@samsung.com>

        [EFL] Disable REQUEST_ANIMATION_FRAME_TIMER to render a new animation frame.
        https://bugs.webkit.org/show_bug.cgi?id=112114

        Reviewed by Kenneth Rohde Christiansen.

        The issue is that if the animation starts outside of the area covered by keepRects,
        the web process does not create tiles of the animation layer and the layer moves 
        without having any tiles. In order to fix this issue, CoordinatedLayerHost must call 
        scheduleLayerFlush to create new tiles when the layer enters the area covered by keepRect.
        However EFL port didn't call scheduleLayerFlush periodically for animation.
        We can tie scripted animations with synchronization of the layer and that already 
        has been implemented in r123786 by Qt port. This patch is for activating r123786 patch.

        The testing is covered by ManualTests/animation/transition-on-and-offscreen-animation.html

        * wtf/Platform.h: Disable REQUEST_ANIMATION_FRAME_TIMER.

2013-03-20  Mark Lam  <mark.lam@apple.com>

        Introducing String::reverseFindLineTerminator().
        https://bugs.webkit.org/show_bug.cgi?id=112741.

        Reviewed by Oliver Hunt.

        This is needed by the JSC debugger code for computing column numbers.

        * wtf/text/StringImpl.cpp:
        (WTF::StringImpl::reverseFindLineTerminator):
        * wtf/text/StringImpl.h:
        (StringImpl):
        (WTF::reverseFindLineTerminator):
        * wtf/text/WTFString.h:
        (WTF::String::reverseFindLineTerminator):

2013-03-19  Martin Robinson  <mrobinson@igalia.com>

        Fix the WTF gyp build for GTK+.

        * WTF.gyp/WTFGTK.gyp: Skip files with CF in the name.

2013-03-19  Alberto Garcia  <agarcia@igalia.com>

        [BlackBerry] Enable USE_SYSTEM_MALLOC by default
        https://bugs.webkit.org/show_bug.cgi?id=112365

        Reviewed by Benjamin Poulain.

        Enable USE_SYSTEM_MALLOC by default via FeatureList.pm instead of
        harcoding it in wtf/Platform.h

        * wtf/Platform.h:

2013-03-18  Benjamin Poulain  <benjamin@webkit.org>

        [iOS] Make a UChar string equal() based on the LChar version
        https://bugs.webkit.org/show_bug.cgi?id=112495

        Reviewed by David Kilzer.

        * wtf/text/StringImpl.h:
        (WTF::equal):
        Create a equal() function for UChar based on the work done for LChar.

        On A6, this is a speed up of about 40% for any string of 2 or more characters.
        It is slower by 8% on a single UChar comparison.

2013-03-18  Brent Fulgham  <bfulgham@webkit.org>

        [WinCairo] Get build working under VS2010.
        https://bugs.webkit.org/show_bug.cgi?id=112604

        Reviewed by Tim Horton.

        * WTF.vcxproj/WTF.vcxproj: Add Debug_WinCairo and Release_WinCairo
        targets so headers get copied to appropriate build folder.
        * WTF.vcxproj/WTFGenerated.vcxproj: Ditto.

2013-03-15  Benjamin Poulain  <bpoulain@apple.com>

        [iOS] Update StringImpl's equal to have a single version on all supported Apple CPUs
        https://bugs.webkit.org/show_bug.cgi?id=112400

        Reviewed by Michael Saboff.

        * wtf/text/StringImpl.h:
        (WTF::equal):
        Tweak the code to make it work on older Apple CPUs:
        -Use external "ouput" variable instead of the registers R9 and R12. This gets rid
         of some register pressure previously imposed on the compiler. (Clang nicely
         choose R9 and R12 when needed, following iOS ABI).
        -Instead of using "R3" for storing the length / 4, update the length by -4 on
         each iteration and work in the negative space for the tail. This frees one register
         which is then used for isEqual.
        -Get rid of the unconditional branch from the loop. By using subs and working in the
         negative space, we can test for the Carry flag to jump back to the next LDR.

2013-03-15  Benjamin Poulain  <bpoulain@apple.com>

        [iOS] Fix the length pass to memcmp in the fallback versions of String's equal
        https://bugs.webkit.org/show_bug.cgi?id=112463

        Reviewed by Ryosuke Niwa.

        * wtf/text/StringImpl.h:
        (WTF::equal): It might be a good idea to compare the full UChar strings...

2013-03-15  Michael Saboff  <msaboff@apple.com>

        Add runtime check for improper register allocations in DFG
        https://bugs.webkit.org/show_bug.cgi?id=112380

        Reviewed by Geoffrey Garen.

        * wtf/Platform.h: Added new ENABLE_DFG_REGISTER_ALLOCATION_VALIDATION compilation flag to
        enable generation of register allocation checking.  This is on for debug builds.

2013-03-13  Jessie Berlin  <jberlin@apple.com>

        Remove svn:executable from a file that isn't supposed to be executable.

        Rubber-stamped by Geoff Garen.

        * wtf/MediaTime.h:

2013-03-13  Oliver Hunt  <oliver@apple.com>

        Simplify Checked<> multiplication
        https://bugs.webkit.org/show_bug.cgi?id=112286

        Reviewed by James Robinson.

        Trying to correctly identify multiplication by zero complicated the
        unsigned * unsigned multiply, and still didn't handle all cases correctly.
        Now we just do the normal division based approach to overflow detection
        leading to much simpler reasoning.

        Would be nice if we could have a jo style intrinsic one day.

        * wtf/CheckedArithmetic.h:

2013-03-13  Dean Jackson  <dino@apple.com>

        Unreviewed attempted build fix for Windows. SchedulePair.cpp -> SchedulePairCF.cpp

        * WTF.vcproj/WTF.vcproj:
        * WTF.vcxproj/WTF.vcxproj:
        * WTF.vcxproj/WTF.vcxproj.filters:

2013-03-13  Benjamin Poulain  <bpoulain@apple.com>

        [iOS] Add optimized version of StringImpl's equal(LChar*,LChar*) for Apple CPUs
        https://bugs.webkit.org/show_bug.cgi?id=112202

        Reviewed by Gavin Barraclough.

        * Source/WTF/wtf/Platform.h:
        Make the macro WTF_ARM_ARCH_VERSION valid on any architecture.
        * wtf/text/StringImpl.h:
        (WTF::equal):
        On ARMv7S, the new version is about 11% percent faster than the simple loop.
        On ARMv7 classic, memcmp is a little faster than the simple loop on Apple A5.

2013-03-13  James Robinson  <jamesr@chromium.org>

        SchedulePair.cpp is CF-specific
        https://bugs.webkit.org/show_bug.cgi?id=112204

        Reviewed by Oliver Hunt.

        This renames SchedulePair.cpp SchedulePairCF.cpp, since it depends on CF, and excludes it from chromium's gyp
        files.

        * WTF.gyp/WTF.gyp:
          Add CF to the exclusion filter for the Chromium port.
        * WTF.gypi:
          Add SchedulePairCF.cpp
        * WTF.xcodeproj/project.pbxproj:
          Update project file to point to new .cpp location
        * wtf/SchedulePairCF.cpp: Renamed from Source/WTF/wtf/SchedulePair.cpp.

2013-03-13  Allan Sandfeld Jensen  <allan.jensen@digia.com>

        Support C++11 features in GCC <4.6
        https://bugs.webkit.org/show_bug.cgi?id=111553

        Reviewed by Simon Hausmann.

        Enable support for rvalue references from gcc 4.3, deleted functions
        from gcc 4.4, explicit conversion from gcc 4.5, and strongly typed
        enums from gcc 4.6. 

        * wtf/Compiler.h:

2013-03-12  Geoffrey Garen  <ggaren@apple.com>

        Unreviewed attempted Windows build fix after http://trac.webkit.org/changeset/145592.

        * wtf/SchedulePair.cpp:
        * wtf/SchedulePair.h:
        (WTF::SchedulePair::SchedulePair): Since linking is failing,
        try inlining this function.

2013-03-12  Tim Horton  <timothy_horton@apple.com>

        Typo in earlier Windows build fix. Unreviewed.

        * WTF.vcproj/WTF.vcproj:

2013-03-12  Tim Horton  <timothy_horton@apple.com>

        Unreviewed attempted Windows build fix after http://trac.webkit.org/changeset/145592.

        * WTF.vcproj/WTF.vcproj:
        * WTF.vcxproj/WTF.vcxproj:
        * WTF.vcxproj/WTF.vcxproj.filters:

2013-03-12  James Robinson  <jamesr@chromium.org>

        Build fix for r145592 - update gyp files to refer to new file locations.

        * WTF.gypi:

2013-03-12  Geoffrey Garen  <ggaren@apple.com>

        Moved RunLoopTimer and SchedulePair to WTF
        https://bugs.webkit.org/show_bug.cgi?id=112171

        Reviewed by Oliver Hunt.

        This will allow us to use timers in lower level primitives without
        duplicating all the code.

        * WTF.xcodeproj/project.pbxproj:
        * wtf/AutodrainedPool.h: Copied from Source/WebCore/platform/AutodrainedPool.h.
        (AutodrainedPool):
        * wtf/AutodrainedPoolMac.mm: Copied from Source/WebCore/platform/mac/AutodrainedPool.mm.
        * wtf/RunLoopTimer.h: Copied from Source/WebCore/platform/RunLoopTimer.h.
        * wtf/RunLoopTimerCF.cpp: Copied from Source/WebCore/platform/cf/RunLoopTimerCF.cpp.
        * wtf/SchedulePair.cpp: Copied from Source/WebCore/platform/cf/SchedulePair.cpp.
        * wtf/SchedulePair.h: Copied from Source/WebCore/platform/cf/SchedulePair.h.
        (SchedulePair):
        * wtf/SchedulePairMac.mm: Copied from Source/WebCore/platform/mac/SchedulePairMac.mm.

2013-03-12  Oliver Hunt  <oliver@apple.com>

        Add more Checked<> tests
        https://bugs.webkit.org/show_bug.cgi?id=112190

        Reviewed by Geoffrey Garen.

        Export the CheckedState enum type

        * wtf/CheckedArithmetic.h:

2013-03-12  Oliver Hunt  <oliver@apple.com>

        Make CheckedArithmetic slightly more sane
        https://bugs.webkit.org/show_bug.cgi?id=112178

        Reviewed by Geoffrey Garen.

        Add an enum type for safeGet rather than using a bool,
        and correctly handle unsigned * unsigned, when one value
        is 0.

        * wtf/CheckedArithmetic.h:
        (WTF::ENUM_CLASS):
        (WTF):
        (WTF::operator+):
        (WTF::operator-):
        (WTF::operator*):

2013-03-11  Michael Saboff  <msaboff@apple.com>

        Unreviewed build fix.  Rolling out inadvertent setting of DATA_LOG_TO_FILE.

2013-03-11  Oliver Hunt  <oliver@apple.com>

        Make SegmentedVector Noncopyable
        https://bugs.webkit.org/show_bug.cgi?id=112059

        Reviewed by Geoffrey Garen.

        Copying a SegmentedVector can be extraordinarily expensive, so we beat
        it with the Noncopyable stick - that way we can ensure that if anyone
        wants an actual copy they know what they're doing.

        * wtf/SegmentedVector.h:
        (SegmentedVector):

2013-03-08  Benjamin Poulain  <benjamin@webkit.org>

        [Mac] Add a feature flag for 'view-mode' Media Feature, disable it on Mac
        https://bugs.webkit.org/show_bug.cgi?id=111297

        Reviewed by Kenneth Rohde Christiansen.

        * wtf/FeatureDefines.h: Add a new feature flag for the view-mode
        CSS media: ENABLE_VIEW_MODE_CSS_MEDIA.

2013-03-08  Roger Fong  <roger_fong@apple.com>

        Makefile fixes.

        * WTF.vcxproj/WTF.make:

2013-03-08  Gabor Rapcsanyi  <rgabor@webkit.org>

        Cache flush problem on ARMv7 JSC
        https://bugs.webkit.org/show_bug.cgi?id=111441

        Reviewed by Zoltan Herczeg.

        Not proper cache flush causing random crashes on ARMv7 Linux with V8 tests.
        The problem is similar to https://bugs.webkit.org/show_bug.cgi?id=77712.
        Change the cache fulsh mechanism similar to ARM traditinal and revert the
        temporary fix.

        * wtf/OSAllocatorPosix.cpp:
        (WTF::OSAllocator::reserveUncommitted):
        (WTF::OSAllocator::decommit):

2013-03-07  Andrew Bortz  <andrew@abortz.net>

        Replace Mersenne Twister random number generator with a simpler one.
        https://bugs.webkit.org/show_bug.cgi?id=111533

        Reviewed by Adam Barth.

        The new generator is only a single line long, but passes all the Diehard
        statistical tests and runs ~3x faster than the Mersenne Twister, with a
        guaranteed cycle length of 2^64 and only 8 bytes of state.
        
        * wtf/Platform.h: Mersenne Twister defines are no longer needed
        * wtf/RandomNumber.cpp:
        (WTF::Internal::initializeRandomNumber): State initialization
        (WTF::Internal::randomNumber): Actual implementation
        (WTF::randomNumber): We don't need to fall back on rand()-based generator anymore,
        so this code is greatly simplified.
        * wtf/RandomNumber.h:
        * wtf/RandomNumberSeed.h:
        (WTF::initializeRandomNumberGenerator): This code is no longer needed.
        Additionally, the code had an error, since rand() returns 32-bits, so each
        initializationBuffer's upper 16-bits has more bits set than random.

2013-03-06  Adenilson Cavalcanti  <cavalcantii@gmail.com>

        Build fix: PageAllocationAligned no longer has executable flag
        https://bugs.webkit.org/show_bug.cgi?id=111659

        Reviewed by Kentaro Hara.

        Build fix: use false as parameter to execution flag.

        * wtf/PageAllocationAligned.cpp:
        (WTF::PageAllocationAligned::allocate):

2013-03-06  Eric Seidel  <eric@webkit.org>

        AtomicStringImpls are not safe to send between threads
        https://bugs.webkit.org/show_bug.cgi?id=111652

        Reviewed by Benjamin Poulain.

        We don't have this problem yet, but it's good to be safe.

        * wtf/text/WTFString.cpp:
        (WTF::String::isSafeToSendToAnotherThread):

2013-03-06  Oliver Hunt  <oliver@apple.com>

        Don't give PageAllocationAligned the option to allocate executable memory
        https://bugs.webkit.org/show_bug.cgi?id=111657

        Reviewed by Geoffrey Garen.

        * wtf/PageAllocationAligned.cpp:
        (WTF::PageAllocationAligned::allocate):
        * wtf/PageAllocationAligned.h:
        (PageAllocationAligned):

2013-03-04  Jer Noble  <jer.noble@apple.com>

        Default mouse cursor behavior should be auto-hide for full screen video with custom controls
        https://bugs.webkit.org/show_bug.cgi?id=107601

        Reviewed by Beth Dakin.

        Enable the CURSOR_VISIBILITY feature.

        * wtf/FeatureDefines.h:

2013-03-04  Oliver Hunt  <oliver@apple.com>

        Make fastmalloc use guardpages
        https://bugs.webkit.org/show_bug.cgi?id=111353

        Reviewed by Anders Carlsson.

        Add PROT_NONE pages at the beginning and end of every
        mmap call made by fastmalloc.

        * wtf/TCSystemAlloc.cpp:
        (TryMmap):

2013-03-06  Paweł Forysiuk  <tuxator@o2.pl>

        Typo in inline function in ByteOrder.h
        https://bugs.webkit.org/show_bug.cgi?id=111473

        Reviewed by Benjamin Poulain.

        * wtf/ByteOrder.h:
        (ntohs):

2013-03-05  Ryuan Choi  <ryuan.choi@samsung.com>

        [EFL] Build break with latest EFL libraries
        https://bugs.webkit.org/show_bug.cgi?id=111028

        Reviewed by Dirk Pranke.

        * wtf/PlatformEfl.cmake: Added ECORE_IMF_INCLUDE_DIRS.

2013-03-05  Csaba Osztrogonác  <ossy@webkit.org>

        Fix cast-align warning in ASCIIFastPath.h on ARM
        https://bugs.webkit.org/show_bug.cgi?id=111436

        Reviewed by Benjamin Poulain.

        * wtf/text/ASCIIFastPath.h:
        (WTF::charactersAreAllASCII):

2013-03-04  Laszlo Gombos  <l.gombos@samsung.com>

        JSC_OBJC_API_ENABLED should be removed from FeatureDefines.h
        https://bugs.webkit.org/show_bug.cgi?id=111269

        Reviewed by Mark Hahnenberg.

        JSC_OBJC_API_ENABLED flag was added to FeatureDefines.h (r143637) 
        so that it could be used in WebCore.exp.in to determine whether 
        or not we should be exporting certain symbols based on whether 
        the WebKit-related portion of the JSC ObjC API was enabled.
        
        It turned out conditionally including certain symbols didn't
        work when building fat binaries, so it's not even necessary any more.

        * wtf/FeatureDefines.h: Remove JSC_OBJC_API_ENABLED.

2013-03-04  Andreas Kling  <akling@apple.com>

        Deque: Free internal buffer in clear().
        <http://webkit.org/b/111316>
        <rdar://problem/13336675>

        Reviewed by Antti Koivisto.

        525 kB progression on Membuster3.

        * wtf/Deque.h:
        (WTF::::clear):

2013-03-04  Kunihiko Sakamoto  <ksakamoto@chromium.org>

        Add build flag for FontLoader
        https://bugs.webkit.org/show_bug.cgi?id=111289

        Reviewed by Benjamin Poulain.

        Add ENABLE_FONT_LOAD_EVENTS build flag (disabled by default).

        * wtf/FeatureDefines.h:

2013-02-27  Darin Adler  <darin@apple.com>

        StringHasher functions require alignment that call sites do not all guarantee
        https://bugs.webkit.org/show_bug.cgi?id=110171

        Reviewed by Benjamin Poulain.

        The StringHasher class is optimized for clients who pass it two characters at
        a time. However, the function named addCharacters did not make this clear to
        clients, and one calculateStringHashAndLengthFromUTF8MaskingTop8Bits got it wrong.
        Fix by making addCharacters work regardless of hasher alignment and adding a new
        function, addCharactersAssumingAligned, for use when we want a faster path and can
        guarantee we are adding characters two at a time.

        * wtf/StringHasher.h:
        (WTF::StringHasher::addCharactersAssumingAligned): Renamed the addCharacters function
        addCharactersAssumingAligned, since it only works if the hasher is currently aligned,
        meaning it contains an even number of characters. The function already asserts
        that this is true, but the calculateStringHashAndLengthFromUTF8MaskingTop8Bits
        function was using it in cases where the assertion could fire. Also updated to
        call addCharactersInternal by its new name. Also added some new overloads that take
        data pointers and lengths so callers can always use addCharactersAssumingAligned
        instead of addCharacters if they know the hasher is aligned.
        (WTF::StringHasher::addCharacter): Updated to call the public
        addCharactersAssumingAligned function since that's simpler and a bit cleaner.
        (WTF::StringHasher::addCharacters): Added functions with this name that handle
        the case where the hasher is not aligned. These will be called by existing call sites
        that were formerly using the function named addCharactersAssumingAligned above.
        Also add an overload that works with the default converter automatically.
        (WTF::StringHasher::computeHashAndMaskTop8Bits): Changed to call
        addCharactersAssumingAligned to eliminate copied and pasted code. The hasher is empty,
        so definitely aligned.
        (WTF::StringHasher::computeHash): Ditto.
        (WTF::StringHasher::addCharactersInternal): Renamed from addCharactersToHash, since
        the former name did not make clear how this differs from the public functions.
        The real difference is that this is like addCharactersAssumingAligned, but without
        the assertion, so addCharactersAssumingAligned is called instead, even within the
        class's implementation.

2013-03-01  Ilya Tikhonovsky  <loislo@chromium.org>

        Web Inspector: Native Memory Instrumentation: do not visit raw pointers by default.
        https://bugs.webkit.org/show_bug.cgi?id=110943

        Reviewed by Yury Semikhatsky.

        Unfortunately in many cases raw pointer may point to an object that has been deleted.
        There is no working solution to solve this problem in general.
        It could be solved only on case by case basis.

        * wtf/MemoryInstrumentation.h:
        (WTF::MemoryInstrumentation::addObject):
        (WTF::MemoryInstrumentation::MemberTypeTraits::addObject):
        (WTF::MemoryClassInfo::addMember):
        (WTF::MemoryInstrumentation::addObjectImpl):
        * wtf/MemoryInstrumentationString.h:
        (WTF::reportMemoryUsage):

2013-03-01  Eric Seidel  <eric@webkit.org>

        Threaded HTML Parser has an extra copy of every byte from the network
        https://bugs.webkit.org/show_bug.cgi?id=111135

        Reviewed by Adam Barth.

        The threaded html parser needs to accept ownership
        of a string buffer.  The easiest way to do this seemed
        to be to use a PassRefPtr<StringImpl>, but there was no way
        to generated one from a String (easily), so I added one.

        * wtf/text/WTFString.h:
        (WTF::String::releaseImpl):

2013-02-28  Oliver Hunt  <oliver@apple.com>

        Crash in JSC::MarkedBlock::FreeList JSC::MarkedBlock::sweepHelper
        https://bugs.webkit.org/show_bug.cgi?id=111059

        Reviewed by Ryosuke Niwa.

        Sometimes C++'s implicit operator conversion rules suck.
        Add explicit operator== and !=.

        * wtf/FastMalloc.cpp:
        (WTF::HardenedSLL::operator!=):
        (WTF::HardenedSLL::operator==):
        (HardenedSLL):

2013-02-28  Zeno Albisser  <zeno@webkit.org>

        Enable DFG JIT for Qt on Mac
        https://bugs.webkit.org/show_bug.cgi?id=111095

        Rubber-stamped by Simon Hausmann

        * wtf/Platform.h:

2013-02-28  Eric Carlson  <eric.carlson@apple.com>

        [Mac] use HAVE() macro instead of version check
        https://bugs.webkit.org/show_bug.cgi?id=111087

        Reviewed by Dean Jackson.

        * wtf/Platform.h: Define HAVE_MEDIA_ACCESSIBILITY_FRAMEWORK.

2013-02-27  Balazs Kilvady  <kilvadyb@homejinni.com>

        Bug in atomicIncrement implementation for MIPS GCC
        https://bugs.webkit.org/show_bug.cgi?id=110969

        Reviewed by Csaba Osztrogonác.

        Fix of __sync_[add|sub]_and_fetch_8 for GCC patch.

        * wtf/Atomics.cpp:

2013-02-27  Simon Hausmann  <simon.hausmann@digia.com>

        REGRESSION(r137994): It made JSC tests hang and layout tests fail on ARM Thumb2 / Linux
        https://bugs.webkit.org/show_bug.cgi?id=108632

        Reviewed by Csaba Osztrogonác.

        It appears that mprotect() is very slow on ARM/Linux, so disable the
        approach of unreserved mappings there and fall back to overcomitting
        memory, based on Uli Schlachter's recommendation.

        * wtf/OSAllocatorPosix.cpp:
        (WTF::OSAllocator::reserveUncommitted):
        (WTF::OSAllocator::decommit):

2013-02-26  Roger Fong  <roger_fong@apple.com>

        Unreviewed. Build fix for VS2010 solution, take 2.

        * WTF.vcxproj/work-around-vs-dependency-tracking-bugs.py:

2013-02-26  Roger Fong  <roger_fong@apple.com>

        Unreviewed. Unreviewed build fix for VS2010 solution.

        * WTF.vcxproj/work-around-vs-dependency-tracking-bugs.py:

2013-02-26  Balazs Kilvady  <kilvadyb@homejinni.com>

        Fix the atomicIncrement implementation for MIPS GCC
        https://bugs.webkit.org/show_bug.cgi?id=106739

        Reviewed by Oliver Hunt.

        Implementation of missing __sync_[add|sub]_and_fetch_8 functions.

        Some architectures, like MIPS32, don't have GCC implementation for
        builtin __sync_* functions with 64 bits variable size. GCC answer
        for the problem: If a target doesn't support atomic operations on
        certain variable sizes, you are out of luck with atomicity in that
        case (http://gcc.gnu.org/bugzilla/show_bug.cgi?id=56296). GCC >= 4.8
        will support __atomic_* builtin functions for this purpose for all
        the GCC targets, but for current compilers we have to include our
        own implementation.

        * GNUmakefile.list.am:
        * WTF.pro:
        * wtf/Atomics.cpp: Added.
        (WTF):
        (WTF::getSwapLock):
        (WTF::atomicStep):
        * wtf/CMakeLists.txt:

2013-02-26  Oliver Hunt  <oliver@apple.com>

        Appease the QT bots.

        * wtf/FastMalloc.cpp:

2013-02-26  Jocelyn Turcotte  <jocelyn.turcotte@digia.com>

        Implement JIT on Windows 64 bits
        https://bugs.webkit.org/show_bug.cgi?id=107965

        Reviewed by Simon Hausmann.

        * wtf/Platform.h:

2013-02-26  Oliver Hunt  <oliver@apple.com>

        Appease static analyzer warning about null string passed to strlen
        https://bugs.webkit.org/show_bug.cgi?id=110658

        Reviewed by Benjamin Poulain.

        Add a null check before calling strlen

        * wtf/Threading.cpp:
        (WTF::createThread):

2013-02-25  Ryosuke Niwa  <rniwa@webkit.org>

        Build fix attempt after r143996.

        * wtf/FastMalloc.cpp:
        (WTF):

2013-02-25  Roger Fong  <roger_fong@apple.com>

        Unreviewed. Fix script to use WEBKIT_SOURCE for VS2010 property sheets instead of WEBKIT_LIBRARIES.

        * WTF.vcxproj/work-around-vs-dependency-tracking-bugs.py:

2013-02-25  Oliver Hunt  <oliver@apple.com>

        Add cookies to FastMalloc spans
        https://bugs.webkit.org/show_bug.cgi?id=110827

        Reviewed by Michael Saboff.

        Add a cookie to spans, and move some of the hardening around so
        that it's more useful.

        * wtf/FastMalloc.cpp:
        (WTF::internalEntropyValue):
        (WTF::spanInitializerCookie):
        (WTF::Span::initCookie):
        (WTF::Span::clearCookie):
        (WTF::Span::isValid):
        (Span):
        (WTF::NewSpan):
        (WTF::DeleteSpan):
        (WTF::TCMalloc_ThreadCache_FreeList::Validate):
        (WTF::TCMalloc_Central_FreeList::Populate):
        (WTF::TCMalloc_ThreadCache::Deallocate):
        (WTF::TCMalloc_ThreadCache::CreateCacheIfNecessary):

2013-02-25  Jer Noble  <jer.noble@apple.com>

        Normalize ENABLE_ENCRYPTED_MEDIA definitions across all FeatureDefines files.
        https://bugs.webkit.org/show_bug.cgi?id=110806

        Reviewed by Alexey Proskuryakov.

        Ensure both ENCRYPTED_MEDIA and ENCRYPTED_MEDIA_V2 are enabled on macosx_1090.

        * wtf/FeatureDefines.h:

2013-02-23  Ilya Tikhonovsky  <loislo@chromium.org>

        Web Inspector: Native Memory Instrumentation: replace String with const char* in MemoryObjectInfo
        https://bugs.webkit.org/show_bug.cgi?id=110599

        Reviewed by Yury Semikhatsky.

        Due to potentially dynamic nature of names and classNames we need to make a copy of the strings
        that were given us via MemoryInstrumentation calls.
        So I extended client api with registerString method that pushes the strings
        down to the serializer.

        * wtf/MemoryInstrumentation.h:
        (MemoryInstrumentationClient):
        * wtf/MemoryObjectInfo.h:
        (WTF::MemoryObjectInfo::MemoryObjectInfo):
        (WTF::MemoryObjectInfo::setClassName):
        (WTF::MemoryObjectInfo::classNameId):
        (WTF::MemoryObjectInfo::setName):
        (WTF::MemoryObjectInfo::nameId):
        (MemoryObjectInfo):

2013-02-21  Brady Eidson  <beidson@apple.com>

        Move fastlog2() to WTF/MathExtras.h so it can be used from multiple projects.

        Rubberstamped by Geoff Garen.

        * wtf/MathExtras.h:
        (WTF::fastLog2):

2013-02-21  Andy Estes  <aestes@apple.com>

        TriState.h should be a Project header
        https://bugs.webkit.org/show_bug.cgi?id=110543

        Rubber-stamped by Dan Bernstein.

        WTF uses a script to copy headers to the build destination, so it isn't
        necessary to mark headers as Private/Public (and doing so can be problematic).

        * WTF.xcodeproj/project.pbxproj: Mark TriState.h as a Project header.

2013-02-21  Roger Fong  <roger_fong@apple.com>

        Unreviewed. Add executable property to cmd file.
        Required for executable files to maintain their executable permissions over svn.

        * WTF.vcxproj/copy-files.cmd: Added property svn:executable.

2013-02-19  Mark Hahnenberg  <mhahnenberg@apple.com>

        Objective-C API: Need a way to use the Objective-C JavaScript API with WebKit
        https://bugs.webkit.org/show_bug.cgi?id=106059

        Reviewed by Geoffrey Garen.

        * wtf/FeatureDefines.h: Added enable flag for JSC Objective-C API so it can be used in
        export files.

2013-02-21  Martin Robinson  <mrobinson@igalia.com>

        A couple more 'make dist' fixes for WebKitGTK+.

        * GNUmakefile.list.am: Add a missing file to the source list.

2013-02-20  Roger Fong  <roger_fong@apple.com>

        Get VS2010 Solution B&I ready.
        <rdar://problem/1322988>

        Rubberstamped by Timothy Horton.        
        
        Add Production configuration. 
        Add a WTF submit solution with a DebugSuffix configuration. 
        Modify WTF.make as necessary.
        
        * WTF.vcxproj: Added property svn:eol-style. Modified property svn:ignore.
        * WTF.vcxproj/WTF.make: Added.
        * WTF.vcxproj/WTF.submit.sln: Added.
        * WTF.vcxproj/WTF.vcxproj:
        * WTF.vcxproj/WTFCommon.props:
        * WTF.vcxproj/WTFGenerated.vcxproj:
        * WTF.vcxproj/WTFGeneratedProduction.props: Added.
        * WTF.vcxproj/WTFGeneratedRelease.props:
        * WTF.vcxproj/WTFProduction.props: Added.
        * WTF.vcxproj/WTFRelease.props:
        * WTF.vcxproj/copy-files.cmd:

2013-02-20  Oliver Hunt  <oliver@apple.com>

        Moar hardening
        https://bugs.webkit.org/show_bug.cgi?id=110275

        Reviewed by Mark Hahnenberg.

        We now poison objects when they get freed, and verify that
        any object that is being freed is not poisoned.  If the
        object looks like it's poisoned we validate the freelist,
        and ensure the object is not already present.  If it is
        we crash.

        On allocation, we ensure that the object being allocated
        is poisoned, then clear the poisoning fields.

        * wtf/FastMalloc.cpp:
        (WTF::internalEntropyValue):
        (WTF):
        (WTF::freedObjectStartPoison):
        (WTF::freedObjectEndPoison):
        (TCMalloc_ThreadCache_FreeList):
        (WTF::TCMalloc_ThreadCache_FreeList::Validate):
        (WTF::TCMalloc_Central_FreeList::Populate):
        (WTF::TCMalloc_ThreadCache::Allocate):
        (WTF::TCMalloc_ThreadCache::Deallocate):
        (WTF::TCMalloc_ThreadCache::CreateCacheIfNecessary):

2013-02-19  Sheriff Bot  <webkit.review.bot@gmail.com>

        Unreviewed, rolling out r143400.
        http://trac.webkit.org/changeset/143400
        https://bugs.webkit.org/show_bug.cgi?id=110290

        breaks everything (instacrash launching Safari) (Requested by
        thorton on #webkit).

        * wtf/FastMalloc.cpp:
        (WTF::internalEntropyValue):
        (WTF):
        (WTF::TCMalloc_Central_FreeList::Populate):
        (WTF::TCMalloc_ThreadCache::Allocate):
        (WTF::TCMalloc_ThreadCache::Deallocate):

2013-02-19  Oliver Hunt  <oliver@apple.com>

        Moar hardening
        https://bugs.webkit.org/show_bug.cgi?id=110275

        Reviewed by Anders Carlsson.

        We now poison objects when they get freed, and verify that
        any object that is being freed is not poisoned.  If the
        object looks like it's poisoned we validate the freelist,
        and ensure the object is not already present.  If it is
        we crash.

        On allocation, we ensure that the object being allocated
        is poisoned, then clear the poisoning fields.

        * wtf/FastMalloc.cpp:
        (WTF::internalEntropyValue):
        (WTF):
        (WTF::freedObjectStartPoison):
        (WTF::freedObjectEndPoison):
        (TCMalloc_ThreadCache_FreeList):
        (WTF::TCMalloc_ThreadCache_FreeList::Validate):
        (WTF::TCMalloc_Central_FreeList::Populate):
        (WTF::TCMalloc_ThreadCache::Allocate):
        (WTF::TCMalloc_ThreadCache::Deallocate):

2013-02-18  Darin Adler  <darin@apple.com>

        Style tweaks to StringHasher.h
        https://bugs.webkit.org/show_bug.cgi?id=110042

        Reviewed by Alexey Proskuryakov.

        I have a bug fix coming soon, but figured I'd separate out style tweaks and land them
        first to make that patch easier to undrestand.

        * wtf/StringHasher.h: Tweak and rearrange comments a bit.
        (WTF::StringHasher::addCharacter): Use character instead of ch.
        (WTF::StringHasher::addCharacters): Use remainder instead of rem. Also capitalize the U
        that we use to make an unsigned 1 constant.
        (WTF::StringHasher::computeHashAndMaskTop8Bits): Ditto.
        (WTF::StringHasher::hashMemory): Change version that takes size as a template argument
        to call the version that takes the size at runtime, since both generate the same code
        anyway. Added a FIXME questioning why this function uses the "mask top 8 bits" version
        of the hash. Fix incorrect compile assertion that required sizes that are multiples
        of four. This function works on sizes that are multiples of two. Also fixed a spelling
        error where we called it a "multible".
        (WTF::StringHasher::defaultConverter): Use character instead of ch.
        (WTF::StringHasher::addCharactersToHash): Eliminated unnecessary local variable.

2013-02-18  Alexey Proskuryakov  <ap@apple.com>

        Make HexNumber functions return 8-bit strings
        https://bugs.webkit.org/show_bug.cgi?id=110152

        Reviewed by Michael Saboff.

        * wtf/HexNumber.h:
        (Internal):
        (WTF::Internal::hexDigitsForMode):
        (WTF::appendByteAsHex):
        (WTF::placeByteAsHexCompressIfPossible):
        (WTF::placeByteAsHex):
        (WTF::appendUnsignedAsHex):
        (WTF::appendUnsignedAsHexFixedSize):
        Use LChar everywhere.

2013-02-18  Benjamin Poulain  <bpoulain@apple.com>

        Remove Vector::dataSlot(), it has no implementation
        https://bugs.webkit.org/show_bug.cgi?id=109999

        Reviewed by Andreas Kling.

        VectorBufferBase does not implement any function bufferSlot().
        The file only compiles because that part of the template is never
        instantiated.

        * wtf/Vector.h:

2013-02-18  Laszlo Gombos  <l.gombos@samsung.com>

        Move ENABLE macros for WebCore out from Platform.h
        https://bugs.webkit.org/show_bug.cgi?id=105735

        Unreviewed, build fix when NETSCAPE_PLUGIN_API is disabled.

        Enable ENABLE_PLUGIN_PACKAGE_SIMPLE_HASH even if
        NETSCAPE_PLUGIN_API is disabled (Qt, Efl, GTK, WX ports).

        * wtf/FeatureDefines.h:

2013-02-18  Balazs Kilvady  <kilvadyb@homejinni.com>

        MIPS DFG implementation.
        https://bugs.webkit.org/show_bug.cgi?id=101328

        Reviewed by Oliver Hunt.

        DFG implementation for MIPS.

        * wtf/Platform.h:

2013-02-18  Zan Dobersek  <zdobersek@igalia.com>

        Stop placing std::isfinite and std::signbit inside the global scope
        https://bugs.webkit.org/show_bug.cgi?id=109817

        Reviewed by Darin Adler.

        Prefix calls to the isfinite and signbit methods with std:: as the two
        methods are no longer being imported into the global scope.

        On Solaris and OpenBSD platforms or when using Visual C++ the two methods
        are now defined (as incompatibility workarounds) inside the std namespace.

        * wtf/DateMath.cpp:
        (WTF::timeClip):
        * wtf/DecimalNumber.h:
        (WTF::DecimalNumber::DecimalNumber):
        * wtf/MathExtras.h:
        (std):
        (std::isfinite):
        (std::signbit):
        (lrint):
        (wtf_pow):
        (decomposeDouble):
        * wtf/MediaTime.cpp:
        (WTF::MediaTime::createWithFloat):
        (WTF::MediaTime::createWithDouble):
        * wtf/dtoa.cpp:
        (WTF::dtoa):

2013-02-18  Laszlo Gombos  <l.gombos@samsung.com>

        Move ENABLE macros for WebCore out from Platform.h
        https://bugs.webkit.org/show_bug.cgi?id=105735

        Reviewed by Darin Adler and Benjamin Poulain.

        Introduce FeatureDefines.h by combining the existing rules from
        Platform.h and adding new rules for all the ENABLE flags that are
        listed in the FeatureFlags wiki.

        The new rules are not used at the moment by any ports
        as the port specific build systems already define these flags
        so the !defined() guard will prevent redefinition of the macros.

        * GNUmakefile.list.am: Add FeatureDefines.h.
        * WTF.gypi: Ditto.
        * WTF.pro: Ditto.
        * WTF.vcproj/WTF.vcproj: Ditto.
        * WTF.xcodeproj/project.pbxproj: Ditto.
        * wtf/CMakeLists.txt: Ditto.
        * wtf/FeatureDefines.h: Added.
        * wtf/Platform.h: Move macro definitions to FeatureDefines.h.

2013-02-16  Darin Adler  <darin@apple.com>

        Remove redundant use of inline keyword in StringHasher.h
        https://bugs.webkit.org/show_bug.cgi?id=110036

        Reviewed by Geoffrey Garen.

        I have some other improvements for StringHasher.h, but wanted to get the simplest ones
        out of the way first.

        * wtf/StringHasher.h: Remove inline keyword on functions inside the class definition,
        since functions defined inside the class are automatically inline.

2013-02-15  Martin Robinson  <mrobinson@igalia.com>

        [GTK] Spread the gyp build files throughout the tree
        https://bugs.webkit.org/show_bug.cgi?id=109960

        Reviewed by Dirk Pranke.

        * WTF.gyp/WTFGTK.gyp: Renamed from Source/WebKit/gtk/gyp/WTF.gyp.

2013-02-15  Anders Carlsson  <andersca@apple.com>

        Add HashMap::isValidKey and HashSet::isValidValue
        https://bugs.webkit.org/show_bug.cgi?id=109977

        Reviewed by Sam Weinig and Darin Adler.

        Add helper functions for determining whether keys are valid, i.e. if
        they are _not_ empty or deleted according to the hash traits.

        * wtf/HashMap.h:
        * wtf/HashSet.h:

2013-02-15  Laszlo Gombos  <l.gombos@samsung.com>

        Remove support for RVCT version less than 4.0
        https://bugs.webkit.org/show_bug.cgi?id=109390

        The 4.0 version of the RVCT compiler was 
        released in 2008. 
        
        Remove support for version older then 4.0 of RVCT, 
        and keep the support for newer RVCT versions.

        Reviewed by Zoltan Herczeg.

        * WTF.gypi: Remove StringExtras.cpp.
        * WTF.vcproj/WTF.vcproj: Remove StringExtras.cpp.
        * WTF.vcxproj/WTF.vcxproj: Remove StringExtras.cpp.
        * WTF.vcxproj/WTF.vcxproj.filters: Remove StringExtras.cpp.
        * WTF.xcodeproj/project.pbxproj: Remove StringExtras.cpp.
        * wtf/CMakeLists.txt: Remove StringExtras.cpp.
        * wtf/Compiler.h: Remove tests for RVCT_VERSION_AT_LEAST(3, 0, 0, 0).
